

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2.Objects.NotificationPermissionRequest
    ( 

-- * Exported types
    NotificationPermissionRequest(..)       ,
    IsNotificationPermissionRequest         ,
    toNotificationPermissionRequest         ,
    noNotificationPermissionRequest         ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2.Interfaces.PermissionRequest as WebKit2.PermissionRequest

-- | Memory-managed wrapper type.
newtype NotificationPermissionRequest = NotificationPermissionRequest (ManagedPtr NotificationPermissionRequest)
foreign import ccall "webkit_notification_permission_request_get_type"
    c_webkit_notification_permission_request_get_type :: IO GType

instance GObject NotificationPermissionRequest where
    gobjectType = c_webkit_notification_permission_request_get_type
    

-- | Type class for types which can be safely cast to `NotificationPermissionRequest`, for instance with `toNotificationPermissionRequest`.
class (GObject o, O.IsDescendantOf NotificationPermissionRequest o) => IsNotificationPermissionRequest o
instance (GObject o, O.IsDescendantOf NotificationPermissionRequest o) => IsNotificationPermissionRequest o

instance O.HasParentTypes NotificationPermissionRequest
type instance O.ParentTypes NotificationPermissionRequest = '[GObject.Object.Object, WebKit2.PermissionRequest.PermissionRequest]

-- | Cast to `NotificationPermissionRequest`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toNotificationPermissionRequest :: (MonadIO m, IsNotificationPermissionRequest o) => o -> m NotificationPermissionRequest
toNotificationPermissionRequest = liftIO . unsafeCastTo NotificationPermissionRequest

-- | A convenience alias for `Nothing` :: `Maybe` `NotificationPermissionRequest`.
noNotificationPermissionRequest :: Maybe NotificationPermissionRequest
noNotificationPermissionRequest = Nothing

#if ENABLE_OVERLOADING
type family ResolveNotificationPermissionRequestMethod (t :: Symbol) (o :: *) :: * where
    ResolveNotificationPermissionRequestMethod "allow" o = WebKit2.PermissionRequest.PermissionRequestAllowMethodInfo
    ResolveNotificationPermissionRequestMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveNotificationPermissionRequestMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveNotificationPermissionRequestMethod "deny" o = WebKit2.PermissionRequest.PermissionRequestDenyMethodInfo
    ResolveNotificationPermissionRequestMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveNotificationPermissionRequestMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveNotificationPermissionRequestMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveNotificationPermissionRequestMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveNotificationPermissionRequestMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveNotificationPermissionRequestMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveNotificationPermissionRequestMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveNotificationPermissionRequestMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveNotificationPermissionRequestMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveNotificationPermissionRequestMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveNotificationPermissionRequestMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveNotificationPermissionRequestMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveNotificationPermissionRequestMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveNotificationPermissionRequestMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveNotificationPermissionRequestMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveNotificationPermissionRequestMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveNotificationPermissionRequestMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveNotificationPermissionRequestMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveNotificationPermissionRequestMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveNotificationPermissionRequestMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveNotificationPermissionRequestMethod t NotificationPermissionRequest, O.MethodInfo info NotificationPermissionRequest p) => OL.IsLabel t (NotificationPermissionRequest -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList NotificationPermissionRequest
type instance O.AttributeList NotificationPermissionRequest = NotificationPermissionRequestAttributeList
type NotificationPermissionRequestAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList NotificationPermissionRequest = NotificationPermissionRequestSignalList
type NotificationPermissionRequestSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


