

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2.Objects.UserMediaPermissionRequest
    ( 

-- * Exported types
    UserMediaPermissionRequest(..)          ,
    IsUserMediaPermissionRequest            ,
    toUserMediaPermissionRequest            ,
    noUserMediaPermissionRequest            ,


 -- * Properties
-- ** isForAudioDevice #attr:isForAudioDevice#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    UserMediaPermissionRequestIsForAudioDevicePropertyInfo,
#endif
    getUserMediaPermissionRequestIsForAudioDevice,
#if ENABLE_OVERLOADING
    userMediaPermissionRequestIsForAudioDevice,
#endif


-- ** isForVideoDevice #attr:isForVideoDevice#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    UserMediaPermissionRequestIsForVideoDevicePropertyInfo,
#endif
    getUserMediaPermissionRequestIsForVideoDevice,
#if ENABLE_OVERLOADING
    userMediaPermissionRequestIsForVideoDevice,
#endif




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2.Interfaces.PermissionRequest as WebKit2.PermissionRequest

-- | Memory-managed wrapper type.
newtype UserMediaPermissionRequest = UserMediaPermissionRequest (ManagedPtr UserMediaPermissionRequest)
foreign import ccall "webkit_user_media_permission_request_get_type"
    c_webkit_user_media_permission_request_get_type :: IO GType

instance GObject UserMediaPermissionRequest where
    gobjectType = c_webkit_user_media_permission_request_get_type
    

-- | Type class for types which can be safely cast to `UserMediaPermissionRequest`, for instance with `toUserMediaPermissionRequest`.
class (GObject o, O.IsDescendantOf UserMediaPermissionRequest o) => IsUserMediaPermissionRequest o
instance (GObject o, O.IsDescendantOf UserMediaPermissionRequest o) => IsUserMediaPermissionRequest o

instance O.HasParentTypes UserMediaPermissionRequest
type instance O.ParentTypes UserMediaPermissionRequest = '[GObject.Object.Object, WebKit2.PermissionRequest.PermissionRequest]

-- | Cast to `UserMediaPermissionRequest`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toUserMediaPermissionRequest :: (MonadIO m, IsUserMediaPermissionRequest o) => o -> m UserMediaPermissionRequest
toUserMediaPermissionRequest = liftIO . unsafeCastTo UserMediaPermissionRequest

-- | A convenience alias for `Nothing` :: `Maybe` `UserMediaPermissionRequest`.
noUserMediaPermissionRequest :: Maybe UserMediaPermissionRequest
noUserMediaPermissionRequest = Nothing

#if ENABLE_OVERLOADING
type family ResolveUserMediaPermissionRequestMethod (t :: Symbol) (o :: *) :: * where
    ResolveUserMediaPermissionRequestMethod "allow" o = WebKit2.PermissionRequest.PermissionRequestAllowMethodInfo
    ResolveUserMediaPermissionRequestMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveUserMediaPermissionRequestMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveUserMediaPermissionRequestMethod "deny" o = WebKit2.PermissionRequest.PermissionRequestDenyMethodInfo
    ResolveUserMediaPermissionRequestMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveUserMediaPermissionRequestMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveUserMediaPermissionRequestMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveUserMediaPermissionRequestMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveUserMediaPermissionRequestMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveUserMediaPermissionRequestMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveUserMediaPermissionRequestMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveUserMediaPermissionRequestMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveUserMediaPermissionRequestMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveUserMediaPermissionRequestMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveUserMediaPermissionRequestMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveUserMediaPermissionRequestMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveUserMediaPermissionRequestMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveUserMediaPermissionRequestMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveUserMediaPermissionRequestMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveUserMediaPermissionRequestMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveUserMediaPermissionRequestMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveUserMediaPermissionRequestMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveUserMediaPermissionRequestMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveUserMediaPermissionRequestMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveUserMediaPermissionRequestMethod t UserMediaPermissionRequest, O.MethodInfo info UserMediaPermissionRequest p) => OL.IsLabel t (UserMediaPermissionRequest -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "is-for-audio-device"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@is-for-audio-device@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' userMediaPermissionRequest #isForAudioDevice
@
-}
getUserMediaPermissionRequestIsForAudioDevice :: (MonadIO m, IsUserMediaPermissionRequest o) => o -> m Bool
getUserMediaPermissionRequestIsForAudioDevice obj = liftIO $ B.Properties.getObjectPropertyBool obj "is-for-audio-device"

#if ENABLE_OVERLOADING
data UserMediaPermissionRequestIsForAudioDevicePropertyInfo
instance AttrInfo UserMediaPermissionRequestIsForAudioDevicePropertyInfo where
    type AttrAllowedOps UserMediaPermissionRequestIsForAudioDevicePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint UserMediaPermissionRequestIsForAudioDevicePropertyInfo = (~) ()
    type AttrBaseTypeConstraint UserMediaPermissionRequestIsForAudioDevicePropertyInfo = IsUserMediaPermissionRequest
    type AttrGetType UserMediaPermissionRequestIsForAudioDevicePropertyInfo = Bool
    type AttrLabel UserMediaPermissionRequestIsForAudioDevicePropertyInfo = "is-for-audio-device"
    type AttrOrigin UserMediaPermissionRequestIsForAudioDevicePropertyInfo = UserMediaPermissionRequest
    attrGet _ = getUserMediaPermissionRequestIsForAudioDevice
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

-- VVV Prop "is-for-video-device"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@is-for-video-device@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' userMediaPermissionRequest #isForVideoDevice
@
-}
getUserMediaPermissionRequestIsForVideoDevice :: (MonadIO m, IsUserMediaPermissionRequest o) => o -> m Bool
getUserMediaPermissionRequestIsForVideoDevice obj = liftIO $ B.Properties.getObjectPropertyBool obj "is-for-video-device"

#if ENABLE_OVERLOADING
data UserMediaPermissionRequestIsForVideoDevicePropertyInfo
instance AttrInfo UserMediaPermissionRequestIsForVideoDevicePropertyInfo where
    type AttrAllowedOps UserMediaPermissionRequestIsForVideoDevicePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint UserMediaPermissionRequestIsForVideoDevicePropertyInfo = (~) ()
    type AttrBaseTypeConstraint UserMediaPermissionRequestIsForVideoDevicePropertyInfo = IsUserMediaPermissionRequest
    type AttrGetType UserMediaPermissionRequestIsForVideoDevicePropertyInfo = Bool
    type AttrLabel UserMediaPermissionRequestIsForVideoDevicePropertyInfo = "is-for-video-device"
    type AttrOrigin UserMediaPermissionRequestIsForVideoDevicePropertyInfo = UserMediaPermissionRequest
    attrGet _ = getUserMediaPermissionRequestIsForVideoDevice
    attrSet _ = undefined
    attrConstruct _ = undefined
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList UserMediaPermissionRequest
type instance O.AttributeList UserMediaPermissionRequest = UserMediaPermissionRequestAttributeList
type UserMediaPermissionRequestAttributeList = ('[ '("isForAudioDevice", UserMediaPermissionRequestIsForAudioDevicePropertyInfo), '("isForVideoDevice", UserMediaPermissionRequestIsForVideoDevicePropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
userMediaPermissionRequestIsForAudioDevice :: AttrLabelProxy "isForAudioDevice"
userMediaPermissionRequestIsForAudioDevice = AttrLabelProxy

userMediaPermissionRequestIsForVideoDevice :: AttrLabelProxy "isForVideoDevice"
userMediaPermissionRequestIsForVideoDevice = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList UserMediaPermissionRequest = UserMediaPermissionRequestSignalList
type UserMediaPermissionRequestSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


