

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.WebKit2.Objects.Settings
    ( 

-- * Exported types
    Settings(..)                            ,
    IsSettings                              ,
    toSettings                              ,
    noSettings                              ,


 -- * Methods
-- ** fontSizeToPixels #method:fontSizeToPixels#

    settingsFontSizeToPixels                ,


-- ** fontSizeToPoints #method:fontSizeToPoints#

    settingsFontSizeToPoints                ,


-- ** getAllowFileAccessFromFileUrls #method:getAllowFileAccessFromFileUrls#

#if ENABLE_OVERLOADING
    SettingsGetAllowFileAccessFromFileUrlsMethodInfo,
#endif
    settingsGetAllowFileAccessFromFileUrls  ,


-- ** getAllowModalDialogs #method:getAllowModalDialogs#

#if ENABLE_OVERLOADING
    SettingsGetAllowModalDialogsMethodInfo  ,
#endif
    settingsGetAllowModalDialogs            ,


-- ** getAllowUniversalAccessFromFileUrls #method:getAllowUniversalAccessFromFileUrls#

#if ENABLE_OVERLOADING
    SettingsGetAllowUniversalAccessFromFileUrlsMethodInfo,
#endif
    settingsGetAllowUniversalAccessFromFileUrls,


-- ** getAutoLoadImages #method:getAutoLoadImages#

#if ENABLE_OVERLOADING
    SettingsGetAutoLoadImagesMethodInfo     ,
#endif
    settingsGetAutoLoadImages               ,


-- ** getCursiveFontFamily #method:getCursiveFontFamily#

#if ENABLE_OVERLOADING
    SettingsGetCursiveFontFamilyMethodInfo  ,
#endif
    settingsGetCursiveFontFamily            ,


-- ** getDefaultCharset #method:getDefaultCharset#

#if ENABLE_OVERLOADING
    SettingsGetDefaultCharsetMethodInfo     ,
#endif
    settingsGetDefaultCharset               ,


-- ** getDefaultFontFamily #method:getDefaultFontFamily#

#if ENABLE_OVERLOADING
    SettingsGetDefaultFontFamilyMethodInfo  ,
#endif
    settingsGetDefaultFontFamily            ,


-- ** getDefaultFontSize #method:getDefaultFontSize#

#if ENABLE_OVERLOADING
    SettingsGetDefaultFontSizeMethodInfo    ,
#endif
    settingsGetDefaultFontSize              ,


-- ** getDefaultMonospaceFontSize #method:getDefaultMonospaceFontSize#

#if ENABLE_OVERLOADING
    SettingsGetDefaultMonospaceFontSizeMethodInfo,
#endif
    settingsGetDefaultMonospaceFontSize     ,


-- ** getDrawCompositingIndicators #method:getDrawCompositingIndicators#

#if ENABLE_OVERLOADING
    SettingsGetDrawCompositingIndicatorsMethodInfo,
#endif
    settingsGetDrawCompositingIndicators    ,


-- ** getEnableAccelerated2dCanvas #method:getEnableAccelerated2dCanvas#

#if ENABLE_OVERLOADING
    SettingsGetEnableAccelerated2dCanvasMethodInfo,
#endif
    settingsGetEnableAccelerated2dCanvas    ,


-- ** getEnableBackForwardNavigationGestures #method:getEnableBackForwardNavigationGestures#

#if ENABLE_OVERLOADING
    SettingsGetEnableBackForwardNavigationGesturesMethodInfo,
#endif
    settingsGetEnableBackForwardNavigationGestures,


-- ** getEnableCaretBrowsing #method:getEnableCaretBrowsing#

#if ENABLE_OVERLOADING
    SettingsGetEnableCaretBrowsingMethodInfo,
#endif
    settingsGetEnableCaretBrowsing          ,


-- ** getEnableDeveloperExtras #method:getEnableDeveloperExtras#

#if ENABLE_OVERLOADING
    SettingsGetEnableDeveloperExtrasMethodInfo,
#endif
    settingsGetEnableDeveloperExtras        ,


-- ** getEnableDnsPrefetching #method:getEnableDnsPrefetching#

#if ENABLE_OVERLOADING
    SettingsGetEnableDnsPrefetchingMethodInfo,
#endif
    settingsGetEnableDnsPrefetching         ,


-- ** getEnableEncryptedMedia #method:getEnableEncryptedMedia#

#if ENABLE_OVERLOADING
    SettingsGetEnableEncryptedMediaMethodInfo,
#endif
    settingsGetEnableEncryptedMedia         ,


-- ** getEnableFrameFlattening #method:getEnableFrameFlattening#

#if ENABLE_OVERLOADING
    SettingsGetEnableFrameFlatteningMethodInfo,
#endif
    settingsGetEnableFrameFlattening        ,


-- ** getEnableFullscreen #method:getEnableFullscreen#

#if ENABLE_OVERLOADING
    SettingsGetEnableFullscreenMethodInfo   ,
#endif
    settingsGetEnableFullscreen             ,


-- ** getEnableHtml5Database #method:getEnableHtml5Database#

#if ENABLE_OVERLOADING
    SettingsGetEnableHtml5DatabaseMethodInfo,
#endif
    settingsGetEnableHtml5Database          ,


-- ** getEnableHtml5LocalStorage #method:getEnableHtml5LocalStorage#

#if ENABLE_OVERLOADING
    SettingsGetEnableHtml5LocalStorageMethodInfo,
#endif
    settingsGetEnableHtml5LocalStorage      ,


-- ** getEnableHyperlinkAuditing #method:getEnableHyperlinkAuditing#

#if ENABLE_OVERLOADING
    SettingsGetEnableHyperlinkAuditingMethodInfo,
#endif
    settingsGetEnableHyperlinkAuditing      ,


-- ** getEnableJava #method:getEnableJava#

#if ENABLE_OVERLOADING
    SettingsGetEnableJavaMethodInfo         ,
#endif
    settingsGetEnableJava                   ,


-- ** getEnableJavascript #method:getEnableJavascript#

#if ENABLE_OVERLOADING
    SettingsGetEnableJavascriptMethodInfo   ,
#endif
    settingsGetEnableJavascript             ,


-- ** getEnableJavascriptMarkup #method:getEnableJavascriptMarkup#

#if ENABLE_OVERLOADING
    SettingsGetEnableJavascriptMarkupMethodInfo,
#endif
    settingsGetEnableJavascriptMarkup       ,


-- ** getEnableMediaCapabilities #method:getEnableMediaCapabilities#

#if ENABLE_OVERLOADING
    SettingsGetEnableMediaCapabilitiesMethodInfo,
#endif
    settingsGetEnableMediaCapabilities      ,


-- ** getEnableMediaStream #method:getEnableMediaStream#

#if ENABLE_OVERLOADING
    SettingsGetEnableMediaStreamMethodInfo  ,
#endif
    settingsGetEnableMediaStream            ,


-- ** getEnableMediasource #method:getEnableMediasource#

#if ENABLE_OVERLOADING
    SettingsGetEnableMediasourceMethodInfo  ,
#endif
    settingsGetEnableMediasource            ,


-- ** getEnableMockCaptureDevices #method:getEnableMockCaptureDevices#

#if ENABLE_OVERLOADING
    SettingsGetEnableMockCaptureDevicesMethodInfo,
#endif
    settingsGetEnableMockCaptureDevices     ,


-- ** getEnableOfflineWebApplicationCache #method:getEnableOfflineWebApplicationCache#

#if ENABLE_OVERLOADING
    SettingsGetEnableOfflineWebApplicationCacheMethodInfo,
#endif
    settingsGetEnableOfflineWebApplicationCache,


-- ** getEnablePageCache #method:getEnablePageCache#

#if ENABLE_OVERLOADING
    SettingsGetEnablePageCacheMethodInfo    ,
#endif
    settingsGetEnablePageCache              ,


-- ** getEnablePlugins #method:getEnablePlugins#

#if ENABLE_OVERLOADING
    SettingsGetEnablePluginsMethodInfo      ,
#endif
    settingsGetEnablePlugins                ,


-- ** getEnablePrivateBrowsing #method:getEnablePrivateBrowsing#

#if ENABLE_OVERLOADING
    SettingsGetEnablePrivateBrowsingMethodInfo,
#endif
    settingsGetEnablePrivateBrowsing        ,


-- ** getEnableResizableTextAreas #method:getEnableResizableTextAreas#

#if ENABLE_OVERLOADING
    SettingsGetEnableResizableTextAreasMethodInfo,
#endif
    settingsGetEnableResizableTextAreas     ,


-- ** getEnableSiteSpecificQuirks #method:getEnableSiteSpecificQuirks#

#if ENABLE_OVERLOADING
    SettingsGetEnableSiteSpecificQuirksMethodInfo,
#endif
    settingsGetEnableSiteSpecificQuirks     ,


-- ** getEnableSmoothScrolling #method:getEnableSmoothScrolling#

#if ENABLE_OVERLOADING
    SettingsGetEnableSmoothScrollingMethodInfo,
#endif
    settingsGetEnableSmoothScrolling        ,


-- ** getEnableSpatialNavigation #method:getEnableSpatialNavigation#

#if ENABLE_OVERLOADING
    SettingsGetEnableSpatialNavigationMethodInfo,
#endif
    settingsGetEnableSpatialNavigation      ,


-- ** getEnableTabsToLinks #method:getEnableTabsToLinks#

#if ENABLE_OVERLOADING
    SettingsGetEnableTabsToLinksMethodInfo  ,
#endif
    settingsGetEnableTabsToLinks            ,


-- ** getEnableWebaudio #method:getEnableWebaudio#

#if ENABLE_OVERLOADING
    SettingsGetEnableWebaudioMethodInfo     ,
#endif
    settingsGetEnableWebaudio               ,


-- ** getEnableWebgl #method:getEnableWebgl#

#if ENABLE_OVERLOADING
    SettingsGetEnableWebglMethodInfo        ,
#endif
    settingsGetEnableWebgl                  ,


-- ** getEnableWriteConsoleMessagesToStdout #method:getEnableWriteConsoleMessagesToStdout#

#if ENABLE_OVERLOADING
    SettingsGetEnableWriteConsoleMessagesToStdoutMethodInfo,
#endif
    settingsGetEnableWriteConsoleMessagesToStdout,


-- ** getEnableXssAuditor #method:getEnableXssAuditor#

#if ENABLE_OVERLOADING
    SettingsGetEnableXssAuditorMethodInfo   ,
#endif
    settingsGetEnableXssAuditor             ,


-- ** getFantasyFontFamily #method:getFantasyFontFamily#

#if ENABLE_OVERLOADING
    SettingsGetFantasyFontFamilyMethodInfo  ,
#endif
    settingsGetFantasyFontFamily            ,


-- ** getHardwareAccelerationPolicy #method:getHardwareAccelerationPolicy#

#if ENABLE_OVERLOADING
    SettingsGetHardwareAccelerationPolicyMethodInfo,
#endif
    settingsGetHardwareAccelerationPolicy   ,


-- ** getJavascriptCanAccessClipboard #method:getJavascriptCanAccessClipboard#

#if ENABLE_OVERLOADING
    SettingsGetJavascriptCanAccessClipboardMethodInfo,
#endif
    settingsGetJavascriptCanAccessClipboard ,


-- ** getJavascriptCanOpenWindowsAutomatically #method:getJavascriptCanOpenWindowsAutomatically#

#if ENABLE_OVERLOADING
    SettingsGetJavascriptCanOpenWindowsAutomaticallyMethodInfo,
#endif
    settingsGetJavascriptCanOpenWindowsAutomatically,


-- ** getLoadIconsIgnoringImageLoadSetting #method:getLoadIconsIgnoringImageLoadSetting#

#if ENABLE_OVERLOADING
    SettingsGetLoadIconsIgnoringImageLoadSettingMethodInfo,
#endif
    settingsGetLoadIconsIgnoringImageLoadSetting,


-- ** getMediaPlaybackAllowsInline #method:getMediaPlaybackAllowsInline#

#if ENABLE_OVERLOADING
    SettingsGetMediaPlaybackAllowsInlineMethodInfo,
#endif
    settingsGetMediaPlaybackAllowsInline    ,


-- ** getMediaPlaybackRequiresUserGesture #method:getMediaPlaybackRequiresUserGesture#

#if ENABLE_OVERLOADING
    SettingsGetMediaPlaybackRequiresUserGestureMethodInfo,
#endif
    settingsGetMediaPlaybackRequiresUserGesture,


-- ** getMinimumFontSize #method:getMinimumFontSize#

#if ENABLE_OVERLOADING
    SettingsGetMinimumFontSizeMethodInfo    ,
#endif
    settingsGetMinimumFontSize              ,


-- ** getMonospaceFontFamily #method:getMonospaceFontFamily#

#if ENABLE_OVERLOADING
    SettingsGetMonospaceFontFamilyMethodInfo,
#endif
    settingsGetMonospaceFontFamily          ,


-- ** getPictographFontFamily #method:getPictographFontFamily#

#if ENABLE_OVERLOADING
    SettingsGetPictographFontFamilyMethodInfo,
#endif
    settingsGetPictographFontFamily         ,


-- ** getPrintBackgrounds #method:getPrintBackgrounds#

#if ENABLE_OVERLOADING
    SettingsGetPrintBackgroundsMethodInfo   ,
#endif
    settingsGetPrintBackgrounds             ,


-- ** getSansSerifFontFamily #method:getSansSerifFontFamily#

#if ENABLE_OVERLOADING
    SettingsGetSansSerifFontFamilyMethodInfo,
#endif
    settingsGetSansSerifFontFamily          ,


-- ** getSerifFontFamily #method:getSerifFontFamily#

#if ENABLE_OVERLOADING
    SettingsGetSerifFontFamilyMethodInfo    ,
#endif
    settingsGetSerifFontFamily              ,


-- ** getUserAgent #method:getUserAgent#

#if ENABLE_OVERLOADING
    SettingsGetUserAgentMethodInfo          ,
#endif
    settingsGetUserAgent                    ,


-- ** getZoomTextOnly #method:getZoomTextOnly#

#if ENABLE_OVERLOADING
    SettingsGetZoomTextOnlyMethodInfo       ,
#endif
    settingsGetZoomTextOnly                 ,


-- ** new #method:new#

    settingsNew                             ,


-- ** setAllowFileAccessFromFileUrls #method:setAllowFileAccessFromFileUrls#

#if ENABLE_OVERLOADING
    SettingsSetAllowFileAccessFromFileUrlsMethodInfo,
#endif
    settingsSetAllowFileAccessFromFileUrls  ,


-- ** setAllowModalDialogs #method:setAllowModalDialogs#

#if ENABLE_OVERLOADING
    SettingsSetAllowModalDialogsMethodInfo  ,
#endif
    settingsSetAllowModalDialogs            ,


-- ** setAllowUniversalAccessFromFileUrls #method:setAllowUniversalAccessFromFileUrls#

#if ENABLE_OVERLOADING
    SettingsSetAllowUniversalAccessFromFileUrlsMethodInfo,
#endif
    settingsSetAllowUniversalAccessFromFileUrls,


-- ** setAutoLoadImages #method:setAutoLoadImages#

#if ENABLE_OVERLOADING
    SettingsSetAutoLoadImagesMethodInfo     ,
#endif
    settingsSetAutoLoadImages               ,


-- ** setCursiveFontFamily #method:setCursiveFontFamily#

#if ENABLE_OVERLOADING
    SettingsSetCursiveFontFamilyMethodInfo  ,
#endif
    settingsSetCursiveFontFamily            ,


-- ** setDefaultCharset #method:setDefaultCharset#

#if ENABLE_OVERLOADING
    SettingsSetDefaultCharsetMethodInfo     ,
#endif
    settingsSetDefaultCharset               ,


-- ** setDefaultFontFamily #method:setDefaultFontFamily#

#if ENABLE_OVERLOADING
    SettingsSetDefaultFontFamilyMethodInfo  ,
#endif
    settingsSetDefaultFontFamily            ,


-- ** setDefaultFontSize #method:setDefaultFontSize#

#if ENABLE_OVERLOADING
    SettingsSetDefaultFontSizeMethodInfo    ,
#endif
    settingsSetDefaultFontSize              ,


-- ** setDefaultMonospaceFontSize #method:setDefaultMonospaceFontSize#

#if ENABLE_OVERLOADING
    SettingsSetDefaultMonospaceFontSizeMethodInfo,
#endif
    settingsSetDefaultMonospaceFontSize     ,


-- ** setDrawCompositingIndicators #method:setDrawCompositingIndicators#

#if ENABLE_OVERLOADING
    SettingsSetDrawCompositingIndicatorsMethodInfo,
#endif
    settingsSetDrawCompositingIndicators    ,


-- ** setEnableAccelerated2dCanvas #method:setEnableAccelerated2dCanvas#

#if ENABLE_OVERLOADING
    SettingsSetEnableAccelerated2dCanvasMethodInfo,
#endif
    settingsSetEnableAccelerated2dCanvas    ,


-- ** setEnableBackForwardNavigationGestures #method:setEnableBackForwardNavigationGestures#

#if ENABLE_OVERLOADING
    SettingsSetEnableBackForwardNavigationGesturesMethodInfo,
#endif
    settingsSetEnableBackForwardNavigationGestures,


-- ** setEnableCaretBrowsing #method:setEnableCaretBrowsing#

#if ENABLE_OVERLOADING
    SettingsSetEnableCaretBrowsingMethodInfo,
#endif
    settingsSetEnableCaretBrowsing          ,


-- ** setEnableDeveloperExtras #method:setEnableDeveloperExtras#

#if ENABLE_OVERLOADING
    SettingsSetEnableDeveloperExtrasMethodInfo,
#endif
    settingsSetEnableDeveloperExtras        ,


-- ** setEnableDnsPrefetching #method:setEnableDnsPrefetching#

#if ENABLE_OVERLOADING
    SettingsSetEnableDnsPrefetchingMethodInfo,
#endif
    settingsSetEnableDnsPrefetching         ,


-- ** setEnableEncryptedMedia #method:setEnableEncryptedMedia#

#if ENABLE_OVERLOADING
    SettingsSetEnableEncryptedMediaMethodInfo,
#endif
    settingsSetEnableEncryptedMedia         ,


-- ** setEnableFrameFlattening #method:setEnableFrameFlattening#

#if ENABLE_OVERLOADING
    SettingsSetEnableFrameFlatteningMethodInfo,
#endif
    settingsSetEnableFrameFlattening        ,


-- ** setEnableFullscreen #method:setEnableFullscreen#

#if ENABLE_OVERLOADING
    SettingsSetEnableFullscreenMethodInfo   ,
#endif
    settingsSetEnableFullscreen             ,


-- ** setEnableHtml5Database #method:setEnableHtml5Database#

#if ENABLE_OVERLOADING
    SettingsSetEnableHtml5DatabaseMethodInfo,
#endif
    settingsSetEnableHtml5Database          ,


-- ** setEnableHtml5LocalStorage #method:setEnableHtml5LocalStorage#

#if ENABLE_OVERLOADING
    SettingsSetEnableHtml5LocalStorageMethodInfo,
#endif
    settingsSetEnableHtml5LocalStorage      ,


-- ** setEnableHyperlinkAuditing #method:setEnableHyperlinkAuditing#

#if ENABLE_OVERLOADING
    SettingsSetEnableHyperlinkAuditingMethodInfo,
#endif
    settingsSetEnableHyperlinkAuditing      ,


-- ** setEnableJava #method:setEnableJava#

#if ENABLE_OVERLOADING
    SettingsSetEnableJavaMethodInfo         ,
#endif
    settingsSetEnableJava                   ,


-- ** setEnableJavascript #method:setEnableJavascript#

#if ENABLE_OVERLOADING
    SettingsSetEnableJavascriptMethodInfo   ,
#endif
    settingsSetEnableJavascript             ,


-- ** setEnableJavascriptMarkup #method:setEnableJavascriptMarkup#

#if ENABLE_OVERLOADING
    SettingsSetEnableJavascriptMarkupMethodInfo,
#endif
    settingsSetEnableJavascriptMarkup       ,


-- ** setEnableMediaCapabilities #method:setEnableMediaCapabilities#

#if ENABLE_OVERLOADING
    SettingsSetEnableMediaCapabilitiesMethodInfo,
#endif
    settingsSetEnableMediaCapabilities      ,


-- ** setEnableMediaStream #method:setEnableMediaStream#

#if ENABLE_OVERLOADING
    SettingsSetEnableMediaStreamMethodInfo  ,
#endif
    settingsSetEnableMediaStream            ,


-- ** setEnableMediasource #method:setEnableMediasource#

#if ENABLE_OVERLOADING
    SettingsSetEnableMediasourceMethodInfo  ,
#endif
    settingsSetEnableMediasource            ,


-- ** setEnableMockCaptureDevices #method:setEnableMockCaptureDevices#

#if ENABLE_OVERLOADING
    SettingsSetEnableMockCaptureDevicesMethodInfo,
#endif
    settingsSetEnableMockCaptureDevices     ,


-- ** setEnableOfflineWebApplicationCache #method:setEnableOfflineWebApplicationCache#

#if ENABLE_OVERLOADING
    SettingsSetEnableOfflineWebApplicationCacheMethodInfo,
#endif
    settingsSetEnableOfflineWebApplicationCache,


-- ** setEnablePageCache #method:setEnablePageCache#

#if ENABLE_OVERLOADING
    SettingsSetEnablePageCacheMethodInfo    ,
#endif
    settingsSetEnablePageCache              ,


-- ** setEnablePlugins #method:setEnablePlugins#

#if ENABLE_OVERLOADING
    SettingsSetEnablePluginsMethodInfo      ,
#endif
    settingsSetEnablePlugins                ,


-- ** setEnablePrivateBrowsing #method:setEnablePrivateBrowsing#

#if ENABLE_OVERLOADING
    SettingsSetEnablePrivateBrowsingMethodInfo,
#endif
    settingsSetEnablePrivateBrowsing        ,


-- ** setEnableResizableTextAreas #method:setEnableResizableTextAreas#

#if ENABLE_OVERLOADING
    SettingsSetEnableResizableTextAreasMethodInfo,
#endif
    settingsSetEnableResizableTextAreas     ,


-- ** setEnableSiteSpecificQuirks #method:setEnableSiteSpecificQuirks#

#if ENABLE_OVERLOADING
    SettingsSetEnableSiteSpecificQuirksMethodInfo,
#endif
    settingsSetEnableSiteSpecificQuirks     ,


-- ** setEnableSmoothScrolling #method:setEnableSmoothScrolling#

#if ENABLE_OVERLOADING
    SettingsSetEnableSmoothScrollingMethodInfo,
#endif
    settingsSetEnableSmoothScrolling        ,


-- ** setEnableSpatialNavigation #method:setEnableSpatialNavigation#

#if ENABLE_OVERLOADING
    SettingsSetEnableSpatialNavigationMethodInfo,
#endif
    settingsSetEnableSpatialNavigation      ,


-- ** setEnableTabsToLinks #method:setEnableTabsToLinks#

#if ENABLE_OVERLOADING
    SettingsSetEnableTabsToLinksMethodInfo  ,
#endif
    settingsSetEnableTabsToLinks            ,


-- ** setEnableWebaudio #method:setEnableWebaudio#

#if ENABLE_OVERLOADING
    SettingsSetEnableWebaudioMethodInfo     ,
#endif
    settingsSetEnableWebaudio               ,


-- ** setEnableWebgl #method:setEnableWebgl#

#if ENABLE_OVERLOADING
    SettingsSetEnableWebglMethodInfo        ,
#endif
    settingsSetEnableWebgl                  ,


-- ** setEnableWriteConsoleMessagesToStdout #method:setEnableWriteConsoleMessagesToStdout#

#if ENABLE_OVERLOADING
    SettingsSetEnableWriteConsoleMessagesToStdoutMethodInfo,
#endif
    settingsSetEnableWriteConsoleMessagesToStdout,


-- ** setEnableXssAuditor #method:setEnableXssAuditor#

#if ENABLE_OVERLOADING
    SettingsSetEnableXssAuditorMethodInfo   ,
#endif
    settingsSetEnableXssAuditor             ,


-- ** setFantasyFontFamily #method:setFantasyFontFamily#

#if ENABLE_OVERLOADING
    SettingsSetFantasyFontFamilyMethodInfo  ,
#endif
    settingsSetFantasyFontFamily            ,


-- ** setHardwareAccelerationPolicy #method:setHardwareAccelerationPolicy#

#if ENABLE_OVERLOADING
    SettingsSetHardwareAccelerationPolicyMethodInfo,
#endif
    settingsSetHardwareAccelerationPolicy   ,


-- ** setJavascriptCanAccessClipboard #method:setJavascriptCanAccessClipboard#

#if ENABLE_OVERLOADING
    SettingsSetJavascriptCanAccessClipboardMethodInfo,
#endif
    settingsSetJavascriptCanAccessClipboard ,


-- ** setJavascriptCanOpenWindowsAutomatically #method:setJavascriptCanOpenWindowsAutomatically#

#if ENABLE_OVERLOADING
    SettingsSetJavascriptCanOpenWindowsAutomaticallyMethodInfo,
#endif
    settingsSetJavascriptCanOpenWindowsAutomatically,


-- ** setLoadIconsIgnoringImageLoadSetting #method:setLoadIconsIgnoringImageLoadSetting#

#if ENABLE_OVERLOADING
    SettingsSetLoadIconsIgnoringImageLoadSettingMethodInfo,
#endif
    settingsSetLoadIconsIgnoringImageLoadSetting,


-- ** setMediaPlaybackAllowsInline #method:setMediaPlaybackAllowsInline#

#if ENABLE_OVERLOADING
    SettingsSetMediaPlaybackAllowsInlineMethodInfo,
#endif
    settingsSetMediaPlaybackAllowsInline    ,


-- ** setMediaPlaybackRequiresUserGesture #method:setMediaPlaybackRequiresUserGesture#

#if ENABLE_OVERLOADING
    SettingsSetMediaPlaybackRequiresUserGestureMethodInfo,
#endif
    settingsSetMediaPlaybackRequiresUserGesture,


-- ** setMinimumFontSize #method:setMinimumFontSize#

#if ENABLE_OVERLOADING
    SettingsSetMinimumFontSizeMethodInfo    ,
#endif
    settingsSetMinimumFontSize              ,


-- ** setMonospaceFontFamily #method:setMonospaceFontFamily#

#if ENABLE_OVERLOADING
    SettingsSetMonospaceFontFamilyMethodInfo,
#endif
    settingsSetMonospaceFontFamily          ,


-- ** setPictographFontFamily #method:setPictographFontFamily#

#if ENABLE_OVERLOADING
    SettingsSetPictographFontFamilyMethodInfo,
#endif
    settingsSetPictographFontFamily         ,


-- ** setPrintBackgrounds #method:setPrintBackgrounds#

#if ENABLE_OVERLOADING
    SettingsSetPrintBackgroundsMethodInfo   ,
#endif
    settingsSetPrintBackgrounds             ,


-- ** setSansSerifFontFamily #method:setSansSerifFontFamily#

#if ENABLE_OVERLOADING
    SettingsSetSansSerifFontFamilyMethodInfo,
#endif
    settingsSetSansSerifFontFamily          ,


-- ** setSerifFontFamily #method:setSerifFontFamily#

#if ENABLE_OVERLOADING
    SettingsSetSerifFontFamilyMethodInfo    ,
#endif
    settingsSetSerifFontFamily              ,


-- ** setUserAgent #method:setUserAgent#

#if ENABLE_OVERLOADING
    SettingsSetUserAgentMethodInfo          ,
#endif
    settingsSetUserAgent                    ,


-- ** setUserAgentWithApplicationDetails #method:setUserAgentWithApplicationDetails#

#if ENABLE_OVERLOADING
    SettingsSetUserAgentWithApplicationDetailsMethodInfo,
#endif
    settingsSetUserAgentWithApplicationDetails,


-- ** setZoomTextOnly #method:setZoomTextOnly#

#if ENABLE_OVERLOADING
    SettingsSetZoomTextOnlyMethodInfo       ,
#endif
    settingsSetZoomTextOnly                 ,




 -- * Properties
-- ** allowFileAccessFromFileUrls #attr:allowFileAccessFromFileUrls#
{- | Whether file access is allowed from file URLs. By default, when
something is loaded in a 'GI.WebKit2.Objects.WebView.WebView' using a file URI, cross
origin requests to other file resources are not allowed. This
setting allows you to change that behaviour, so that it would be
possible to do a XMLHttpRequest of a local file, for example.

/Since: 2.10/
-}
#if ENABLE_OVERLOADING
    SettingsAllowFileAccessFromFileUrlsPropertyInfo,
#endif
    constructSettingsAllowFileAccessFromFileUrls,
    getSettingsAllowFileAccessFromFileUrls  ,
    setSettingsAllowFileAccessFromFileUrls  ,
#if ENABLE_OVERLOADING
    settingsAllowFileAccessFromFileUrls     ,
#endif


-- ** allowModalDialogs #attr:allowModalDialogs#
{- | Determine whether it\'s allowed to create and run modal dialogs
from a 'GI.WebKit2.Objects.WebView.WebView' through JavaScript with
\<function>window.showModalDialog\<\/function>. If it\'s set to
'False', the associated 'GI.WebKit2.Objects.WebView.WebView' won\'t be able to create
new modal dialogs, so not even the 'GI.WebKit2.Objects.WebView.WebView'::@/create/@
signal will be emitted.
-}
#if ENABLE_OVERLOADING
    SettingsAllowModalDialogsPropertyInfo   ,
#endif
    constructSettingsAllowModalDialogs      ,
    getSettingsAllowModalDialogs            ,
    setSettingsAllowModalDialogs            ,
#if ENABLE_OVERLOADING
    settingsAllowModalDialogs               ,
#endif


-- ** allowUniversalAccessFromFileUrls #attr:allowUniversalAccessFromFileUrls#
{- | Whether or not JavaScript running in the context of a file scheme URL
should be allowed to access content from any origin.  By default, when
something is loaded in a 'GI.WebKit2.Objects.WebView.WebView' using a file scheme URL,
access to the local file system and arbitrary local storage is not
allowed. This setting allows you to change that behaviour, so that
it would be possible to use local storage, for example.

/Since: 2.14/
-}
#if ENABLE_OVERLOADING
    SettingsAllowUniversalAccessFromFileUrlsPropertyInfo,
#endif
    constructSettingsAllowUniversalAccessFromFileUrls,
    getSettingsAllowUniversalAccessFromFileUrls,
    setSettingsAllowUniversalAccessFromFileUrls,
#if ENABLE_OVERLOADING
    settingsAllowUniversalAccessFromFileUrls,
#endif


-- ** autoLoadImages #attr:autoLoadImages#
{- | Determines whether images should be automatically loaded or not.
On devices where network bandwidth is of concern, it might be
useful to turn this property off.
-}
#if ENABLE_OVERLOADING
    SettingsAutoLoadImagesPropertyInfo      ,
#endif
    constructSettingsAutoLoadImages         ,
    getSettingsAutoLoadImages               ,
    setSettingsAutoLoadImages               ,
#if ENABLE_OVERLOADING
    settingsAutoLoadImages                  ,
#endif


-- ** cursiveFontFamily #attr:cursiveFontFamily#
{- | The font family used as the default for content using a cursive font.
-}
#if ENABLE_OVERLOADING
    SettingsCursiveFontFamilyPropertyInfo   ,
#endif
    constructSettingsCursiveFontFamily      ,
    getSettingsCursiveFontFamily            ,
    setSettingsCursiveFontFamily            ,
#if ENABLE_OVERLOADING
    settingsCursiveFontFamily               ,
#endif


-- ** defaultCharset #attr:defaultCharset#
{- | The default text charset used when interpreting content with an unspecified charset.
-}
#if ENABLE_OVERLOADING
    SettingsDefaultCharsetPropertyInfo      ,
#endif
    constructSettingsDefaultCharset         ,
    getSettingsDefaultCharset               ,
    setSettingsDefaultCharset               ,
#if ENABLE_OVERLOADING
    settingsDefaultCharset                  ,
#endif


-- ** defaultFontFamily #attr:defaultFontFamily#
{- | The font family to use as the default for content that does not specify a font.
-}
#if ENABLE_OVERLOADING
    SettingsDefaultFontFamilyPropertyInfo   ,
#endif
    constructSettingsDefaultFontFamily      ,
    getSettingsDefaultFontFamily            ,
    setSettingsDefaultFontFamily            ,
#if ENABLE_OVERLOADING
    settingsDefaultFontFamily               ,
#endif


-- ** defaultFontSize #attr:defaultFontSize#
{- | The default font size in pixels to use for content displayed if
no font size is specified.
-}
#if ENABLE_OVERLOADING
    SettingsDefaultFontSizePropertyInfo     ,
#endif
    constructSettingsDefaultFontSize        ,
    getSettingsDefaultFontSize              ,
    setSettingsDefaultFontSize              ,
#if ENABLE_OVERLOADING
    settingsDefaultFontSize                 ,
#endif


-- ** defaultMonospaceFontSize #attr:defaultMonospaceFontSize#
{- | The default font size in pixels to use for content displayed in
monospace font if no font size is specified.
-}
#if ENABLE_OVERLOADING
    SettingsDefaultMonospaceFontSizePropertyInfo,
#endif
    constructSettingsDefaultMonospaceFontSize,
    getSettingsDefaultMonospaceFontSize     ,
    setSettingsDefaultMonospaceFontSize     ,
#if ENABLE_OVERLOADING
    settingsDefaultMonospaceFontSize        ,
#endif


-- ** drawCompositingIndicators #attr:drawCompositingIndicators#
{- | Whether to draw compositing borders and repaint counters on layers drawn
with accelerated compositing. This is useful for debugging issues related
to web content that is composited with the GPU.
-}
#if ENABLE_OVERLOADING
    SettingsDrawCompositingIndicatorsPropertyInfo,
#endif
    constructSettingsDrawCompositingIndicators,
    getSettingsDrawCompositingIndicators    ,
    setSettingsDrawCompositingIndicators    ,
#if ENABLE_OVERLOADING
    settingsDrawCompositingIndicators       ,
#endif


-- ** enableAccelerated2dCanvas #attr:enableAccelerated2dCanvas#
{- | Enable or disable accelerated 2D canvas. Accelerated 2D canvas is only available
if WebKit was compiled with a version of Cairo including the unstable CairoGL API.
When accelerated 2D canvas is enabled, WebKit may render some 2D canvas content
using hardware accelerated drawing operations.

/Since: 2.2/
-}
#if ENABLE_OVERLOADING
    SettingsEnableAccelerated2dCanvasPropertyInfo,
#endif
    constructSettingsEnableAccelerated2dCanvas,
    getSettingsEnableAccelerated2dCanvas    ,
    setSettingsEnableAccelerated2dCanvas    ,
#if ENABLE_OVERLOADING
    settingsEnableAccelerated2dCanvas       ,
#endif


-- ** enableBackForwardNavigationGestures #attr:enableBackForwardNavigationGestures#
{- | Enable or disable horizontal swipe gesture for back-forward navigation.

/Since: 2.24/
-}
#if ENABLE_OVERLOADING
    SettingsEnableBackForwardNavigationGesturesPropertyInfo,
#endif
    constructSettingsEnableBackForwardNavigationGestures,
    getSettingsEnableBackForwardNavigationGestures,
    setSettingsEnableBackForwardNavigationGestures,
#if ENABLE_OVERLOADING
    settingsEnableBackForwardNavigationGestures,
#endif


-- ** enableCaretBrowsing #attr:enableCaretBrowsing#
{- | Whether to enable accessibility enhanced keyboard navigation.
-}
#if ENABLE_OVERLOADING
    SettingsEnableCaretBrowsingPropertyInfo ,
#endif
    constructSettingsEnableCaretBrowsing    ,
    getSettingsEnableCaretBrowsing          ,
    setSettingsEnableCaretBrowsing          ,
#if ENABLE_OVERLOADING
    settingsEnableCaretBrowsing             ,
#endif


-- ** enableDeveloperExtras #attr:enableDeveloperExtras#
{- | Determines whether or not developer tools, such as the Web Inspector, are enabled.
-}
#if ENABLE_OVERLOADING
    SettingsEnableDeveloperExtrasPropertyInfo,
#endif
    constructSettingsEnableDeveloperExtras  ,
    getSettingsEnableDeveloperExtras        ,
    setSettingsEnableDeveloperExtras        ,
#if ENABLE_OVERLOADING
    settingsEnableDeveloperExtras           ,
#endif


-- ** enableDnsPrefetching #attr:enableDnsPrefetching#
{- | Determines whether or not to prefetch domain names. DNS prefetching attempts
to resolve domain names before a user tries to follow a link.
-}
#if ENABLE_OVERLOADING
    SettingsEnableDnsPrefetchingPropertyInfo,
#endif
    constructSettingsEnableDnsPrefetching   ,
    getSettingsEnableDnsPrefetching         ,
    setSettingsEnableDnsPrefetching         ,
#if ENABLE_OVERLOADING
    settingsEnableDnsPrefetching            ,
#endif


-- ** enableEncryptedMedia #attr:enableEncryptedMedia#
{- | Enable or disable support for Encrypted Media API on pages.
EncryptedMedia is an experimental JavaScript API for playing encrypted media in HTML.
This property will only work as intended if the EncryptedMedia feature is enabled at build time
with the ENABLE_ENCRYPTED_MEDIA flag.

See https:\/\/www.w3.org\/TR\/encrypted-media\/

/Since: 2.20/
-}
#if ENABLE_OVERLOADING
    SettingsEnableEncryptedMediaPropertyInfo,
#endif
    constructSettingsEnableEncryptedMedia   ,
    getSettingsEnableEncryptedMedia         ,
    setSettingsEnableEncryptedMedia         ,
#if ENABLE_OVERLOADING
    settingsEnableEncryptedMedia            ,
#endif


-- ** enableFrameFlattening #attr:enableFrameFlattening#
{- | Whether to enable the frame flattening. With this setting each subframe is expanded
to its contents, which will flatten all the frames to become one scrollable page.
On touch devices scrollable subframes on a page can result in a confusing user experience.
-}
#if ENABLE_OVERLOADING
    SettingsEnableFrameFlatteningPropertyInfo,
#endif
    constructSettingsEnableFrameFlattening  ,
    getSettingsEnableFrameFlattening        ,
    setSettingsEnableFrameFlattening        ,
#if ENABLE_OVERLOADING
    settingsEnableFrameFlattening           ,
#endif


-- ** enableFullscreen #attr:enableFullscreen#
{- | Whether to enable the Javascript Fullscreen API. The API
allows any HTML element to request fullscreen display. See also
the current draft of the spec:
http:\/\/www.w3.org\/TR\/fullscreen\/
-}
#if ENABLE_OVERLOADING
    SettingsEnableFullscreenPropertyInfo    ,
#endif
    constructSettingsEnableFullscreen       ,
    getSettingsEnableFullscreen             ,
    setSettingsEnableFullscreen             ,
#if ENABLE_OVERLOADING
    settingsEnableFullscreen                ,
#endif


-- ** enableHtml5Database #attr:enableHtml5Database#
{- | Whether to enable HTML5 client-side SQL database support. Client-side
SQL database allows web pages to store structured data and be able to
use SQL to manipulate that data asynchronously.

HTML5 database specification is available at
http:\/\/www.w3.org\/TR\/webdatabase\/.
-}
#if ENABLE_OVERLOADING
    SettingsEnableHtml5DatabasePropertyInfo ,
#endif
    constructSettingsEnableHtml5Database    ,
    getSettingsEnableHtml5Database          ,
    setSettingsEnableHtml5Database          ,
#if ENABLE_OVERLOADING
    settingsEnableHtml5Database             ,
#endif


-- ** enableHtml5LocalStorage #attr:enableHtml5LocalStorage#
{- | Whether to enable HTML5 local storage support. Local storage provides
simple synchronous storage access.

HTML5 local storage specification is available at
http:\/\/dev.w3.org\/html5\/webstorage\/.
-}
#if ENABLE_OVERLOADING
    SettingsEnableHtml5LocalStoragePropertyInfo,
#endif
    constructSettingsEnableHtml5LocalStorage,
    getSettingsEnableHtml5LocalStorage      ,
    setSettingsEnableHtml5LocalStorage      ,
#if ENABLE_OVERLOADING
    settingsEnableHtml5LocalStorage         ,
#endif


-- ** enableHyperlinkAuditing #attr:enableHyperlinkAuditing#
{- | Determines whether or not hyperlink auditing is enabled.

The hyperlink auditing specification is available at
http:\/\/www.whatwg.org\/specs\/web-apps\/current-work\/multipage\/links.html@/hyperlink/@-auditing.
-}
#if ENABLE_OVERLOADING
    SettingsEnableHyperlinkAuditingPropertyInfo,
#endif
    constructSettingsEnableHyperlinkAuditing,
    getSettingsEnableHyperlinkAuditing      ,
    setSettingsEnableHyperlinkAuditing      ,
#if ENABLE_OVERLOADING
    settingsEnableHyperlinkAuditing         ,
#endif


-- ** enableJava #attr:enableJava#
{- | Determines whether or not Java is enabled on the page.
-}
#if ENABLE_OVERLOADING
    SettingsEnableJavaPropertyInfo          ,
#endif
    constructSettingsEnableJava             ,
    getSettingsEnableJava                   ,
    setSettingsEnableJava                   ,
#if ENABLE_OVERLOADING
    settingsEnableJava                      ,
#endif


-- ** enableJavascript #attr:enableJavascript#
{- | Determines whether or not JavaScript executes within a page.
-}
#if ENABLE_OVERLOADING
    SettingsEnableJavascriptPropertyInfo    ,
#endif
    constructSettingsEnableJavascript       ,
    getSettingsEnableJavascript             ,
    setSettingsEnableJavascript             ,
#if ENABLE_OVERLOADING
    settingsEnableJavascript                ,
#endif


-- ** enableJavascriptMarkup #attr:enableJavascriptMarkup#
{- | Determines whether or not JavaScript markup is allowed in document. When this setting is disabled,
all JavaScript-related elements and attributes are removed from the document during parsing. Note that
executing JavaScript is still allowed if 'GI.WebKit2.Objects.Settings.Settings':@/enable-javascript/@ is 'True'.

/Since: 2.24/
-}
#if ENABLE_OVERLOADING
    SettingsEnableJavascriptMarkupPropertyInfo,
#endif
    constructSettingsEnableJavascriptMarkup ,
    getSettingsEnableJavascriptMarkup       ,
    setSettingsEnableJavascriptMarkup       ,
#if ENABLE_OVERLOADING
    settingsEnableJavascriptMarkup          ,
#endif


-- ** enableMediaCapabilities #attr:enableMediaCapabilities#
{- | Enable or disable support for MediaCapabilities on pages. This
specification intends to provide APIs to allow websites to make an optimal
decision when picking media content for the user. The APIs will expose
information about the decoding and encoding capabilities for a given format
but also output capabilities to find the best match based on the device’s
display.

See also https:\/\/wicg.github.io\/media-capabilities\/

/Since: 2.22/
-}
#if ENABLE_OVERLOADING
    SettingsEnableMediaCapabilitiesPropertyInfo,
#endif
    constructSettingsEnableMediaCapabilities,
    getSettingsEnableMediaCapabilities      ,
    setSettingsEnableMediaCapabilities      ,
#if ENABLE_OVERLOADING
    settingsEnableMediaCapabilities         ,
#endif


-- ** enableMediaStream #attr:enableMediaStream#
{- | Enable or disable support for MediaStream on pages. MediaStream
is an experimental proposal for allowing web pages to access
audio and video devices for capture.

See also http:\/\/dev.w3.org\/2011\/webrtc\/editor\/getusermedia.html

/Since: 2.4/
-}
#if ENABLE_OVERLOADING
    SettingsEnableMediaStreamPropertyInfo   ,
#endif
    constructSettingsEnableMediaStream      ,
    getSettingsEnableMediaStream            ,
    setSettingsEnableMediaStream            ,
#if ENABLE_OVERLOADING
    settingsEnableMediaStream               ,
#endif


-- ** enableMediasource #attr:enableMediasource#
{- | Enable or disable support for MediaSource on pages. MediaSource
extends HTMLMediaElement to allow JavaScript to generate media
streams for playback.

See also http:\/\/www.w3.org\/TR\/media-source\/

/Since: 2.4/
-}
#if ENABLE_OVERLOADING
    SettingsEnableMediasourcePropertyInfo   ,
#endif
    constructSettingsEnableMediasource      ,
    getSettingsEnableMediasource            ,
    setSettingsEnableMediasource            ,
#if ENABLE_OVERLOADING
    settingsEnableMediasource               ,
#endif


-- ** enableMockCaptureDevices #attr:enableMockCaptureDevices#
{- | Enable or disable the Mock Capture Devices. Those are fake
Microphone and Camera devices to be used as MediaStream
sources.

/Since: 2.24/
-}
#if ENABLE_OVERLOADING
    SettingsEnableMockCaptureDevicesPropertyInfo,
#endif
    constructSettingsEnableMockCaptureDevices,
    getSettingsEnableMockCaptureDevices     ,
    setSettingsEnableMockCaptureDevices     ,
#if ENABLE_OVERLOADING
    settingsEnableMockCaptureDevices        ,
#endif


-- ** enableOfflineWebApplicationCache #attr:enableOfflineWebApplicationCache#
{- | Whether to enable HTML5 offline web application cache support. Offline
web application cache allows web applications to run even when
the user is not connected to the network.

HTML5 offline web application specification is available at
http:\/\/dev.w3.org\/html5\/spec\/offline.html.
-}
#if ENABLE_OVERLOADING
    SettingsEnableOfflineWebApplicationCachePropertyInfo,
#endif
    constructSettingsEnableOfflineWebApplicationCache,
    getSettingsEnableOfflineWebApplicationCache,
    setSettingsEnableOfflineWebApplicationCache,
#if ENABLE_OVERLOADING
    settingsEnableOfflineWebApplicationCache,
#endif


-- ** enablePageCache #attr:enablePageCache#
{- | Enable or disable the page cache. Disabling the page cache is
generally only useful for special circumstances like low-memory
scenarios or special purpose applications like static HTML
viewers. This setting only controls the Page Cache, this cache
is different than the disk-based or memory-based traditional
resource caches, its point is to make going back and forth
between pages much faster. For details about the different types
of caches and their purposes see:
http:\/\/webkit.org\/blog\/427\/webkit-page-cache-i-the-basics\/
-}
#if ENABLE_OVERLOADING
    SettingsEnablePageCachePropertyInfo     ,
#endif
    constructSettingsEnablePageCache        ,
    getSettingsEnablePageCache              ,
    setSettingsEnablePageCache              ,
#if ENABLE_OVERLOADING
    settingsEnablePageCache                 ,
#endif


-- ** enablePlugins #attr:enablePlugins#
{- | Determines whether or not plugins on the page are enabled.
-}
#if ENABLE_OVERLOADING
    SettingsEnablePluginsPropertyInfo       ,
#endif
    constructSettingsEnablePlugins          ,
    getSettingsEnablePlugins                ,
    setSettingsEnablePlugins                ,
#if ENABLE_OVERLOADING
    settingsEnablePlugins                   ,
#endif


-- ** enablePrivateBrowsing #attr:enablePrivateBrowsing#
{- | Determines whether or not private browsing is enabled. Private browsing
will disable history, cache and form auto-fill for any pages visited.
-}
#if ENABLE_OVERLOADING
    SettingsEnablePrivateBrowsingPropertyInfo,
#endif
    constructSettingsEnablePrivateBrowsing  ,
    getSettingsEnablePrivateBrowsing        ,
    setSettingsEnablePrivateBrowsing        ,
#if ENABLE_OVERLOADING
    settingsEnablePrivateBrowsing           ,
#endif


-- ** enableResizableTextAreas #attr:enableResizableTextAreas#
{- | Determines whether or not text areas can be resized.
-}
#if ENABLE_OVERLOADING
    SettingsEnableResizableTextAreasPropertyInfo,
#endif
    constructSettingsEnableResizableTextAreas,
    getSettingsEnableResizableTextAreas     ,
    setSettingsEnableResizableTextAreas     ,
#if ENABLE_OVERLOADING
    settingsEnableResizableTextAreas        ,
#endif


-- ** enableSiteSpecificQuirks #attr:enableSiteSpecificQuirks#
{- | Whether to turn on site-specific quirks. Turning this on will
tell WebKit to use some site-specific workarounds for
better web compatibility. For example, older versions of
MediaWiki will incorrectly send to WebKit a CSS file with KHTML
workarounds. By turning on site-specific quirks, WebKit will
special-case this and other cases to make some specific sites work.
-}
#if ENABLE_OVERLOADING
    SettingsEnableSiteSpecificQuirksPropertyInfo,
#endif
    constructSettingsEnableSiteSpecificQuirks,
    getSettingsEnableSiteSpecificQuirks     ,
    setSettingsEnableSiteSpecificQuirks     ,
#if ENABLE_OVERLOADING
    settingsEnableSiteSpecificQuirks        ,
#endif


-- ** enableSmoothScrolling #attr:enableSmoothScrolling#
{- | Enable or disable smooth scrolling.
-}
#if ENABLE_OVERLOADING
    SettingsEnableSmoothScrollingPropertyInfo,
#endif
    constructSettingsEnableSmoothScrolling  ,
    getSettingsEnableSmoothScrolling        ,
    setSettingsEnableSmoothScrolling        ,
#if ENABLE_OVERLOADING
    settingsEnableSmoothScrolling           ,
#endif


-- ** enableSpatialNavigation #attr:enableSpatialNavigation#
{- | Whether to enable Spatial Navigation. This feature consists in the ability
to navigate between focusable elements in a Web page, such as hyperlinks
and form controls, by using Left, Right, Up and Down arrow keys.
For example, if an user presses the Right key, heuristics determine whether
there is an element they might be trying to reach towards the right, and if
there are multiple elements, which element they probably wants.

/Since: 2.4/
-}
#if ENABLE_OVERLOADING
    SettingsEnableSpatialNavigationPropertyInfo,
#endif
    constructSettingsEnableSpatialNavigation,
    getSettingsEnableSpatialNavigation      ,
    setSettingsEnableSpatialNavigation      ,
#if ENABLE_OVERLOADING
    settingsEnableSpatialNavigation         ,
#endif


-- ** enableTabsToLinks #attr:enableTabsToLinks#
{- | Determines whether the tab key cycles through the elements on the page.
When this setting is enabled, users will be able to focus the next element
in the page by pressing the tab key. If the selected element is editable,
then pressing tab key will insert the tab character.
-}
#if ENABLE_OVERLOADING
    SettingsEnableTabsToLinksPropertyInfo   ,
#endif
    constructSettingsEnableTabsToLinks      ,
    getSettingsEnableTabsToLinks            ,
    setSettingsEnableTabsToLinks            ,
#if ENABLE_OVERLOADING
    settingsEnableTabsToLinks               ,
#endif


-- ** enableWebaudio #attr:enableWebaudio#
{- | Enable or disable support for WebAudio on pages. WebAudio is an
experimental proposal for allowing web pages to generate Audio
WAVE data from JavaScript. The standard is currently a
work-in-progress by the W3C Audio Working Group.

See also https:\/\/dvcs.w3.org\/hg\/audio\/raw-file\/tip\/webaudio\/specification.html
-}
#if ENABLE_OVERLOADING
    SettingsEnableWebaudioPropertyInfo      ,
#endif
    constructSettingsEnableWebaudio         ,
    getSettingsEnableWebaudio               ,
    setSettingsEnableWebaudio               ,
#if ENABLE_OVERLOADING
    settingsEnableWebaudio                  ,
#endif


-- ** enableWebgl #attr:enableWebgl#
{- | Enable or disable support for WebGL on pages. WebGL is an experimental
proposal for allowing web pages to use OpenGL ES-like calls directly. The
standard is currently a work-in-progress by the Khronos Group.
-}
#if ENABLE_OVERLOADING
    SettingsEnableWebglPropertyInfo         ,
#endif
    constructSettingsEnableWebgl            ,
    getSettingsEnableWebgl                  ,
    setSettingsEnableWebgl                  ,
#if ENABLE_OVERLOADING
    settingsEnableWebgl                     ,
#endif


-- ** enableWriteConsoleMessagesToStdout #attr:enableWriteConsoleMessagesToStdout#
{- | Enable or disable writing console messages to stdout. These are messages
sent to the console with console.log and related methods.

/Since: 2.2/
-}
#if ENABLE_OVERLOADING
    SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo,
#endif
    constructSettingsEnableWriteConsoleMessagesToStdout,
    getSettingsEnableWriteConsoleMessagesToStdout,
    setSettingsEnableWriteConsoleMessagesToStdout,
#if ENABLE_OVERLOADING
    settingsEnableWriteConsoleMessagesToStdout,
#endif


-- ** enableXssAuditor #attr:enableXssAuditor#
{- | Whether to enable the XSS auditor. This feature filters some kinds of
reflective XSS attacks on vulnerable web sites.
-}
#if ENABLE_OVERLOADING
    SettingsEnableXssAuditorPropertyInfo    ,
#endif
    constructSettingsEnableXssAuditor       ,
    getSettingsEnableXssAuditor             ,
    setSettingsEnableXssAuditor             ,
#if ENABLE_OVERLOADING
    settingsEnableXssAuditor                ,
#endif


-- ** fantasyFontFamily #attr:fantasyFontFamily#
{- | The font family used as the default for content using a fantasy font.
-}
#if ENABLE_OVERLOADING
    SettingsFantasyFontFamilyPropertyInfo   ,
#endif
    constructSettingsFantasyFontFamily      ,
    getSettingsFantasyFontFamily            ,
    setSettingsFantasyFontFamily            ,
#if ENABLE_OVERLOADING
    settingsFantasyFontFamily               ,
#endif


-- ** hardwareAccelerationPolicy #attr:hardwareAccelerationPolicy#
{- | The 'GI.WebKit2.Enums.HardwareAccelerationPolicy' to decide how to enable and disable
hardware acceleration. The default value 'GI.WebKit2.Enums.HardwareAccelerationPolicyOnDemand'
enables the hardware acceleration when the web contents request it, disabling it again
when no longer needed. It\'s possible to enforce hardware acceleration to be always enabled
by using 'GI.WebKit2.Enums.HardwareAccelerationPolicyAlways'. And it\'s also possible to disable it
completely using 'GI.WebKit2.Enums.HardwareAccelerationPolicyNever'. Note that disabling hardware
acceleration might cause some websites to not render correctly or consume more CPU.

Note that changing this setting might not be possible if hardware acceleration is not
supported by the hardware or the system. In that case you can get the value to know the
actual policy being used, but changing the setting will not have any effect.

/Since: 2.16/
-}
#if ENABLE_OVERLOADING
    SettingsHardwareAccelerationPolicyPropertyInfo,
#endif
    constructSettingsHardwareAccelerationPolicy,
    getSettingsHardwareAccelerationPolicy   ,
    setSettingsHardwareAccelerationPolicy   ,
#if ENABLE_OVERLOADING
    settingsHardwareAccelerationPolicy      ,
#endif


-- ** javascriptCanAccessClipboard #attr:javascriptCanAccessClipboard#
{- | Whether JavaScript can access the clipboard. The default value is 'False'. If
set to 'True', document.@/execCommand()/@ allows cut, copy and paste commands.
-}
#if ENABLE_OVERLOADING
    SettingsJavascriptCanAccessClipboardPropertyInfo,
#endif
    constructSettingsJavascriptCanAccessClipboard,
    getSettingsJavascriptCanAccessClipboard ,
    setSettingsJavascriptCanAccessClipboard ,
#if ENABLE_OVERLOADING
    settingsJavascriptCanAccessClipboard    ,
#endif


-- ** javascriptCanOpenWindowsAutomatically #attr:javascriptCanOpenWindowsAutomatically#
{- | Whether JavaScript can open popup windows automatically without user
intervention.
-}
#if ENABLE_OVERLOADING
    SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo,
#endif
    constructSettingsJavascriptCanOpenWindowsAutomatically,
    getSettingsJavascriptCanOpenWindowsAutomatically,
    setSettingsJavascriptCanOpenWindowsAutomatically,
#if ENABLE_OVERLOADING
    settingsJavascriptCanOpenWindowsAutomatically,
#endif


-- ** loadIconsIgnoringImageLoadSetting #attr:loadIconsIgnoringImageLoadSetting#
{- | Determines whether a site can load favicons irrespective
of the value of 'GI.WebKit2.Objects.Settings.Settings':@/auto-load-images/@.
-}
#if ENABLE_OVERLOADING
    SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo,
#endif
    constructSettingsLoadIconsIgnoringImageLoadSetting,
    getSettingsLoadIconsIgnoringImageLoadSetting,
    setSettingsLoadIconsIgnoringImageLoadSetting,
#if ENABLE_OVERLOADING
    settingsLoadIconsIgnoringImageLoadSetting,
#endif


-- ** mediaPlaybackAllowsInline #attr:mediaPlaybackAllowsInline#
{- | Whether media playback is full-screen only or inline playback is allowed.
This is 'True' by default, so media playback can be inline. Setting it to
'False' allows specifying that media playback should be always fullscreen.
-}
#if ENABLE_OVERLOADING
    SettingsMediaPlaybackAllowsInlinePropertyInfo,
#endif
    constructSettingsMediaPlaybackAllowsInline,
    getSettingsMediaPlaybackAllowsInline    ,
    setSettingsMediaPlaybackAllowsInline    ,
#if ENABLE_OVERLOADING
    settingsMediaPlaybackAllowsInline       ,
#endif


-- ** mediaPlaybackRequiresUserGesture #attr:mediaPlaybackRequiresUserGesture#
{- | Whether a user gesture (such as clicking the play button)
would be required to start media playback or load media. This is off
by default, so media playback could start automatically.
Setting it on requires a gesture by the user to start playback, or to
load the media.
-}
#if ENABLE_OVERLOADING
    SettingsMediaPlaybackRequiresUserGesturePropertyInfo,
#endif
    constructSettingsMediaPlaybackRequiresUserGesture,
    getSettingsMediaPlaybackRequiresUserGesture,
    setSettingsMediaPlaybackRequiresUserGesture,
#if ENABLE_OVERLOADING
    settingsMediaPlaybackRequiresUserGesture,
#endif


-- ** minimumFontSize #attr:minimumFontSize#
{- | The minimum font size in pixels used to display text. This setting
controls the absolute smallest size. Values other than 0 can
potentially break page layouts.
-}
#if ENABLE_OVERLOADING
    SettingsMinimumFontSizePropertyInfo     ,
#endif
    constructSettingsMinimumFontSize        ,
    getSettingsMinimumFontSize              ,
    setSettingsMinimumFontSize              ,
#if ENABLE_OVERLOADING
    settingsMinimumFontSize                 ,
#endif


-- ** monospaceFontFamily #attr:monospaceFontFamily#
{- | The font family used as the default for content using a monospace font.
-}
#if ENABLE_OVERLOADING
    SettingsMonospaceFontFamilyPropertyInfo ,
#endif
    constructSettingsMonospaceFontFamily    ,
    getSettingsMonospaceFontFamily          ,
    setSettingsMonospaceFontFamily          ,
#if ENABLE_OVERLOADING
    settingsMonospaceFontFamily             ,
#endif


-- ** pictographFontFamily #attr:pictographFontFamily#
{- | The font family used as the default for content using a pictograph font.
-}
#if ENABLE_OVERLOADING
    SettingsPictographFontFamilyPropertyInfo,
#endif
    constructSettingsPictographFontFamily   ,
    getSettingsPictographFontFamily         ,
    setSettingsPictographFontFamily         ,
#if ENABLE_OVERLOADING
    settingsPictographFontFamily            ,
#endif


-- ** printBackgrounds #attr:printBackgrounds#
{- | Whether background images should be drawn during printing.
-}
#if ENABLE_OVERLOADING
    SettingsPrintBackgroundsPropertyInfo    ,
#endif
    constructSettingsPrintBackgrounds       ,
    getSettingsPrintBackgrounds             ,
    setSettingsPrintBackgrounds             ,
#if ENABLE_OVERLOADING
    settingsPrintBackgrounds                ,
#endif


-- ** sansSerifFontFamily #attr:sansSerifFontFamily#
{- | The font family used as the default for content using a sans-serif font.
-}
#if ENABLE_OVERLOADING
    SettingsSansSerifFontFamilyPropertyInfo ,
#endif
    constructSettingsSansSerifFontFamily    ,
    getSettingsSansSerifFontFamily          ,
    setSettingsSansSerifFontFamily          ,
#if ENABLE_OVERLOADING
    settingsSansSerifFontFamily             ,
#endif


-- ** serifFontFamily #attr:serifFontFamily#
{- | The font family used as the default for content using a serif font.
-}
#if ENABLE_OVERLOADING
    SettingsSerifFontFamilyPropertyInfo     ,
#endif
    constructSettingsSerifFontFamily        ,
    getSettingsSerifFontFamily              ,
    setSettingsSerifFontFamily              ,
#if ENABLE_OVERLOADING
    settingsSerifFontFamily                 ,
#endif


-- ** userAgent #attr:userAgent#
{- | The user-agent string used by WebKit. Unusual user-agent strings may cause web
content to render incorrectly or fail to run, as many web pages are written to
parse the user-agent strings of only the most popular browsers. Therefore, it\'s
typically better to not completely override the standard user-agent, but to use
'GI.WebKit2.Objects.Settings.settingsSetUserAgentWithApplicationDetails' instead.

If this property is set to the empty string or 'Nothing', it will revert to the standard
user-agent.
-}
#if ENABLE_OVERLOADING
    SettingsUserAgentPropertyInfo           ,
#endif
    clearSettingsUserAgent                  ,
    constructSettingsUserAgent              ,
    getSettingsUserAgent                    ,
    setSettingsUserAgent                    ,
#if ENABLE_OVERLOADING
    settingsUserAgent                       ,
#endif


-- ** zoomTextOnly #attr:zoomTextOnly#
{- | Whether 'GI.WebKit2.Objects.WebView.WebView':@/zoom-level/@ affects only the
text of the page or all the contents. Other contents containing text
like form controls will be also affected by zoom factor when
this property is enabled.
-}
#if ENABLE_OVERLOADING
    SettingsZoomTextOnlyPropertyInfo        ,
#endif
    constructSettingsZoomTextOnly           ,
    getSettingsZoomTextOnly                 ,
    setSettingsZoomTextOnly                 ,
#if ENABLE_OVERLOADING
    settingsZoomTextOnly                    ,
#endif




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import {-# SOURCE #-} qualified GI.WebKit2.Enums as WebKit2.Enums

-- | Memory-managed wrapper type.
newtype Settings = Settings (ManagedPtr Settings)
foreign import ccall "webkit_settings_get_type"
    c_webkit_settings_get_type :: IO GType

instance GObject Settings where
    gobjectType = c_webkit_settings_get_type
    

-- | Type class for types which can be safely cast to `Settings`, for instance with `toSettings`.
class (GObject o, O.IsDescendantOf Settings o) => IsSettings o
instance (GObject o, O.IsDescendantOf Settings o) => IsSettings o

instance O.HasParentTypes Settings
type instance O.ParentTypes Settings = '[GObject.Object.Object]

-- | Cast to `Settings`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toSettings :: (MonadIO m, IsSettings o) => o -> m Settings
toSettings = liftIO . unsafeCastTo Settings

-- | A convenience alias for `Nothing` :: `Maybe` `Settings`.
noSettings :: Maybe Settings
noSettings = Nothing

#if ENABLE_OVERLOADING
type family ResolveSettingsMethod (t :: Symbol) (o :: *) :: * where
    ResolveSettingsMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveSettingsMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveSettingsMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveSettingsMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveSettingsMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveSettingsMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveSettingsMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveSettingsMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveSettingsMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveSettingsMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveSettingsMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveSettingsMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveSettingsMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveSettingsMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveSettingsMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveSettingsMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveSettingsMethod "getAllowFileAccessFromFileUrls" o = SettingsGetAllowFileAccessFromFileUrlsMethodInfo
    ResolveSettingsMethod "getAllowModalDialogs" o = SettingsGetAllowModalDialogsMethodInfo
    ResolveSettingsMethod "getAllowUniversalAccessFromFileUrls" o = SettingsGetAllowUniversalAccessFromFileUrlsMethodInfo
    ResolveSettingsMethod "getAutoLoadImages" o = SettingsGetAutoLoadImagesMethodInfo
    ResolveSettingsMethod "getCursiveFontFamily" o = SettingsGetCursiveFontFamilyMethodInfo
    ResolveSettingsMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveSettingsMethod "getDefaultCharset" o = SettingsGetDefaultCharsetMethodInfo
    ResolveSettingsMethod "getDefaultFontFamily" o = SettingsGetDefaultFontFamilyMethodInfo
    ResolveSettingsMethod "getDefaultFontSize" o = SettingsGetDefaultFontSizeMethodInfo
    ResolveSettingsMethod "getDefaultMonospaceFontSize" o = SettingsGetDefaultMonospaceFontSizeMethodInfo
    ResolveSettingsMethod "getDrawCompositingIndicators" o = SettingsGetDrawCompositingIndicatorsMethodInfo
    ResolveSettingsMethod "getEnableAccelerated2dCanvas" o = SettingsGetEnableAccelerated2dCanvasMethodInfo
    ResolveSettingsMethod "getEnableBackForwardNavigationGestures" o = SettingsGetEnableBackForwardNavigationGesturesMethodInfo
    ResolveSettingsMethod "getEnableCaretBrowsing" o = SettingsGetEnableCaretBrowsingMethodInfo
    ResolveSettingsMethod "getEnableDeveloperExtras" o = SettingsGetEnableDeveloperExtrasMethodInfo
    ResolveSettingsMethod "getEnableDnsPrefetching" o = SettingsGetEnableDnsPrefetchingMethodInfo
    ResolveSettingsMethod "getEnableEncryptedMedia" o = SettingsGetEnableEncryptedMediaMethodInfo
    ResolveSettingsMethod "getEnableFrameFlattening" o = SettingsGetEnableFrameFlatteningMethodInfo
    ResolveSettingsMethod "getEnableFullscreen" o = SettingsGetEnableFullscreenMethodInfo
    ResolveSettingsMethod "getEnableHtml5Database" o = SettingsGetEnableHtml5DatabaseMethodInfo
    ResolveSettingsMethod "getEnableHtml5LocalStorage" o = SettingsGetEnableHtml5LocalStorageMethodInfo
    ResolveSettingsMethod "getEnableHyperlinkAuditing" o = SettingsGetEnableHyperlinkAuditingMethodInfo
    ResolveSettingsMethod "getEnableJava" o = SettingsGetEnableJavaMethodInfo
    ResolveSettingsMethod "getEnableJavascript" o = SettingsGetEnableJavascriptMethodInfo
    ResolveSettingsMethod "getEnableJavascriptMarkup" o = SettingsGetEnableJavascriptMarkupMethodInfo
    ResolveSettingsMethod "getEnableMediaCapabilities" o = SettingsGetEnableMediaCapabilitiesMethodInfo
    ResolveSettingsMethod "getEnableMediaStream" o = SettingsGetEnableMediaStreamMethodInfo
    ResolveSettingsMethod "getEnableMediasource" o = SettingsGetEnableMediasourceMethodInfo
    ResolveSettingsMethod "getEnableMockCaptureDevices" o = SettingsGetEnableMockCaptureDevicesMethodInfo
    ResolveSettingsMethod "getEnableOfflineWebApplicationCache" o = SettingsGetEnableOfflineWebApplicationCacheMethodInfo
    ResolveSettingsMethod "getEnablePageCache" o = SettingsGetEnablePageCacheMethodInfo
    ResolveSettingsMethod "getEnablePlugins" o = SettingsGetEnablePluginsMethodInfo
    ResolveSettingsMethod "getEnablePrivateBrowsing" o = SettingsGetEnablePrivateBrowsingMethodInfo
    ResolveSettingsMethod "getEnableResizableTextAreas" o = SettingsGetEnableResizableTextAreasMethodInfo
    ResolveSettingsMethod "getEnableSiteSpecificQuirks" o = SettingsGetEnableSiteSpecificQuirksMethodInfo
    ResolveSettingsMethod "getEnableSmoothScrolling" o = SettingsGetEnableSmoothScrollingMethodInfo
    ResolveSettingsMethod "getEnableSpatialNavigation" o = SettingsGetEnableSpatialNavigationMethodInfo
    ResolveSettingsMethod "getEnableTabsToLinks" o = SettingsGetEnableTabsToLinksMethodInfo
    ResolveSettingsMethod "getEnableWebaudio" o = SettingsGetEnableWebaudioMethodInfo
    ResolveSettingsMethod "getEnableWebgl" o = SettingsGetEnableWebglMethodInfo
    ResolveSettingsMethod "getEnableWriteConsoleMessagesToStdout" o = SettingsGetEnableWriteConsoleMessagesToStdoutMethodInfo
    ResolveSettingsMethod "getEnableXssAuditor" o = SettingsGetEnableXssAuditorMethodInfo
    ResolveSettingsMethod "getFantasyFontFamily" o = SettingsGetFantasyFontFamilyMethodInfo
    ResolveSettingsMethod "getHardwareAccelerationPolicy" o = SettingsGetHardwareAccelerationPolicyMethodInfo
    ResolveSettingsMethod "getJavascriptCanAccessClipboard" o = SettingsGetJavascriptCanAccessClipboardMethodInfo
    ResolveSettingsMethod "getJavascriptCanOpenWindowsAutomatically" o = SettingsGetJavascriptCanOpenWindowsAutomaticallyMethodInfo
    ResolveSettingsMethod "getLoadIconsIgnoringImageLoadSetting" o = SettingsGetLoadIconsIgnoringImageLoadSettingMethodInfo
    ResolveSettingsMethod "getMediaPlaybackAllowsInline" o = SettingsGetMediaPlaybackAllowsInlineMethodInfo
    ResolveSettingsMethod "getMediaPlaybackRequiresUserGesture" o = SettingsGetMediaPlaybackRequiresUserGestureMethodInfo
    ResolveSettingsMethod "getMinimumFontSize" o = SettingsGetMinimumFontSizeMethodInfo
    ResolveSettingsMethod "getMonospaceFontFamily" o = SettingsGetMonospaceFontFamilyMethodInfo
    ResolveSettingsMethod "getPictographFontFamily" o = SettingsGetPictographFontFamilyMethodInfo
    ResolveSettingsMethod "getPrintBackgrounds" o = SettingsGetPrintBackgroundsMethodInfo
    ResolveSettingsMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveSettingsMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveSettingsMethod "getSansSerifFontFamily" o = SettingsGetSansSerifFontFamilyMethodInfo
    ResolveSettingsMethod "getSerifFontFamily" o = SettingsGetSerifFontFamilyMethodInfo
    ResolveSettingsMethod "getUserAgent" o = SettingsGetUserAgentMethodInfo
    ResolveSettingsMethod "getZoomTextOnly" o = SettingsGetZoomTextOnlyMethodInfo
    ResolveSettingsMethod "setAllowFileAccessFromFileUrls" o = SettingsSetAllowFileAccessFromFileUrlsMethodInfo
    ResolveSettingsMethod "setAllowModalDialogs" o = SettingsSetAllowModalDialogsMethodInfo
    ResolveSettingsMethod "setAllowUniversalAccessFromFileUrls" o = SettingsSetAllowUniversalAccessFromFileUrlsMethodInfo
    ResolveSettingsMethod "setAutoLoadImages" o = SettingsSetAutoLoadImagesMethodInfo
    ResolveSettingsMethod "setCursiveFontFamily" o = SettingsSetCursiveFontFamilyMethodInfo
    ResolveSettingsMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveSettingsMethod "setDefaultCharset" o = SettingsSetDefaultCharsetMethodInfo
    ResolveSettingsMethod "setDefaultFontFamily" o = SettingsSetDefaultFontFamilyMethodInfo
    ResolveSettingsMethod "setDefaultFontSize" o = SettingsSetDefaultFontSizeMethodInfo
    ResolveSettingsMethod "setDefaultMonospaceFontSize" o = SettingsSetDefaultMonospaceFontSizeMethodInfo
    ResolveSettingsMethod "setDrawCompositingIndicators" o = SettingsSetDrawCompositingIndicatorsMethodInfo
    ResolveSettingsMethod "setEnableAccelerated2dCanvas" o = SettingsSetEnableAccelerated2dCanvasMethodInfo
    ResolveSettingsMethod "setEnableBackForwardNavigationGestures" o = SettingsSetEnableBackForwardNavigationGesturesMethodInfo
    ResolveSettingsMethod "setEnableCaretBrowsing" o = SettingsSetEnableCaretBrowsingMethodInfo
    ResolveSettingsMethod "setEnableDeveloperExtras" o = SettingsSetEnableDeveloperExtrasMethodInfo
    ResolveSettingsMethod "setEnableDnsPrefetching" o = SettingsSetEnableDnsPrefetchingMethodInfo
    ResolveSettingsMethod "setEnableEncryptedMedia" o = SettingsSetEnableEncryptedMediaMethodInfo
    ResolveSettingsMethod "setEnableFrameFlattening" o = SettingsSetEnableFrameFlatteningMethodInfo
    ResolveSettingsMethod "setEnableFullscreen" o = SettingsSetEnableFullscreenMethodInfo
    ResolveSettingsMethod "setEnableHtml5Database" o = SettingsSetEnableHtml5DatabaseMethodInfo
    ResolveSettingsMethod "setEnableHtml5LocalStorage" o = SettingsSetEnableHtml5LocalStorageMethodInfo
    ResolveSettingsMethod "setEnableHyperlinkAuditing" o = SettingsSetEnableHyperlinkAuditingMethodInfo
    ResolveSettingsMethod "setEnableJava" o = SettingsSetEnableJavaMethodInfo
    ResolveSettingsMethod "setEnableJavascript" o = SettingsSetEnableJavascriptMethodInfo
    ResolveSettingsMethod "setEnableJavascriptMarkup" o = SettingsSetEnableJavascriptMarkupMethodInfo
    ResolveSettingsMethod "setEnableMediaCapabilities" o = SettingsSetEnableMediaCapabilitiesMethodInfo
    ResolveSettingsMethod "setEnableMediaStream" o = SettingsSetEnableMediaStreamMethodInfo
    ResolveSettingsMethod "setEnableMediasource" o = SettingsSetEnableMediasourceMethodInfo
    ResolveSettingsMethod "setEnableMockCaptureDevices" o = SettingsSetEnableMockCaptureDevicesMethodInfo
    ResolveSettingsMethod "setEnableOfflineWebApplicationCache" o = SettingsSetEnableOfflineWebApplicationCacheMethodInfo
    ResolveSettingsMethod "setEnablePageCache" o = SettingsSetEnablePageCacheMethodInfo
    ResolveSettingsMethod "setEnablePlugins" o = SettingsSetEnablePluginsMethodInfo
    ResolveSettingsMethod "setEnablePrivateBrowsing" o = SettingsSetEnablePrivateBrowsingMethodInfo
    ResolveSettingsMethod "setEnableResizableTextAreas" o = SettingsSetEnableResizableTextAreasMethodInfo
    ResolveSettingsMethod "setEnableSiteSpecificQuirks" o = SettingsSetEnableSiteSpecificQuirksMethodInfo
    ResolveSettingsMethod "setEnableSmoothScrolling" o = SettingsSetEnableSmoothScrollingMethodInfo
    ResolveSettingsMethod "setEnableSpatialNavigation" o = SettingsSetEnableSpatialNavigationMethodInfo
    ResolveSettingsMethod "setEnableTabsToLinks" o = SettingsSetEnableTabsToLinksMethodInfo
    ResolveSettingsMethod "setEnableWebaudio" o = SettingsSetEnableWebaudioMethodInfo
    ResolveSettingsMethod "setEnableWebgl" o = SettingsSetEnableWebglMethodInfo
    ResolveSettingsMethod "setEnableWriteConsoleMessagesToStdout" o = SettingsSetEnableWriteConsoleMessagesToStdoutMethodInfo
    ResolveSettingsMethod "setEnableXssAuditor" o = SettingsSetEnableXssAuditorMethodInfo
    ResolveSettingsMethod "setFantasyFontFamily" o = SettingsSetFantasyFontFamilyMethodInfo
    ResolveSettingsMethod "setHardwareAccelerationPolicy" o = SettingsSetHardwareAccelerationPolicyMethodInfo
    ResolveSettingsMethod "setJavascriptCanAccessClipboard" o = SettingsSetJavascriptCanAccessClipboardMethodInfo
    ResolveSettingsMethod "setJavascriptCanOpenWindowsAutomatically" o = SettingsSetJavascriptCanOpenWindowsAutomaticallyMethodInfo
    ResolveSettingsMethod "setLoadIconsIgnoringImageLoadSetting" o = SettingsSetLoadIconsIgnoringImageLoadSettingMethodInfo
    ResolveSettingsMethod "setMediaPlaybackAllowsInline" o = SettingsSetMediaPlaybackAllowsInlineMethodInfo
    ResolveSettingsMethod "setMediaPlaybackRequiresUserGesture" o = SettingsSetMediaPlaybackRequiresUserGestureMethodInfo
    ResolveSettingsMethod "setMinimumFontSize" o = SettingsSetMinimumFontSizeMethodInfo
    ResolveSettingsMethod "setMonospaceFontFamily" o = SettingsSetMonospaceFontFamilyMethodInfo
    ResolveSettingsMethod "setPictographFontFamily" o = SettingsSetPictographFontFamilyMethodInfo
    ResolveSettingsMethod "setPrintBackgrounds" o = SettingsSetPrintBackgroundsMethodInfo
    ResolveSettingsMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveSettingsMethod "setSansSerifFontFamily" o = SettingsSetSansSerifFontFamilyMethodInfo
    ResolveSettingsMethod "setSerifFontFamily" o = SettingsSetSerifFontFamilyMethodInfo
    ResolveSettingsMethod "setUserAgent" o = SettingsSetUserAgentMethodInfo
    ResolveSettingsMethod "setUserAgentWithApplicationDetails" o = SettingsSetUserAgentWithApplicationDetailsMethodInfo
    ResolveSettingsMethod "setZoomTextOnly" o = SettingsSetZoomTextOnlyMethodInfo
    ResolveSettingsMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveSettingsMethod t Settings, O.MethodInfo info Settings p) => OL.IsLabel t (Settings -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "allow-file-access-from-file-urls"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@allow-file-access-from-file-urls@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #allowFileAccessFromFileUrls
@
-}
getSettingsAllowFileAccessFromFileUrls :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsAllowFileAccessFromFileUrls obj = liftIO $ B.Properties.getObjectPropertyBool obj "allow-file-access-from-file-urls"

{- |
Set the value of the “@allow-file-access-from-file-urls@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #allowFileAccessFromFileUrls 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsAllowFileAccessFromFileUrls :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsAllowFileAccessFromFileUrls obj val = liftIO $ B.Properties.setObjectPropertyBool obj "allow-file-access-from-file-urls" val

{- |
Construct a `GValueConstruct` with valid value for the “@allow-file-access-from-file-urls@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsAllowFileAccessFromFileUrls :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsAllowFileAccessFromFileUrls val = B.Properties.constructObjectPropertyBool "allow-file-access-from-file-urls" val

#if ENABLE_OVERLOADING
data SettingsAllowFileAccessFromFileUrlsPropertyInfo
instance AttrInfo SettingsAllowFileAccessFromFileUrlsPropertyInfo where
    type AttrAllowedOps SettingsAllowFileAccessFromFileUrlsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsAllowFileAccessFromFileUrlsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsAllowFileAccessFromFileUrlsPropertyInfo = IsSettings
    type AttrGetType SettingsAllowFileAccessFromFileUrlsPropertyInfo = Bool
    type AttrLabel SettingsAllowFileAccessFromFileUrlsPropertyInfo = "allow-file-access-from-file-urls"
    type AttrOrigin SettingsAllowFileAccessFromFileUrlsPropertyInfo = Settings
    attrGet _ = getSettingsAllowFileAccessFromFileUrls
    attrSet _ = setSettingsAllowFileAccessFromFileUrls
    attrConstruct _ = constructSettingsAllowFileAccessFromFileUrls
    attrClear _ = undefined
#endif

-- VVV Prop "allow-modal-dialogs"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@allow-modal-dialogs@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #allowModalDialogs
@
-}
getSettingsAllowModalDialogs :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsAllowModalDialogs obj = liftIO $ B.Properties.getObjectPropertyBool obj "allow-modal-dialogs"

{- |
Set the value of the “@allow-modal-dialogs@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #allowModalDialogs 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsAllowModalDialogs :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsAllowModalDialogs obj val = liftIO $ B.Properties.setObjectPropertyBool obj "allow-modal-dialogs" val

{- |
Construct a `GValueConstruct` with valid value for the “@allow-modal-dialogs@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsAllowModalDialogs :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsAllowModalDialogs val = B.Properties.constructObjectPropertyBool "allow-modal-dialogs" val

#if ENABLE_OVERLOADING
data SettingsAllowModalDialogsPropertyInfo
instance AttrInfo SettingsAllowModalDialogsPropertyInfo where
    type AttrAllowedOps SettingsAllowModalDialogsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsAllowModalDialogsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsAllowModalDialogsPropertyInfo = IsSettings
    type AttrGetType SettingsAllowModalDialogsPropertyInfo = Bool
    type AttrLabel SettingsAllowModalDialogsPropertyInfo = "allow-modal-dialogs"
    type AttrOrigin SettingsAllowModalDialogsPropertyInfo = Settings
    attrGet _ = getSettingsAllowModalDialogs
    attrSet _ = setSettingsAllowModalDialogs
    attrConstruct _ = constructSettingsAllowModalDialogs
    attrClear _ = undefined
#endif

-- VVV Prop "allow-universal-access-from-file-urls"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@allow-universal-access-from-file-urls@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #allowUniversalAccessFromFileUrls
@
-}
getSettingsAllowUniversalAccessFromFileUrls :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsAllowUniversalAccessFromFileUrls obj = liftIO $ B.Properties.getObjectPropertyBool obj "allow-universal-access-from-file-urls"

{- |
Set the value of the “@allow-universal-access-from-file-urls@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #allowUniversalAccessFromFileUrls 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsAllowUniversalAccessFromFileUrls :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsAllowUniversalAccessFromFileUrls obj val = liftIO $ B.Properties.setObjectPropertyBool obj "allow-universal-access-from-file-urls" val

{- |
Construct a `GValueConstruct` with valid value for the “@allow-universal-access-from-file-urls@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsAllowUniversalAccessFromFileUrls :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsAllowUniversalAccessFromFileUrls val = B.Properties.constructObjectPropertyBool "allow-universal-access-from-file-urls" val

#if ENABLE_OVERLOADING
data SettingsAllowUniversalAccessFromFileUrlsPropertyInfo
instance AttrInfo SettingsAllowUniversalAccessFromFileUrlsPropertyInfo where
    type AttrAllowedOps SettingsAllowUniversalAccessFromFileUrlsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsAllowUniversalAccessFromFileUrlsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsAllowUniversalAccessFromFileUrlsPropertyInfo = IsSettings
    type AttrGetType SettingsAllowUniversalAccessFromFileUrlsPropertyInfo = Bool
    type AttrLabel SettingsAllowUniversalAccessFromFileUrlsPropertyInfo = "allow-universal-access-from-file-urls"
    type AttrOrigin SettingsAllowUniversalAccessFromFileUrlsPropertyInfo = Settings
    attrGet _ = getSettingsAllowUniversalAccessFromFileUrls
    attrSet _ = setSettingsAllowUniversalAccessFromFileUrls
    attrConstruct _ = constructSettingsAllowUniversalAccessFromFileUrls
    attrClear _ = undefined
#endif

-- VVV Prop "auto-load-images"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@auto-load-images@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #autoLoadImages
@
-}
getSettingsAutoLoadImages :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsAutoLoadImages obj = liftIO $ B.Properties.getObjectPropertyBool obj "auto-load-images"

{- |
Set the value of the “@auto-load-images@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #autoLoadImages 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsAutoLoadImages :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsAutoLoadImages obj val = liftIO $ B.Properties.setObjectPropertyBool obj "auto-load-images" val

{- |
Construct a `GValueConstruct` with valid value for the “@auto-load-images@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsAutoLoadImages :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsAutoLoadImages val = B.Properties.constructObjectPropertyBool "auto-load-images" val

#if ENABLE_OVERLOADING
data SettingsAutoLoadImagesPropertyInfo
instance AttrInfo SettingsAutoLoadImagesPropertyInfo where
    type AttrAllowedOps SettingsAutoLoadImagesPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsAutoLoadImagesPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsAutoLoadImagesPropertyInfo = IsSettings
    type AttrGetType SettingsAutoLoadImagesPropertyInfo = Bool
    type AttrLabel SettingsAutoLoadImagesPropertyInfo = "auto-load-images"
    type AttrOrigin SettingsAutoLoadImagesPropertyInfo = Settings
    attrGet _ = getSettingsAutoLoadImages
    attrSet _ = setSettingsAutoLoadImages
    attrConstruct _ = constructSettingsAutoLoadImages
    attrClear _ = undefined
#endif

-- VVV Prop "cursive-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@cursive-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #cursiveFontFamily
@
-}
getSettingsCursiveFontFamily :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsCursiveFontFamily obj = liftIO $ checkUnexpectedNothing "getSettingsCursiveFontFamily" $ B.Properties.getObjectPropertyString obj "cursive-font-family"

{- |
Set the value of the “@cursive-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #cursiveFontFamily 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsCursiveFontFamily :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsCursiveFontFamily obj val = liftIO $ B.Properties.setObjectPropertyString obj "cursive-font-family" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@cursive-font-family@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsCursiveFontFamily :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsCursiveFontFamily val = B.Properties.constructObjectPropertyString "cursive-font-family" (Just val)

#if ENABLE_OVERLOADING
data SettingsCursiveFontFamilyPropertyInfo
instance AttrInfo SettingsCursiveFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsCursiveFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsCursiveFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsCursiveFontFamilyPropertyInfo = IsSettings
    type AttrGetType SettingsCursiveFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsCursiveFontFamilyPropertyInfo = "cursive-font-family"
    type AttrOrigin SettingsCursiveFontFamilyPropertyInfo = Settings
    attrGet _ = getSettingsCursiveFontFamily
    attrSet _ = setSettingsCursiveFontFamily
    attrConstruct _ = constructSettingsCursiveFontFamily
    attrClear _ = undefined
#endif

-- VVV Prop "default-charset"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@default-charset@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #defaultCharset
@
-}
getSettingsDefaultCharset :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsDefaultCharset obj = liftIO $ checkUnexpectedNothing "getSettingsDefaultCharset" $ B.Properties.getObjectPropertyString obj "default-charset"

{- |
Set the value of the “@default-charset@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #defaultCharset 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsDefaultCharset :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsDefaultCharset obj val = liftIO $ B.Properties.setObjectPropertyString obj "default-charset" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@default-charset@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsDefaultCharset :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsDefaultCharset val = B.Properties.constructObjectPropertyString "default-charset" (Just val)

#if ENABLE_OVERLOADING
data SettingsDefaultCharsetPropertyInfo
instance AttrInfo SettingsDefaultCharsetPropertyInfo where
    type AttrAllowedOps SettingsDefaultCharsetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultCharsetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsDefaultCharsetPropertyInfo = IsSettings
    type AttrGetType SettingsDefaultCharsetPropertyInfo = T.Text
    type AttrLabel SettingsDefaultCharsetPropertyInfo = "default-charset"
    type AttrOrigin SettingsDefaultCharsetPropertyInfo = Settings
    attrGet _ = getSettingsDefaultCharset
    attrSet _ = setSettingsDefaultCharset
    attrConstruct _ = constructSettingsDefaultCharset
    attrClear _ = undefined
#endif

-- VVV Prop "default-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@default-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #defaultFontFamily
@
-}
getSettingsDefaultFontFamily :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsDefaultFontFamily obj = liftIO $ checkUnexpectedNothing "getSettingsDefaultFontFamily" $ B.Properties.getObjectPropertyString obj "default-font-family"

{- |
Set the value of the “@default-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #defaultFontFamily 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsDefaultFontFamily :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsDefaultFontFamily obj val = liftIO $ B.Properties.setObjectPropertyString obj "default-font-family" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@default-font-family@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsDefaultFontFamily :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsDefaultFontFamily val = B.Properties.constructObjectPropertyString "default-font-family" (Just val)

#if ENABLE_OVERLOADING
data SettingsDefaultFontFamilyPropertyInfo
instance AttrInfo SettingsDefaultFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsDefaultFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsDefaultFontFamilyPropertyInfo = IsSettings
    type AttrGetType SettingsDefaultFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsDefaultFontFamilyPropertyInfo = "default-font-family"
    type AttrOrigin SettingsDefaultFontFamilyPropertyInfo = Settings
    attrGet _ = getSettingsDefaultFontFamily
    attrSet _ = setSettingsDefaultFontFamily
    attrConstruct _ = constructSettingsDefaultFontFamily
    attrClear _ = undefined
#endif

-- VVV Prop "default-font-size"
   -- Type: TBasicType TUInt
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@default-font-size@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #defaultFontSize
@
-}
getSettingsDefaultFontSize :: (MonadIO m, IsSettings o) => o -> m Word32
getSettingsDefaultFontSize obj = liftIO $ B.Properties.getObjectPropertyUInt32 obj "default-font-size"

{- |
Set the value of the “@default-font-size@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #defaultFontSize 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsDefaultFontSize :: (MonadIO m, IsSettings o) => o -> Word32 -> m ()
setSettingsDefaultFontSize obj val = liftIO $ B.Properties.setObjectPropertyUInt32 obj "default-font-size" val

{- |
Construct a `GValueConstruct` with valid value for the “@default-font-size@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsDefaultFontSize :: (IsSettings o) => Word32 -> IO (GValueConstruct o)
constructSettingsDefaultFontSize val = B.Properties.constructObjectPropertyUInt32 "default-font-size" val

#if ENABLE_OVERLOADING
data SettingsDefaultFontSizePropertyInfo
instance AttrInfo SettingsDefaultFontSizePropertyInfo where
    type AttrAllowedOps SettingsDefaultFontSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultFontSizePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint SettingsDefaultFontSizePropertyInfo = IsSettings
    type AttrGetType SettingsDefaultFontSizePropertyInfo = Word32
    type AttrLabel SettingsDefaultFontSizePropertyInfo = "default-font-size"
    type AttrOrigin SettingsDefaultFontSizePropertyInfo = Settings
    attrGet _ = getSettingsDefaultFontSize
    attrSet _ = setSettingsDefaultFontSize
    attrConstruct _ = constructSettingsDefaultFontSize
    attrClear _ = undefined
#endif

-- VVV Prop "default-monospace-font-size"
   -- Type: TBasicType TUInt
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@default-monospace-font-size@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #defaultMonospaceFontSize
@
-}
getSettingsDefaultMonospaceFontSize :: (MonadIO m, IsSettings o) => o -> m Word32
getSettingsDefaultMonospaceFontSize obj = liftIO $ B.Properties.getObjectPropertyUInt32 obj "default-monospace-font-size"

{- |
Set the value of the “@default-monospace-font-size@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #defaultMonospaceFontSize 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsDefaultMonospaceFontSize :: (MonadIO m, IsSettings o) => o -> Word32 -> m ()
setSettingsDefaultMonospaceFontSize obj val = liftIO $ B.Properties.setObjectPropertyUInt32 obj "default-monospace-font-size" val

{- |
Construct a `GValueConstruct` with valid value for the “@default-monospace-font-size@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsDefaultMonospaceFontSize :: (IsSettings o) => Word32 -> IO (GValueConstruct o)
constructSettingsDefaultMonospaceFontSize val = B.Properties.constructObjectPropertyUInt32 "default-monospace-font-size" val

#if ENABLE_OVERLOADING
data SettingsDefaultMonospaceFontSizePropertyInfo
instance AttrInfo SettingsDefaultMonospaceFontSizePropertyInfo where
    type AttrAllowedOps SettingsDefaultMonospaceFontSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultMonospaceFontSizePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint SettingsDefaultMonospaceFontSizePropertyInfo = IsSettings
    type AttrGetType SettingsDefaultMonospaceFontSizePropertyInfo = Word32
    type AttrLabel SettingsDefaultMonospaceFontSizePropertyInfo = "default-monospace-font-size"
    type AttrOrigin SettingsDefaultMonospaceFontSizePropertyInfo = Settings
    attrGet _ = getSettingsDefaultMonospaceFontSize
    attrSet _ = setSettingsDefaultMonospaceFontSize
    attrConstruct _ = constructSettingsDefaultMonospaceFontSize
    attrClear _ = undefined
#endif

-- VVV Prop "draw-compositing-indicators"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@draw-compositing-indicators@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #drawCompositingIndicators
@
-}
getSettingsDrawCompositingIndicators :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsDrawCompositingIndicators obj = liftIO $ B.Properties.getObjectPropertyBool obj "draw-compositing-indicators"

{- |
Set the value of the “@draw-compositing-indicators@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #drawCompositingIndicators 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsDrawCompositingIndicators :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsDrawCompositingIndicators obj val = liftIO $ B.Properties.setObjectPropertyBool obj "draw-compositing-indicators" val

{- |
Construct a `GValueConstruct` with valid value for the “@draw-compositing-indicators@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsDrawCompositingIndicators :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsDrawCompositingIndicators val = B.Properties.constructObjectPropertyBool "draw-compositing-indicators" val

#if ENABLE_OVERLOADING
data SettingsDrawCompositingIndicatorsPropertyInfo
instance AttrInfo SettingsDrawCompositingIndicatorsPropertyInfo where
    type AttrAllowedOps SettingsDrawCompositingIndicatorsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDrawCompositingIndicatorsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsDrawCompositingIndicatorsPropertyInfo = IsSettings
    type AttrGetType SettingsDrawCompositingIndicatorsPropertyInfo = Bool
    type AttrLabel SettingsDrawCompositingIndicatorsPropertyInfo = "draw-compositing-indicators"
    type AttrOrigin SettingsDrawCompositingIndicatorsPropertyInfo = Settings
    attrGet _ = getSettingsDrawCompositingIndicators
    attrSet _ = setSettingsDrawCompositingIndicators
    attrConstruct _ = constructSettingsDrawCompositingIndicators
    attrClear _ = undefined
#endif

-- VVV Prop "enable-accelerated-2d-canvas"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-accelerated-2d-canvas@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableAccelerated2dCanvas
@
-}
getSettingsEnableAccelerated2dCanvas :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableAccelerated2dCanvas obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-accelerated-2d-canvas"

{- |
Set the value of the “@enable-accelerated-2d-canvas@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableAccelerated2dCanvas 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableAccelerated2dCanvas :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableAccelerated2dCanvas obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-accelerated-2d-canvas" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-accelerated-2d-canvas@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableAccelerated2dCanvas :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableAccelerated2dCanvas val = B.Properties.constructObjectPropertyBool "enable-accelerated-2d-canvas" val

#if ENABLE_OVERLOADING
data SettingsEnableAccelerated2dCanvasPropertyInfo
instance AttrInfo SettingsEnableAccelerated2dCanvasPropertyInfo where
    type AttrAllowedOps SettingsEnableAccelerated2dCanvasPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableAccelerated2dCanvasPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableAccelerated2dCanvasPropertyInfo = IsSettings
    type AttrGetType SettingsEnableAccelerated2dCanvasPropertyInfo = Bool
    type AttrLabel SettingsEnableAccelerated2dCanvasPropertyInfo = "enable-accelerated-2d-canvas"
    type AttrOrigin SettingsEnableAccelerated2dCanvasPropertyInfo = Settings
    attrGet _ = getSettingsEnableAccelerated2dCanvas
    attrSet _ = setSettingsEnableAccelerated2dCanvas
    attrConstruct _ = constructSettingsEnableAccelerated2dCanvas
    attrClear _ = undefined
#endif

-- VVV Prop "enable-back-forward-navigation-gestures"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-back-forward-navigation-gestures@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableBackForwardNavigationGestures
@
-}
getSettingsEnableBackForwardNavigationGestures :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableBackForwardNavigationGestures obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-back-forward-navigation-gestures"

{- |
Set the value of the “@enable-back-forward-navigation-gestures@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableBackForwardNavigationGestures 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableBackForwardNavigationGestures :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableBackForwardNavigationGestures obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-back-forward-navigation-gestures" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-back-forward-navigation-gestures@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableBackForwardNavigationGestures :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableBackForwardNavigationGestures val = B.Properties.constructObjectPropertyBool "enable-back-forward-navigation-gestures" val

#if ENABLE_OVERLOADING
data SettingsEnableBackForwardNavigationGesturesPropertyInfo
instance AttrInfo SettingsEnableBackForwardNavigationGesturesPropertyInfo where
    type AttrAllowedOps SettingsEnableBackForwardNavigationGesturesPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableBackForwardNavigationGesturesPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableBackForwardNavigationGesturesPropertyInfo = IsSettings
    type AttrGetType SettingsEnableBackForwardNavigationGesturesPropertyInfo = Bool
    type AttrLabel SettingsEnableBackForwardNavigationGesturesPropertyInfo = "enable-back-forward-navigation-gestures"
    type AttrOrigin SettingsEnableBackForwardNavigationGesturesPropertyInfo = Settings
    attrGet _ = getSettingsEnableBackForwardNavigationGestures
    attrSet _ = setSettingsEnableBackForwardNavigationGestures
    attrConstruct _ = constructSettingsEnableBackForwardNavigationGestures
    attrClear _ = undefined
#endif

-- VVV Prop "enable-caret-browsing"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-caret-browsing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableCaretBrowsing
@
-}
getSettingsEnableCaretBrowsing :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableCaretBrowsing obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-caret-browsing"

{- |
Set the value of the “@enable-caret-browsing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableCaretBrowsing 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableCaretBrowsing :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableCaretBrowsing obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-caret-browsing" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-caret-browsing@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableCaretBrowsing :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableCaretBrowsing val = B.Properties.constructObjectPropertyBool "enable-caret-browsing" val

#if ENABLE_OVERLOADING
data SettingsEnableCaretBrowsingPropertyInfo
instance AttrInfo SettingsEnableCaretBrowsingPropertyInfo where
    type AttrAllowedOps SettingsEnableCaretBrowsingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableCaretBrowsingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableCaretBrowsingPropertyInfo = IsSettings
    type AttrGetType SettingsEnableCaretBrowsingPropertyInfo = Bool
    type AttrLabel SettingsEnableCaretBrowsingPropertyInfo = "enable-caret-browsing"
    type AttrOrigin SettingsEnableCaretBrowsingPropertyInfo = Settings
    attrGet _ = getSettingsEnableCaretBrowsing
    attrSet _ = setSettingsEnableCaretBrowsing
    attrConstruct _ = constructSettingsEnableCaretBrowsing
    attrClear _ = undefined
#endif

-- VVV Prop "enable-developer-extras"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-developer-extras@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableDeveloperExtras
@
-}
getSettingsEnableDeveloperExtras :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableDeveloperExtras obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-developer-extras"

{- |
Set the value of the “@enable-developer-extras@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableDeveloperExtras 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableDeveloperExtras :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableDeveloperExtras obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-developer-extras" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-developer-extras@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableDeveloperExtras :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableDeveloperExtras val = B.Properties.constructObjectPropertyBool "enable-developer-extras" val

#if ENABLE_OVERLOADING
data SettingsEnableDeveloperExtrasPropertyInfo
instance AttrInfo SettingsEnableDeveloperExtrasPropertyInfo where
    type AttrAllowedOps SettingsEnableDeveloperExtrasPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableDeveloperExtrasPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableDeveloperExtrasPropertyInfo = IsSettings
    type AttrGetType SettingsEnableDeveloperExtrasPropertyInfo = Bool
    type AttrLabel SettingsEnableDeveloperExtrasPropertyInfo = "enable-developer-extras"
    type AttrOrigin SettingsEnableDeveloperExtrasPropertyInfo = Settings
    attrGet _ = getSettingsEnableDeveloperExtras
    attrSet _ = setSettingsEnableDeveloperExtras
    attrConstruct _ = constructSettingsEnableDeveloperExtras
    attrClear _ = undefined
#endif

-- VVV Prop "enable-dns-prefetching"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-dns-prefetching@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableDnsPrefetching
@
-}
getSettingsEnableDnsPrefetching :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableDnsPrefetching obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-dns-prefetching"

{- |
Set the value of the “@enable-dns-prefetching@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableDnsPrefetching 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableDnsPrefetching :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableDnsPrefetching obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-dns-prefetching" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-dns-prefetching@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableDnsPrefetching :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableDnsPrefetching val = B.Properties.constructObjectPropertyBool "enable-dns-prefetching" val

#if ENABLE_OVERLOADING
data SettingsEnableDnsPrefetchingPropertyInfo
instance AttrInfo SettingsEnableDnsPrefetchingPropertyInfo where
    type AttrAllowedOps SettingsEnableDnsPrefetchingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableDnsPrefetchingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableDnsPrefetchingPropertyInfo = IsSettings
    type AttrGetType SettingsEnableDnsPrefetchingPropertyInfo = Bool
    type AttrLabel SettingsEnableDnsPrefetchingPropertyInfo = "enable-dns-prefetching"
    type AttrOrigin SettingsEnableDnsPrefetchingPropertyInfo = Settings
    attrGet _ = getSettingsEnableDnsPrefetching
    attrSet _ = setSettingsEnableDnsPrefetching
    attrConstruct _ = constructSettingsEnableDnsPrefetching
    attrClear _ = undefined
#endif

-- VVV Prop "enable-encrypted-media"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-encrypted-media@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableEncryptedMedia
@
-}
getSettingsEnableEncryptedMedia :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableEncryptedMedia obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-encrypted-media"

{- |
Set the value of the “@enable-encrypted-media@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableEncryptedMedia 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableEncryptedMedia :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableEncryptedMedia obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-encrypted-media" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-encrypted-media@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableEncryptedMedia :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableEncryptedMedia val = B.Properties.constructObjectPropertyBool "enable-encrypted-media" val

#if ENABLE_OVERLOADING
data SettingsEnableEncryptedMediaPropertyInfo
instance AttrInfo SettingsEnableEncryptedMediaPropertyInfo where
    type AttrAllowedOps SettingsEnableEncryptedMediaPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableEncryptedMediaPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableEncryptedMediaPropertyInfo = IsSettings
    type AttrGetType SettingsEnableEncryptedMediaPropertyInfo = Bool
    type AttrLabel SettingsEnableEncryptedMediaPropertyInfo = "enable-encrypted-media"
    type AttrOrigin SettingsEnableEncryptedMediaPropertyInfo = Settings
    attrGet _ = getSettingsEnableEncryptedMedia
    attrSet _ = setSettingsEnableEncryptedMedia
    attrConstruct _ = constructSettingsEnableEncryptedMedia
    attrClear _ = undefined
#endif

-- VVV Prop "enable-frame-flattening"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-frame-flattening@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableFrameFlattening
@
-}
getSettingsEnableFrameFlattening :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableFrameFlattening obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-frame-flattening"

{- |
Set the value of the “@enable-frame-flattening@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableFrameFlattening 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableFrameFlattening :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableFrameFlattening obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-frame-flattening" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-frame-flattening@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableFrameFlattening :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableFrameFlattening val = B.Properties.constructObjectPropertyBool "enable-frame-flattening" val

#if ENABLE_OVERLOADING
data SettingsEnableFrameFlatteningPropertyInfo
instance AttrInfo SettingsEnableFrameFlatteningPropertyInfo where
    type AttrAllowedOps SettingsEnableFrameFlatteningPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableFrameFlatteningPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableFrameFlatteningPropertyInfo = IsSettings
    type AttrGetType SettingsEnableFrameFlatteningPropertyInfo = Bool
    type AttrLabel SettingsEnableFrameFlatteningPropertyInfo = "enable-frame-flattening"
    type AttrOrigin SettingsEnableFrameFlatteningPropertyInfo = Settings
    attrGet _ = getSettingsEnableFrameFlattening
    attrSet _ = setSettingsEnableFrameFlattening
    attrConstruct _ = constructSettingsEnableFrameFlattening
    attrClear _ = undefined
#endif

-- VVV Prop "enable-fullscreen"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-fullscreen@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableFullscreen
@
-}
getSettingsEnableFullscreen :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableFullscreen obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-fullscreen"

{- |
Set the value of the “@enable-fullscreen@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableFullscreen 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableFullscreen :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableFullscreen obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-fullscreen" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-fullscreen@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableFullscreen :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableFullscreen val = B.Properties.constructObjectPropertyBool "enable-fullscreen" val

#if ENABLE_OVERLOADING
data SettingsEnableFullscreenPropertyInfo
instance AttrInfo SettingsEnableFullscreenPropertyInfo where
    type AttrAllowedOps SettingsEnableFullscreenPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableFullscreenPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableFullscreenPropertyInfo = IsSettings
    type AttrGetType SettingsEnableFullscreenPropertyInfo = Bool
    type AttrLabel SettingsEnableFullscreenPropertyInfo = "enable-fullscreen"
    type AttrOrigin SettingsEnableFullscreenPropertyInfo = Settings
    attrGet _ = getSettingsEnableFullscreen
    attrSet _ = setSettingsEnableFullscreen
    attrConstruct _ = constructSettingsEnableFullscreen
    attrClear _ = undefined
#endif

-- VVV Prop "enable-html5-database"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-html5-database@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableHtml5Database
@
-}
getSettingsEnableHtml5Database :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableHtml5Database obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-html5-database"

{- |
Set the value of the “@enable-html5-database@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableHtml5Database 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableHtml5Database :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableHtml5Database obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-html5-database" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-html5-database@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableHtml5Database :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableHtml5Database val = B.Properties.constructObjectPropertyBool "enable-html5-database" val

#if ENABLE_OVERLOADING
data SettingsEnableHtml5DatabasePropertyInfo
instance AttrInfo SettingsEnableHtml5DatabasePropertyInfo where
    type AttrAllowedOps SettingsEnableHtml5DatabasePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableHtml5DatabasePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableHtml5DatabasePropertyInfo = IsSettings
    type AttrGetType SettingsEnableHtml5DatabasePropertyInfo = Bool
    type AttrLabel SettingsEnableHtml5DatabasePropertyInfo = "enable-html5-database"
    type AttrOrigin SettingsEnableHtml5DatabasePropertyInfo = Settings
    attrGet _ = getSettingsEnableHtml5Database
    attrSet _ = setSettingsEnableHtml5Database
    attrConstruct _ = constructSettingsEnableHtml5Database
    attrClear _ = undefined
#endif

-- VVV Prop "enable-html5-local-storage"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-html5-local-storage@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableHtml5LocalStorage
@
-}
getSettingsEnableHtml5LocalStorage :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableHtml5LocalStorage obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-html5-local-storage"

{- |
Set the value of the “@enable-html5-local-storage@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableHtml5LocalStorage 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableHtml5LocalStorage :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableHtml5LocalStorage obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-html5-local-storage" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-html5-local-storage@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableHtml5LocalStorage :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableHtml5LocalStorage val = B.Properties.constructObjectPropertyBool "enable-html5-local-storage" val

#if ENABLE_OVERLOADING
data SettingsEnableHtml5LocalStoragePropertyInfo
instance AttrInfo SettingsEnableHtml5LocalStoragePropertyInfo where
    type AttrAllowedOps SettingsEnableHtml5LocalStoragePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableHtml5LocalStoragePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableHtml5LocalStoragePropertyInfo = IsSettings
    type AttrGetType SettingsEnableHtml5LocalStoragePropertyInfo = Bool
    type AttrLabel SettingsEnableHtml5LocalStoragePropertyInfo = "enable-html5-local-storage"
    type AttrOrigin SettingsEnableHtml5LocalStoragePropertyInfo = Settings
    attrGet _ = getSettingsEnableHtml5LocalStorage
    attrSet _ = setSettingsEnableHtml5LocalStorage
    attrConstruct _ = constructSettingsEnableHtml5LocalStorage
    attrClear _ = undefined
#endif

-- VVV Prop "enable-hyperlink-auditing"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-hyperlink-auditing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableHyperlinkAuditing
@
-}
getSettingsEnableHyperlinkAuditing :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableHyperlinkAuditing obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-hyperlink-auditing"

{- |
Set the value of the “@enable-hyperlink-auditing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableHyperlinkAuditing 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableHyperlinkAuditing :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableHyperlinkAuditing obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-hyperlink-auditing" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-hyperlink-auditing@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableHyperlinkAuditing :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableHyperlinkAuditing val = B.Properties.constructObjectPropertyBool "enable-hyperlink-auditing" val

#if ENABLE_OVERLOADING
data SettingsEnableHyperlinkAuditingPropertyInfo
instance AttrInfo SettingsEnableHyperlinkAuditingPropertyInfo where
    type AttrAllowedOps SettingsEnableHyperlinkAuditingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableHyperlinkAuditingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableHyperlinkAuditingPropertyInfo = IsSettings
    type AttrGetType SettingsEnableHyperlinkAuditingPropertyInfo = Bool
    type AttrLabel SettingsEnableHyperlinkAuditingPropertyInfo = "enable-hyperlink-auditing"
    type AttrOrigin SettingsEnableHyperlinkAuditingPropertyInfo = Settings
    attrGet _ = getSettingsEnableHyperlinkAuditing
    attrSet _ = setSettingsEnableHyperlinkAuditing
    attrConstruct _ = constructSettingsEnableHyperlinkAuditing
    attrClear _ = undefined
#endif

-- VVV Prop "enable-java"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-java@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableJava
@
-}
getSettingsEnableJava :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableJava obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-java"

{- |
Set the value of the “@enable-java@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableJava 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableJava :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableJava obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-java" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-java@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableJava :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableJava val = B.Properties.constructObjectPropertyBool "enable-java" val

#if ENABLE_OVERLOADING
data SettingsEnableJavaPropertyInfo
instance AttrInfo SettingsEnableJavaPropertyInfo where
    type AttrAllowedOps SettingsEnableJavaPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableJavaPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableJavaPropertyInfo = IsSettings
    type AttrGetType SettingsEnableJavaPropertyInfo = Bool
    type AttrLabel SettingsEnableJavaPropertyInfo = "enable-java"
    type AttrOrigin SettingsEnableJavaPropertyInfo = Settings
    attrGet _ = getSettingsEnableJava
    attrSet _ = setSettingsEnableJava
    attrConstruct _ = constructSettingsEnableJava
    attrClear _ = undefined
#endif

-- VVV Prop "enable-javascript"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-javascript@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableJavascript
@
-}
getSettingsEnableJavascript :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableJavascript obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-javascript"

{- |
Set the value of the “@enable-javascript@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableJavascript 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableJavascript :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableJavascript obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-javascript" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-javascript@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableJavascript :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableJavascript val = B.Properties.constructObjectPropertyBool "enable-javascript" val

#if ENABLE_OVERLOADING
data SettingsEnableJavascriptPropertyInfo
instance AttrInfo SettingsEnableJavascriptPropertyInfo where
    type AttrAllowedOps SettingsEnableJavascriptPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableJavascriptPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableJavascriptPropertyInfo = IsSettings
    type AttrGetType SettingsEnableJavascriptPropertyInfo = Bool
    type AttrLabel SettingsEnableJavascriptPropertyInfo = "enable-javascript"
    type AttrOrigin SettingsEnableJavascriptPropertyInfo = Settings
    attrGet _ = getSettingsEnableJavascript
    attrSet _ = setSettingsEnableJavascript
    attrConstruct _ = constructSettingsEnableJavascript
    attrClear _ = undefined
#endif

-- VVV Prop "enable-javascript-markup"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-javascript-markup@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableJavascriptMarkup
@
-}
getSettingsEnableJavascriptMarkup :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableJavascriptMarkup obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-javascript-markup"

{- |
Set the value of the “@enable-javascript-markup@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableJavascriptMarkup 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableJavascriptMarkup :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableJavascriptMarkup obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-javascript-markup" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-javascript-markup@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableJavascriptMarkup :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableJavascriptMarkup val = B.Properties.constructObjectPropertyBool "enable-javascript-markup" val

#if ENABLE_OVERLOADING
data SettingsEnableJavascriptMarkupPropertyInfo
instance AttrInfo SettingsEnableJavascriptMarkupPropertyInfo where
    type AttrAllowedOps SettingsEnableJavascriptMarkupPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableJavascriptMarkupPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableJavascriptMarkupPropertyInfo = IsSettings
    type AttrGetType SettingsEnableJavascriptMarkupPropertyInfo = Bool
    type AttrLabel SettingsEnableJavascriptMarkupPropertyInfo = "enable-javascript-markup"
    type AttrOrigin SettingsEnableJavascriptMarkupPropertyInfo = Settings
    attrGet _ = getSettingsEnableJavascriptMarkup
    attrSet _ = setSettingsEnableJavascriptMarkup
    attrConstruct _ = constructSettingsEnableJavascriptMarkup
    attrClear _ = undefined
#endif

-- VVV Prop "enable-media-capabilities"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-media-capabilities@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableMediaCapabilities
@
-}
getSettingsEnableMediaCapabilities :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableMediaCapabilities obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-media-capabilities"

{- |
Set the value of the “@enable-media-capabilities@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableMediaCapabilities 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableMediaCapabilities :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableMediaCapabilities obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-media-capabilities" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-media-capabilities@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableMediaCapabilities :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableMediaCapabilities val = B.Properties.constructObjectPropertyBool "enable-media-capabilities" val

#if ENABLE_OVERLOADING
data SettingsEnableMediaCapabilitiesPropertyInfo
instance AttrInfo SettingsEnableMediaCapabilitiesPropertyInfo where
    type AttrAllowedOps SettingsEnableMediaCapabilitiesPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableMediaCapabilitiesPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableMediaCapabilitiesPropertyInfo = IsSettings
    type AttrGetType SettingsEnableMediaCapabilitiesPropertyInfo = Bool
    type AttrLabel SettingsEnableMediaCapabilitiesPropertyInfo = "enable-media-capabilities"
    type AttrOrigin SettingsEnableMediaCapabilitiesPropertyInfo = Settings
    attrGet _ = getSettingsEnableMediaCapabilities
    attrSet _ = setSettingsEnableMediaCapabilities
    attrConstruct _ = constructSettingsEnableMediaCapabilities
    attrClear _ = undefined
#endif

-- VVV Prop "enable-media-stream"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-media-stream@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableMediaStream
@
-}
getSettingsEnableMediaStream :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableMediaStream obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-media-stream"

{- |
Set the value of the “@enable-media-stream@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableMediaStream 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableMediaStream :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableMediaStream obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-media-stream" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-media-stream@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableMediaStream :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableMediaStream val = B.Properties.constructObjectPropertyBool "enable-media-stream" val

#if ENABLE_OVERLOADING
data SettingsEnableMediaStreamPropertyInfo
instance AttrInfo SettingsEnableMediaStreamPropertyInfo where
    type AttrAllowedOps SettingsEnableMediaStreamPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableMediaStreamPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableMediaStreamPropertyInfo = IsSettings
    type AttrGetType SettingsEnableMediaStreamPropertyInfo = Bool
    type AttrLabel SettingsEnableMediaStreamPropertyInfo = "enable-media-stream"
    type AttrOrigin SettingsEnableMediaStreamPropertyInfo = Settings
    attrGet _ = getSettingsEnableMediaStream
    attrSet _ = setSettingsEnableMediaStream
    attrConstruct _ = constructSettingsEnableMediaStream
    attrClear _ = undefined
#endif

-- VVV Prop "enable-mediasource"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-mediasource@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableMediasource
@
-}
getSettingsEnableMediasource :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableMediasource obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-mediasource"

{- |
Set the value of the “@enable-mediasource@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableMediasource 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableMediasource :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableMediasource obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-mediasource" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-mediasource@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableMediasource :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableMediasource val = B.Properties.constructObjectPropertyBool "enable-mediasource" val

#if ENABLE_OVERLOADING
data SettingsEnableMediasourcePropertyInfo
instance AttrInfo SettingsEnableMediasourcePropertyInfo where
    type AttrAllowedOps SettingsEnableMediasourcePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableMediasourcePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableMediasourcePropertyInfo = IsSettings
    type AttrGetType SettingsEnableMediasourcePropertyInfo = Bool
    type AttrLabel SettingsEnableMediasourcePropertyInfo = "enable-mediasource"
    type AttrOrigin SettingsEnableMediasourcePropertyInfo = Settings
    attrGet _ = getSettingsEnableMediasource
    attrSet _ = setSettingsEnableMediasource
    attrConstruct _ = constructSettingsEnableMediasource
    attrClear _ = undefined
#endif

-- VVV Prop "enable-mock-capture-devices"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-mock-capture-devices@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableMockCaptureDevices
@
-}
getSettingsEnableMockCaptureDevices :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableMockCaptureDevices obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-mock-capture-devices"

{- |
Set the value of the “@enable-mock-capture-devices@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableMockCaptureDevices 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableMockCaptureDevices :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableMockCaptureDevices obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-mock-capture-devices" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-mock-capture-devices@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableMockCaptureDevices :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableMockCaptureDevices val = B.Properties.constructObjectPropertyBool "enable-mock-capture-devices" val

#if ENABLE_OVERLOADING
data SettingsEnableMockCaptureDevicesPropertyInfo
instance AttrInfo SettingsEnableMockCaptureDevicesPropertyInfo where
    type AttrAllowedOps SettingsEnableMockCaptureDevicesPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableMockCaptureDevicesPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableMockCaptureDevicesPropertyInfo = IsSettings
    type AttrGetType SettingsEnableMockCaptureDevicesPropertyInfo = Bool
    type AttrLabel SettingsEnableMockCaptureDevicesPropertyInfo = "enable-mock-capture-devices"
    type AttrOrigin SettingsEnableMockCaptureDevicesPropertyInfo = Settings
    attrGet _ = getSettingsEnableMockCaptureDevices
    attrSet _ = setSettingsEnableMockCaptureDevices
    attrConstruct _ = constructSettingsEnableMockCaptureDevices
    attrClear _ = undefined
#endif

-- VVV Prop "enable-offline-web-application-cache"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-offline-web-application-cache@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableOfflineWebApplicationCache
@
-}
getSettingsEnableOfflineWebApplicationCache :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableOfflineWebApplicationCache obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-offline-web-application-cache"

{- |
Set the value of the “@enable-offline-web-application-cache@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableOfflineWebApplicationCache 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableOfflineWebApplicationCache :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableOfflineWebApplicationCache obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-offline-web-application-cache" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-offline-web-application-cache@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableOfflineWebApplicationCache :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableOfflineWebApplicationCache val = B.Properties.constructObjectPropertyBool "enable-offline-web-application-cache" val

#if ENABLE_OVERLOADING
data SettingsEnableOfflineWebApplicationCachePropertyInfo
instance AttrInfo SettingsEnableOfflineWebApplicationCachePropertyInfo where
    type AttrAllowedOps SettingsEnableOfflineWebApplicationCachePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableOfflineWebApplicationCachePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableOfflineWebApplicationCachePropertyInfo = IsSettings
    type AttrGetType SettingsEnableOfflineWebApplicationCachePropertyInfo = Bool
    type AttrLabel SettingsEnableOfflineWebApplicationCachePropertyInfo = "enable-offline-web-application-cache"
    type AttrOrigin SettingsEnableOfflineWebApplicationCachePropertyInfo = Settings
    attrGet _ = getSettingsEnableOfflineWebApplicationCache
    attrSet _ = setSettingsEnableOfflineWebApplicationCache
    attrConstruct _ = constructSettingsEnableOfflineWebApplicationCache
    attrClear _ = undefined
#endif

-- VVV Prop "enable-page-cache"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-page-cache@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enablePageCache
@
-}
getSettingsEnablePageCache :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnablePageCache obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-page-cache"

{- |
Set the value of the “@enable-page-cache@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enablePageCache 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnablePageCache :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnablePageCache obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-page-cache" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-page-cache@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnablePageCache :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnablePageCache val = B.Properties.constructObjectPropertyBool "enable-page-cache" val

#if ENABLE_OVERLOADING
data SettingsEnablePageCachePropertyInfo
instance AttrInfo SettingsEnablePageCachePropertyInfo where
    type AttrAllowedOps SettingsEnablePageCachePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnablePageCachePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnablePageCachePropertyInfo = IsSettings
    type AttrGetType SettingsEnablePageCachePropertyInfo = Bool
    type AttrLabel SettingsEnablePageCachePropertyInfo = "enable-page-cache"
    type AttrOrigin SettingsEnablePageCachePropertyInfo = Settings
    attrGet _ = getSettingsEnablePageCache
    attrSet _ = setSettingsEnablePageCache
    attrConstruct _ = constructSettingsEnablePageCache
    attrClear _ = undefined
#endif

-- VVV Prop "enable-plugins"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-plugins@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enablePlugins
@
-}
getSettingsEnablePlugins :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnablePlugins obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-plugins"

{- |
Set the value of the “@enable-plugins@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enablePlugins 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnablePlugins :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnablePlugins obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-plugins" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-plugins@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnablePlugins :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnablePlugins val = B.Properties.constructObjectPropertyBool "enable-plugins" val

#if ENABLE_OVERLOADING
data SettingsEnablePluginsPropertyInfo
instance AttrInfo SettingsEnablePluginsPropertyInfo where
    type AttrAllowedOps SettingsEnablePluginsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnablePluginsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnablePluginsPropertyInfo = IsSettings
    type AttrGetType SettingsEnablePluginsPropertyInfo = Bool
    type AttrLabel SettingsEnablePluginsPropertyInfo = "enable-plugins"
    type AttrOrigin SettingsEnablePluginsPropertyInfo = Settings
    attrGet _ = getSettingsEnablePlugins
    attrSet _ = setSettingsEnablePlugins
    attrConstruct _ = constructSettingsEnablePlugins
    attrClear _ = undefined
#endif

-- VVV Prop "enable-private-browsing"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-private-browsing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enablePrivateBrowsing
@
-}
getSettingsEnablePrivateBrowsing :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnablePrivateBrowsing obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-private-browsing"

{- |
Set the value of the “@enable-private-browsing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enablePrivateBrowsing 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnablePrivateBrowsing :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnablePrivateBrowsing obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-private-browsing" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-private-browsing@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnablePrivateBrowsing :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnablePrivateBrowsing val = B.Properties.constructObjectPropertyBool "enable-private-browsing" val

#if ENABLE_OVERLOADING
data SettingsEnablePrivateBrowsingPropertyInfo
instance AttrInfo SettingsEnablePrivateBrowsingPropertyInfo where
    type AttrAllowedOps SettingsEnablePrivateBrowsingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnablePrivateBrowsingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnablePrivateBrowsingPropertyInfo = IsSettings
    type AttrGetType SettingsEnablePrivateBrowsingPropertyInfo = Bool
    type AttrLabel SettingsEnablePrivateBrowsingPropertyInfo = "enable-private-browsing"
    type AttrOrigin SettingsEnablePrivateBrowsingPropertyInfo = Settings
    attrGet _ = getSettingsEnablePrivateBrowsing
    attrSet _ = setSettingsEnablePrivateBrowsing
    attrConstruct _ = constructSettingsEnablePrivateBrowsing
    attrClear _ = undefined
#endif

-- VVV Prop "enable-resizable-text-areas"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-resizable-text-areas@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableResizableTextAreas
@
-}
getSettingsEnableResizableTextAreas :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableResizableTextAreas obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-resizable-text-areas"

{- |
Set the value of the “@enable-resizable-text-areas@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableResizableTextAreas 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableResizableTextAreas :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableResizableTextAreas obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-resizable-text-areas" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-resizable-text-areas@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableResizableTextAreas :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableResizableTextAreas val = B.Properties.constructObjectPropertyBool "enable-resizable-text-areas" val

#if ENABLE_OVERLOADING
data SettingsEnableResizableTextAreasPropertyInfo
instance AttrInfo SettingsEnableResizableTextAreasPropertyInfo where
    type AttrAllowedOps SettingsEnableResizableTextAreasPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableResizableTextAreasPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableResizableTextAreasPropertyInfo = IsSettings
    type AttrGetType SettingsEnableResizableTextAreasPropertyInfo = Bool
    type AttrLabel SettingsEnableResizableTextAreasPropertyInfo = "enable-resizable-text-areas"
    type AttrOrigin SettingsEnableResizableTextAreasPropertyInfo = Settings
    attrGet _ = getSettingsEnableResizableTextAreas
    attrSet _ = setSettingsEnableResizableTextAreas
    attrConstruct _ = constructSettingsEnableResizableTextAreas
    attrClear _ = undefined
#endif

-- VVV Prop "enable-site-specific-quirks"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-site-specific-quirks@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableSiteSpecificQuirks
@
-}
getSettingsEnableSiteSpecificQuirks :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableSiteSpecificQuirks obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-site-specific-quirks"

{- |
Set the value of the “@enable-site-specific-quirks@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableSiteSpecificQuirks 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableSiteSpecificQuirks :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableSiteSpecificQuirks obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-site-specific-quirks" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-site-specific-quirks@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableSiteSpecificQuirks :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableSiteSpecificQuirks val = B.Properties.constructObjectPropertyBool "enable-site-specific-quirks" val

#if ENABLE_OVERLOADING
data SettingsEnableSiteSpecificQuirksPropertyInfo
instance AttrInfo SettingsEnableSiteSpecificQuirksPropertyInfo where
    type AttrAllowedOps SettingsEnableSiteSpecificQuirksPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableSiteSpecificQuirksPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableSiteSpecificQuirksPropertyInfo = IsSettings
    type AttrGetType SettingsEnableSiteSpecificQuirksPropertyInfo = Bool
    type AttrLabel SettingsEnableSiteSpecificQuirksPropertyInfo = "enable-site-specific-quirks"
    type AttrOrigin SettingsEnableSiteSpecificQuirksPropertyInfo = Settings
    attrGet _ = getSettingsEnableSiteSpecificQuirks
    attrSet _ = setSettingsEnableSiteSpecificQuirks
    attrConstruct _ = constructSettingsEnableSiteSpecificQuirks
    attrClear _ = undefined
#endif

-- VVV Prop "enable-smooth-scrolling"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-smooth-scrolling@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableSmoothScrolling
@
-}
getSettingsEnableSmoothScrolling :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableSmoothScrolling obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-smooth-scrolling"

{- |
Set the value of the “@enable-smooth-scrolling@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableSmoothScrolling 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableSmoothScrolling :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableSmoothScrolling obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-smooth-scrolling" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-smooth-scrolling@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableSmoothScrolling :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableSmoothScrolling val = B.Properties.constructObjectPropertyBool "enable-smooth-scrolling" val

#if ENABLE_OVERLOADING
data SettingsEnableSmoothScrollingPropertyInfo
instance AttrInfo SettingsEnableSmoothScrollingPropertyInfo where
    type AttrAllowedOps SettingsEnableSmoothScrollingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableSmoothScrollingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableSmoothScrollingPropertyInfo = IsSettings
    type AttrGetType SettingsEnableSmoothScrollingPropertyInfo = Bool
    type AttrLabel SettingsEnableSmoothScrollingPropertyInfo = "enable-smooth-scrolling"
    type AttrOrigin SettingsEnableSmoothScrollingPropertyInfo = Settings
    attrGet _ = getSettingsEnableSmoothScrolling
    attrSet _ = setSettingsEnableSmoothScrolling
    attrConstruct _ = constructSettingsEnableSmoothScrolling
    attrClear _ = undefined
#endif

-- VVV Prop "enable-spatial-navigation"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-spatial-navigation@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableSpatialNavigation
@
-}
getSettingsEnableSpatialNavigation :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableSpatialNavigation obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-spatial-navigation"

{- |
Set the value of the “@enable-spatial-navigation@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableSpatialNavigation 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableSpatialNavigation :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableSpatialNavigation obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-spatial-navigation" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-spatial-navigation@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableSpatialNavigation :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableSpatialNavigation val = B.Properties.constructObjectPropertyBool "enable-spatial-navigation" val

#if ENABLE_OVERLOADING
data SettingsEnableSpatialNavigationPropertyInfo
instance AttrInfo SettingsEnableSpatialNavigationPropertyInfo where
    type AttrAllowedOps SettingsEnableSpatialNavigationPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableSpatialNavigationPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableSpatialNavigationPropertyInfo = IsSettings
    type AttrGetType SettingsEnableSpatialNavigationPropertyInfo = Bool
    type AttrLabel SettingsEnableSpatialNavigationPropertyInfo = "enable-spatial-navigation"
    type AttrOrigin SettingsEnableSpatialNavigationPropertyInfo = Settings
    attrGet _ = getSettingsEnableSpatialNavigation
    attrSet _ = setSettingsEnableSpatialNavigation
    attrConstruct _ = constructSettingsEnableSpatialNavigation
    attrClear _ = undefined
#endif

-- VVV Prop "enable-tabs-to-links"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-tabs-to-links@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableTabsToLinks
@
-}
getSettingsEnableTabsToLinks :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableTabsToLinks obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-tabs-to-links"

{- |
Set the value of the “@enable-tabs-to-links@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableTabsToLinks 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableTabsToLinks :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableTabsToLinks obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-tabs-to-links" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-tabs-to-links@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableTabsToLinks :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableTabsToLinks val = B.Properties.constructObjectPropertyBool "enable-tabs-to-links" val

#if ENABLE_OVERLOADING
data SettingsEnableTabsToLinksPropertyInfo
instance AttrInfo SettingsEnableTabsToLinksPropertyInfo where
    type AttrAllowedOps SettingsEnableTabsToLinksPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableTabsToLinksPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableTabsToLinksPropertyInfo = IsSettings
    type AttrGetType SettingsEnableTabsToLinksPropertyInfo = Bool
    type AttrLabel SettingsEnableTabsToLinksPropertyInfo = "enable-tabs-to-links"
    type AttrOrigin SettingsEnableTabsToLinksPropertyInfo = Settings
    attrGet _ = getSettingsEnableTabsToLinks
    attrSet _ = setSettingsEnableTabsToLinks
    attrConstruct _ = constructSettingsEnableTabsToLinks
    attrClear _ = undefined
#endif

-- VVV Prop "enable-webaudio"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-webaudio@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableWebaudio
@
-}
getSettingsEnableWebaudio :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableWebaudio obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-webaudio"

{- |
Set the value of the “@enable-webaudio@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableWebaudio 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableWebaudio :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableWebaudio obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-webaudio" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-webaudio@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableWebaudio :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableWebaudio val = B.Properties.constructObjectPropertyBool "enable-webaudio" val

#if ENABLE_OVERLOADING
data SettingsEnableWebaudioPropertyInfo
instance AttrInfo SettingsEnableWebaudioPropertyInfo where
    type AttrAllowedOps SettingsEnableWebaudioPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableWebaudioPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableWebaudioPropertyInfo = IsSettings
    type AttrGetType SettingsEnableWebaudioPropertyInfo = Bool
    type AttrLabel SettingsEnableWebaudioPropertyInfo = "enable-webaudio"
    type AttrOrigin SettingsEnableWebaudioPropertyInfo = Settings
    attrGet _ = getSettingsEnableWebaudio
    attrSet _ = setSettingsEnableWebaudio
    attrConstruct _ = constructSettingsEnableWebaudio
    attrClear _ = undefined
#endif

-- VVV Prop "enable-webgl"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-webgl@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableWebgl
@
-}
getSettingsEnableWebgl :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableWebgl obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-webgl"

{- |
Set the value of the “@enable-webgl@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableWebgl 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableWebgl :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableWebgl obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-webgl" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-webgl@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableWebgl :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableWebgl val = B.Properties.constructObjectPropertyBool "enable-webgl" val

#if ENABLE_OVERLOADING
data SettingsEnableWebglPropertyInfo
instance AttrInfo SettingsEnableWebglPropertyInfo where
    type AttrAllowedOps SettingsEnableWebglPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableWebglPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableWebglPropertyInfo = IsSettings
    type AttrGetType SettingsEnableWebglPropertyInfo = Bool
    type AttrLabel SettingsEnableWebglPropertyInfo = "enable-webgl"
    type AttrOrigin SettingsEnableWebglPropertyInfo = Settings
    attrGet _ = getSettingsEnableWebgl
    attrSet _ = setSettingsEnableWebgl
    attrConstruct _ = constructSettingsEnableWebgl
    attrClear _ = undefined
#endif

-- VVV Prop "enable-write-console-messages-to-stdout"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-write-console-messages-to-stdout@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableWriteConsoleMessagesToStdout
@
-}
getSettingsEnableWriteConsoleMessagesToStdout :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableWriteConsoleMessagesToStdout obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-write-console-messages-to-stdout"

{- |
Set the value of the “@enable-write-console-messages-to-stdout@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableWriteConsoleMessagesToStdout 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableWriteConsoleMessagesToStdout :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableWriteConsoleMessagesToStdout obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-write-console-messages-to-stdout" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-write-console-messages-to-stdout@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableWriteConsoleMessagesToStdout :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableWriteConsoleMessagesToStdout val = B.Properties.constructObjectPropertyBool "enable-write-console-messages-to-stdout" val

#if ENABLE_OVERLOADING
data SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo
instance AttrInfo SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo where
    type AttrAllowedOps SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = IsSettings
    type AttrGetType SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = Bool
    type AttrLabel SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = "enable-write-console-messages-to-stdout"
    type AttrOrigin SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = Settings
    attrGet _ = getSettingsEnableWriteConsoleMessagesToStdout
    attrSet _ = setSettingsEnableWriteConsoleMessagesToStdout
    attrConstruct _ = constructSettingsEnableWriteConsoleMessagesToStdout
    attrClear _ = undefined
#endif

-- VVV Prop "enable-xss-auditor"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-xss-auditor@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #enableXssAuditor
@
-}
getSettingsEnableXssAuditor :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsEnableXssAuditor obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-xss-auditor"

{- |
Set the value of the “@enable-xss-auditor@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #enableXssAuditor 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsEnableXssAuditor :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsEnableXssAuditor obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-xss-auditor" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-xss-auditor@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsEnableXssAuditor :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsEnableXssAuditor val = B.Properties.constructObjectPropertyBool "enable-xss-auditor" val

#if ENABLE_OVERLOADING
data SettingsEnableXssAuditorPropertyInfo
instance AttrInfo SettingsEnableXssAuditorPropertyInfo where
    type AttrAllowedOps SettingsEnableXssAuditorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableXssAuditorPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableXssAuditorPropertyInfo = IsSettings
    type AttrGetType SettingsEnableXssAuditorPropertyInfo = Bool
    type AttrLabel SettingsEnableXssAuditorPropertyInfo = "enable-xss-auditor"
    type AttrOrigin SettingsEnableXssAuditorPropertyInfo = Settings
    attrGet _ = getSettingsEnableXssAuditor
    attrSet _ = setSettingsEnableXssAuditor
    attrConstruct _ = constructSettingsEnableXssAuditor
    attrClear _ = undefined
#endif

-- VVV Prop "fantasy-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@fantasy-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #fantasyFontFamily
@
-}
getSettingsFantasyFontFamily :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsFantasyFontFamily obj = liftIO $ checkUnexpectedNothing "getSettingsFantasyFontFamily" $ B.Properties.getObjectPropertyString obj "fantasy-font-family"

{- |
Set the value of the “@fantasy-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #fantasyFontFamily 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsFantasyFontFamily :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsFantasyFontFamily obj val = liftIO $ B.Properties.setObjectPropertyString obj "fantasy-font-family" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@fantasy-font-family@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsFantasyFontFamily :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsFantasyFontFamily val = B.Properties.constructObjectPropertyString "fantasy-font-family" (Just val)

#if ENABLE_OVERLOADING
data SettingsFantasyFontFamilyPropertyInfo
instance AttrInfo SettingsFantasyFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsFantasyFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsFantasyFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsFantasyFontFamilyPropertyInfo = IsSettings
    type AttrGetType SettingsFantasyFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsFantasyFontFamilyPropertyInfo = "fantasy-font-family"
    type AttrOrigin SettingsFantasyFontFamilyPropertyInfo = Settings
    attrGet _ = getSettingsFantasyFontFamily
    attrSet _ = setSettingsFantasyFontFamily
    attrConstruct _ = constructSettingsFantasyFontFamily
    attrClear _ = undefined
#endif

-- VVV Prop "hardware-acceleration-policy"
   -- Type: TInterface (Name {namespace = "WebKit2", name = "HardwareAccelerationPolicy"})
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@hardware-acceleration-policy@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #hardwareAccelerationPolicy
@
-}
getSettingsHardwareAccelerationPolicy :: (MonadIO m, IsSettings o) => o -> m WebKit2.Enums.HardwareAccelerationPolicy
getSettingsHardwareAccelerationPolicy obj = liftIO $ B.Properties.getObjectPropertyEnum obj "hardware-acceleration-policy"

{- |
Set the value of the “@hardware-acceleration-policy@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #hardwareAccelerationPolicy 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsHardwareAccelerationPolicy :: (MonadIO m, IsSettings o) => o -> WebKit2.Enums.HardwareAccelerationPolicy -> m ()
setSettingsHardwareAccelerationPolicy obj val = liftIO $ B.Properties.setObjectPropertyEnum obj "hardware-acceleration-policy" val

{- |
Construct a `GValueConstruct` with valid value for the “@hardware-acceleration-policy@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsHardwareAccelerationPolicy :: (IsSettings o) => WebKit2.Enums.HardwareAccelerationPolicy -> IO (GValueConstruct o)
constructSettingsHardwareAccelerationPolicy val = B.Properties.constructObjectPropertyEnum "hardware-acceleration-policy" val

#if ENABLE_OVERLOADING
data SettingsHardwareAccelerationPolicyPropertyInfo
instance AttrInfo SettingsHardwareAccelerationPolicyPropertyInfo where
    type AttrAllowedOps SettingsHardwareAccelerationPolicyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsHardwareAccelerationPolicyPropertyInfo = (~) WebKit2.Enums.HardwareAccelerationPolicy
    type AttrBaseTypeConstraint SettingsHardwareAccelerationPolicyPropertyInfo = IsSettings
    type AttrGetType SettingsHardwareAccelerationPolicyPropertyInfo = WebKit2.Enums.HardwareAccelerationPolicy
    type AttrLabel SettingsHardwareAccelerationPolicyPropertyInfo = "hardware-acceleration-policy"
    type AttrOrigin SettingsHardwareAccelerationPolicyPropertyInfo = Settings
    attrGet _ = getSettingsHardwareAccelerationPolicy
    attrSet _ = setSettingsHardwareAccelerationPolicy
    attrConstruct _ = constructSettingsHardwareAccelerationPolicy
    attrClear _ = undefined
#endif

-- VVV Prop "javascript-can-access-clipboard"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@javascript-can-access-clipboard@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #javascriptCanAccessClipboard
@
-}
getSettingsJavascriptCanAccessClipboard :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsJavascriptCanAccessClipboard obj = liftIO $ B.Properties.getObjectPropertyBool obj "javascript-can-access-clipboard"

{- |
Set the value of the “@javascript-can-access-clipboard@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #javascriptCanAccessClipboard 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsJavascriptCanAccessClipboard :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsJavascriptCanAccessClipboard obj val = liftIO $ B.Properties.setObjectPropertyBool obj "javascript-can-access-clipboard" val

{- |
Construct a `GValueConstruct` with valid value for the “@javascript-can-access-clipboard@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsJavascriptCanAccessClipboard :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsJavascriptCanAccessClipboard val = B.Properties.constructObjectPropertyBool "javascript-can-access-clipboard" val

#if ENABLE_OVERLOADING
data SettingsJavascriptCanAccessClipboardPropertyInfo
instance AttrInfo SettingsJavascriptCanAccessClipboardPropertyInfo where
    type AttrAllowedOps SettingsJavascriptCanAccessClipboardPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsJavascriptCanAccessClipboardPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsJavascriptCanAccessClipboardPropertyInfo = IsSettings
    type AttrGetType SettingsJavascriptCanAccessClipboardPropertyInfo = Bool
    type AttrLabel SettingsJavascriptCanAccessClipboardPropertyInfo = "javascript-can-access-clipboard"
    type AttrOrigin SettingsJavascriptCanAccessClipboardPropertyInfo = Settings
    attrGet _ = getSettingsJavascriptCanAccessClipboard
    attrSet _ = setSettingsJavascriptCanAccessClipboard
    attrConstruct _ = constructSettingsJavascriptCanAccessClipboard
    attrClear _ = undefined
#endif

-- VVV Prop "javascript-can-open-windows-automatically"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@javascript-can-open-windows-automatically@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #javascriptCanOpenWindowsAutomatically
@
-}
getSettingsJavascriptCanOpenWindowsAutomatically :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsJavascriptCanOpenWindowsAutomatically obj = liftIO $ B.Properties.getObjectPropertyBool obj "javascript-can-open-windows-automatically"

{- |
Set the value of the “@javascript-can-open-windows-automatically@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #javascriptCanOpenWindowsAutomatically 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsJavascriptCanOpenWindowsAutomatically :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsJavascriptCanOpenWindowsAutomatically obj val = liftIO $ B.Properties.setObjectPropertyBool obj "javascript-can-open-windows-automatically" val

{- |
Construct a `GValueConstruct` with valid value for the “@javascript-can-open-windows-automatically@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsJavascriptCanOpenWindowsAutomatically :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsJavascriptCanOpenWindowsAutomatically val = B.Properties.constructObjectPropertyBool "javascript-can-open-windows-automatically" val

#if ENABLE_OVERLOADING
data SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo
instance AttrInfo SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo where
    type AttrAllowedOps SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = IsSettings
    type AttrGetType SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = Bool
    type AttrLabel SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = "javascript-can-open-windows-automatically"
    type AttrOrigin SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = Settings
    attrGet _ = getSettingsJavascriptCanOpenWindowsAutomatically
    attrSet _ = setSettingsJavascriptCanOpenWindowsAutomatically
    attrConstruct _ = constructSettingsJavascriptCanOpenWindowsAutomatically
    attrClear _ = undefined
#endif

-- VVV Prop "load-icons-ignoring-image-load-setting"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@load-icons-ignoring-image-load-setting@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #loadIconsIgnoringImageLoadSetting
@
-}
getSettingsLoadIconsIgnoringImageLoadSetting :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsLoadIconsIgnoringImageLoadSetting obj = liftIO $ B.Properties.getObjectPropertyBool obj "load-icons-ignoring-image-load-setting"

{- |
Set the value of the “@load-icons-ignoring-image-load-setting@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #loadIconsIgnoringImageLoadSetting 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsLoadIconsIgnoringImageLoadSetting :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsLoadIconsIgnoringImageLoadSetting obj val = liftIO $ B.Properties.setObjectPropertyBool obj "load-icons-ignoring-image-load-setting" val

{- |
Construct a `GValueConstruct` with valid value for the “@load-icons-ignoring-image-load-setting@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsLoadIconsIgnoringImageLoadSetting :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsLoadIconsIgnoringImageLoadSetting val = B.Properties.constructObjectPropertyBool "load-icons-ignoring-image-load-setting" val

#if ENABLE_OVERLOADING
data SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo
instance AttrInfo SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo where
    type AttrAllowedOps SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = IsSettings
    type AttrGetType SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = Bool
    type AttrLabel SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = "load-icons-ignoring-image-load-setting"
    type AttrOrigin SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = Settings
    attrGet _ = getSettingsLoadIconsIgnoringImageLoadSetting
    attrSet _ = setSettingsLoadIconsIgnoringImageLoadSetting
    attrConstruct _ = constructSettingsLoadIconsIgnoringImageLoadSetting
    attrClear _ = undefined
#endif

-- VVV Prop "media-playback-allows-inline"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@media-playback-allows-inline@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #mediaPlaybackAllowsInline
@
-}
getSettingsMediaPlaybackAllowsInline :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsMediaPlaybackAllowsInline obj = liftIO $ B.Properties.getObjectPropertyBool obj "media-playback-allows-inline"

{- |
Set the value of the “@media-playback-allows-inline@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #mediaPlaybackAllowsInline 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsMediaPlaybackAllowsInline :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsMediaPlaybackAllowsInline obj val = liftIO $ B.Properties.setObjectPropertyBool obj "media-playback-allows-inline" val

{- |
Construct a `GValueConstruct` with valid value for the “@media-playback-allows-inline@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsMediaPlaybackAllowsInline :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsMediaPlaybackAllowsInline val = B.Properties.constructObjectPropertyBool "media-playback-allows-inline" val

#if ENABLE_OVERLOADING
data SettingsMediaPlaybackAllowsInlinePropertyInfo
instance AttrInfo SettingsMediaPlaybackAllowsInlinePropertyInfo where
    type AttrAllowedOps SettingsMediaPlaybackAllowsInlinePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMediaPlaybackAllowsInlinePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsMediaPlaybackAllowsInlinePropertyInfo = IsSettings
    type AttrGetType SettingsMediaPlaybackAllowsInlinePropertyInfo = Bool
    type AttrLabel SettingsMediaPlaybackAllowsInlinePropertyInfo = "media-playback-allows-inline"
    type AttrOrigin SettingsMediaPlaybackAllowsInlinePropertyInfo = Settings
    attrGet _ = getSettingsMediaPlaybackAllowsInline
    attrSet _ = setSettingsMediaPlaybackAllowsInline
    attrConstruct _ = constructSettingsMediaPlaybackAllowsInline
    attrClear _ = undefined
#endif

-- VVV Prop "media-playback-requires-user-gesture"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@media-playback-requires-user-gesture@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #mediaPlaybackRequiresUserGesture
@
-}
getSettingsMediaPlaybackRequiresUserGesture :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsMediaPlaybackRequiresUserGesture obj = liftIO $ B.Properties.getObjectPropertyBool obj "media-playback-requires-user-gesture"

{- |
Set the value of the “@media-playback-requires-user-gesture@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #mediaPlaybackRequiresUserGesture 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsMediaPlaybackRequiresUserGesture :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsMediaPlaybackRequiresUserGesture obj val = liftIO $ B.Properties.setObjectPropertyBool obj "media-playback-requires-user-gesture" val

{- |
Construct a `GValueConstruct` with valid value for the “@media-playback-requires-user-gesture@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsMediaPlaybackRequiresUserGesture :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsMediaPlaybackRequiresUserGesture val = B.Properties.constructObjectPropertyBool "media-playback-requires-user-gesture" val

#if ENABLE_OVERLOADING
data SettingsMediaPlaybackRequiresUserGesturePropertyInfo
instance AttrInfo SettingsMediaPlaybackRequiresUserGesturePropertyInfo where
    type AttrAllowedOps SettingsMediaPlaybackRequiresUserGesturePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMediaPlaybackRequiresUserGesturePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsMediaPlaybackRequiresUserGesturePropertyInfo = IsSettings
    type AttrGetType SettingsMediaPlaybackRequiresUserGesturePropertyInfo = Bool
    type AttrLabel SettingsMediaPlaybackRequiresUserGesturePropertyInfo = "media-playback-requires-user-gesture"
    type AttrOrigin SettingsMediaPlaybackRequiresUserGesturePropertyInfo = Settings
    attrGet _ = getSettingsMediaPlaybackRequiresUserGesture
    attrSet _ = setSettingsMediaPlaybackRequiresUserGesture
    attrConstruct _ = constructSettingsMediaPlaybackRequiresUserGesture
    attrClear _ = undefined
#endif

-- VVV Prop "minimum-font-size"
   -- Type: TBasicType TUInt
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@minimum-font-size@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #minimumFontSize
@
-}
getSettingsMinimumFontSize :: (MonadIO m, IsSettings o) => o -> m Word32
getSettingsMinimumFontSize obj = liftIO $ B.Properties.getObjectPropertyUInt32 obj "minimum-font-size"

{- |
Set the value of the “@minimum-font-size@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #minimumFontSize 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsMinimumFontSize :: (MonadIO m, IsSettings o) => o -> Word32 -> m ()
setSettingsMinimumFontSize obj val = liftIO $ B.Properties.setObjectPropertyUInt32 obj "minimum-font-size" val

{- |
Construct a `GValueConstruct` with valid value for the “@minimum-font-size@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsMinimumFontSize :: (IsSettings o) => Word32 -> IO (GValueConstruct o)
constructSettingsMinimumFontSize val = B.Properties.constructObjectPropertyUInt32 "minimum-font-size" val

#if ENABLE_OVERLOADING
data SettingsMinimumFontSizePropertyInfo
instance AttrInfo SettingsMinimumFontSizePropertyInfo where
    type AttrAllowedOps SettingsMinimumFontSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMinimumFontSizePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint SettingsMinimumFontSizePropertyInfo = IsSettings
    type AttrGetType SettingsMinimumFontSizePropertyInfo = Word32
    type AttrLabel SettingsMinimumFontSizePropertyInfo = "minimum-font-size"
    type AttrOrigin SettingsMinimumFontSizePropertyInfo = Settings
    attrGet _ = getSettingsMinimumFontSize
    attrSet _ = setSettingsMinimumFontSize
    attrConstruct _ = constructSettingsMinimumFontSize
    attrClear _ = undefined
#endif

-- VVV Prop "monospace-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@monospace-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #monospaceFontFamily
@
-}
getSettingsMonospaceFontFamily :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsMonospaceFontFamily obj = liftIO $ checkUnexpectedNothing "getSettingsMonospaceFontFamily" $ B.Properties.getObjectPropertyString obj "monospace-font-family"

{- |
Set the value of the “@monospace-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #monospaceFontFamily 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsMonospaceFontFamily :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsMonospaceFontFamily obj val = liftIO $ B.Properties.setObjectPropertyString obj "monospace-font-family" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@monospace-font-family@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsMonospaceFontFamily :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsMonospaceFontFamily val = B.Properties.constructObjectPropertyString "monospace-font-family" (Just val)

#if ENABLE_OVERLOADING
data SettingsMonospaceFontFamilyPropertyInfo
instance AttrInfo SettingsMonospaceFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsMonospaceFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMonospaceFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsMonospaceFontFamilyPropertyInfo = IsSettings
    type AttrGetType SettingsMonospaceFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsMonospaceFontFamilyPropertyInfo = "monospace-font-family"
    type AttrOrigin SettingsMonospaceFontFamilyPropertyInfo = Settings
    attrGet _ = getSettingsMonospaceFontFamily
    attrSet _ = setSettingsMonospaceFontFamily
    attrConstruct _ = constructSettingsMonospaceFontFamily
    attrClear _ = undefined
#endif

-- VVV Prop "pictograph-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@pictograph-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #pictographFontFamily
@
-}
getSettingsPictographFontFamily :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsPictographFontFamily obj = liftIO $ checkUnexpectedNothing "getSettingsPictographFontFamily" $ B.Properties.getObjectPropertyString obj "pictograph-font-family"

{- |
Set the value of the “@pictograph-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #pictographFontFamily 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsPictographFontFamily :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsPictographFontFamily obj val = liftIO $ B.Properties.setObjectPropertyString obj "pictograph-font-family" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@pictograph-font-family@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsPictographFontFamily :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsPictographFontFamily val = B.Properties.constructObjectPropertyString "pictograph-font-family" (Just val)

#if ENABLE_OVERLOADING
data SettingsPictographFontFamilyPropertyInfo
instance AttrInfo SettingsPictographFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsPictographFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsPictographFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsPictographFontFamilyPropertyInfo = IsSettings
    type AttrGetType SettingsPictographFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsPictographFontFamilyPropertyInfo = "pictograph-font-family"
    type AttrOrigin SettingsPictographFontFamilyPropertyInfo = Settings
    attrGet _ = getSettingsPictographFontFamily
    attrSet _ = setSettingsPictographFontFamily
    attrConstruct _ = constructSettingsPictographFontFamily
    attrClear _ = undefined
#endif

-- VVV Prop "print-backgrounds"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@print-backgrounds@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #printBackgrounds
@
-}
getSettingsPrintBackgrounds :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsPrintBackgrounds obj = liftIO $ B.Properties.getObjectPropertyBool obj "print-backgrounds"

{- |
Set the value of the “@print-backgrounds@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #printBackgrounds 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsPrintBackgrounds :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsPrintBackgrounds obj val = liftIO $ B.Properties.setObjectPropertyBool obj "print-backgrounds" val

{- |
Construct a `GValueConstruct` with valid value for the “@print-backgrounds@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsPrintBackgrounds :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsPrintBackgrounds val = B.Properties.constructObjectPropertyBool "print-backgrounds" val

#if ENABLE_OVERLOADING
data SettingsPrintBackgroundsPropertyInfo
instance AttrInfo SettingsPrintBackgroundsPropertyInfo where
    type AttrAllowedOps SettingsPrintBackgroundsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsPrintBackgroundsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsPrintBackgroundsPropertyInfo = IsSettings
    type AttrGetType SettingsPrintBackgroundsPropertyInfo = Bool
    type AttrLabel SettingsPrintBackgroundsPropertyInfo = "print-backgrounds"
    type AttrOrigin SettingsPrintBackgroundsPropertyInfo = Settings
    attrGet _ = getSettingsPrintBackgrounds
    attrSet _ = setSettingsPrintBackgrounds
    attrConstruct _ = constructSettingsPrintBackgrounds
    attrClear _ = undefined
#endif

-- VVV Prop "sans-serif-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@sans-serif-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #sansSerifFontFamily
@
-}
getSettingsSansSerifFontFamily :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsSansSerifFontFamily obj = liftIO $ checkUnexpectedNothing "getSettingsSansSerifFontFamily" $ B.Properties.getObjectPropertyString obj "sans-serif-font-family"

{- |
Set the value of the “@sans-serif-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #sansSerifFontFamily 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsSansSerifFontFamily :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsSansSerifFontFamily obj val = liftIO $ B.Properties.setObjectPropertyString obj "sans-serif-font-family" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@sans-serif-font-family@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsSansSerifFontFamily :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsSansSerifFontFamily val = B.Properties.constructObjectPropertyString "sans-serif-font-family" (Just val)

#if ENABLE_OVERLOADING
data SettingsSansSerifFontFamilyPropertyInfo
instance AttrInfo SettingsSansSerifFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsSansSerifFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsSansSerifFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsSansSerifFontFamilyPropertyInfo = IsSettings
    type AttrGetType SettingsSansSerifFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsSansSerifFontFamilyPropertyInfo = "sans-serif-font-family"
    type AttrOrigin SettingsSansSerifFontFamilyPropertyInfo = Settings
    attrGet _ = getSettingsSansSerifFontFamily
    attrSet _ = setSettingsSansSerifFontFamily
    attrConstruct _ = constructSettingsSansSerifFontFamily
    attrClear _ = undefined
#endif

-- VVV Prop "serif-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@serif-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #serifFontFamily
@
-}
getSettingsSerifFontFamily :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsSerifFontFamily obj = liftIO $ checkUnexpectedNothing "getSettingsSerifFontFamily" $ B.Properties.getObjectPropertyString obj "serif-font-family"

{- |
Set the value of the “@serif-font-family@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #serifFontFamily 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsSerifFontFamily :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsSerifFontFamily obj val = liftIO $ B.Properties.setObjectPropertyString obj "serif-font-family" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@serif-font-family@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsSerifFontFamily :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsSerifFontFamily val = B.Properties.constructObjectPropertyString "serif-font-family" (Just val)

#if ENABLE_OVERLOADING
data SettingsSerifFontFamilyPropertyInfo
instance AttrInfo SettingsSerifFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsSerifFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsSerifFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsSerifFontFamilyPropertyInfo = IsSettings
    type AttrGetType SettingsSerifFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsSerifFontFamilyPropertyInfo = "serif-font-family"
    type AttrOrigin SettingsSerifFontFamilyPropertyInfo = Settings
    attrGet _ = getSettingsSerifFontFamily
    attrSet _ = setSettingsSerifFontFamily
    attrConstruct _ = constructSettingsSerifFontFamily
    attrClear _ = undefined
#endif

-- VVV Prop "user-agent"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just True)

{- |
Get the value of the “@user-agent@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #userAgent
@
-}
getSettingsUserAgent :: (MonadIO m, IsSettings o) => o -> m T.Text
getSettingsUserAgent obj = liftIO $ checkUnexpectedNothing "getSettingsUserAgent" $ B.Properties.getObjectPropertyString obj "user-agent"

{- |
Set the value of the “@user-agent@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #userAgent 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsUserAgent :: (MonadIO m, IsSettings o) => o -> T.Text -> m ()
setSettingsUserAgent obj val = liftIO $ B.Properties.setObjectPropertyString obj "user-agent" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@user-agent@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsUserAgent :: (IsSettings o) => T.Text -> IO (GValueConstruct o)
constructSettingsUserAgent val = B.Properties.constructObjectPropertyString "user-agent" (Just val)

{- |
Set the value of the “@user-agent@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #userAgent
@
-}
clearSettingsUserAgent :: (MonadIO m, IsSettings o) => o -> m ()
clearSettingsUserAgent obj = liftIO $ B.Properties.setObjectPropertyString obj "user-agent" (Nothing :: Maybe T.Text)

#if ENABLE_OVERLOADING
data SettingsUserAgentPropertyInfo
instance AttrInfo SettingsUserAgentPropertyInfo where
    type AttrAllowedOps SettingsUserAgentPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint SettingsUserAgentPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsUserAgentPropertyInfo = IsSettings
    type AttrGetType SettingsUserAgentPropertyInfo = T.Text
    type AttrLabel SettingsUserAgentPropertyInfo = "user-agent"
    type AttrOrigin SettingsUserAgentPropertyInfo = Settings
    attrGet _ = getSettingsUserAgent
    attrSet _ = setSettingsUserAgent
    attrConstruct _ = constructSettingsUserAgent
    attrClear _ = clearSettingsUserAgent
#endif

-- VVV Prop "zoom-text-only"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@zoom-text-only@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' settings #zoomTextOnly
@
-}
getSettingsZoomTextOnly :: (MonadIO m, IsSettings o) => o -> m Bool
getSettingsZoomTextOnly obj = liftIO $ B.Properties.getObjectPropertyBool obj "zoom-text-only"

{- |
Set the value of the “@zoom-text-only@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' settings [ #zoomTextOnly 'Data.GI.Base.Attributes.:=' value ]
@
-}
setSettingsZoomTextOnly :: (MonadIO m, IsSettings o) => o -> Bool -> m ()
setSettingsZoomTextOnly obj val = liftIO $ B.Properties.setObjectPropertyBool obj "zoom-text-only" val

{- |
Construct a `GValueConstruct` with valid value for the “@zoom-text-only@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructSettingsZoomTextOnly :: (IsSettings o) => Bool -> IO (GValueConstruct o)
constructSettingsZoomTextOnly val = B.Properties.constructObjectPropertyBool "zoom-text-only" val

#if ENABLE_OVERLOADING
data SettingsZoomTextOnlyPropertyInfo
instance AttrInfo SettingsZoomTextOnlyPropertyInfo where
    type AttrAllowedOps SettingsZoomTextOnlyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsZoomTextOnlyPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsZoomTextOnlyPropertyInfo = IsSettings
    type AttrGetType SettingsZoomTextOnlyPropertyInfo = Bool
    type AttrLabel SettingsZoomTextOnlyPropertyInfo = "zoom-text-only"
    type AttrOrigin SettingsZoomTextOnlyPropertyInfo = Settings
    attrGet _ = getSettingsZoomTextOnly
    attrSet _ = setSettingsZoomTextOnly
    attrConstruct _ = constructSettingsZoomTextOnly
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList Settings
type instance O.AttributeList Settings = SettingsAttributeList
type SettingsAttributeList = ('[ '("allowFileAccessFromFileUrls", SettingsAllowFileAccessFromFileUrlsPropertyInfo), '("allowModalDialogs", SettingsAllowModalDialogsPropertyInfo), '("allowUniversalAccessFromFileUrls", SettingsAllowUniversalAccessFromFileUrlsPropertyInfo), '("autoLoadImages", SettingsAutoLoadImagesPropertyInfo), '("cursiveFontFamily", SettingsCursiveFontFamilyPropertyInfo), '("defaultCharset", SettingsDefaultCharsetPropertyInfo), '("defaultFontFamily", SettingsDefaultFontFamilyPropertyInfo), '("defaultFontSize", SettingsDefaultFontSizePropertyInfo), '("defaultMonospaceFontSize", SettingsDefaultMonospaceFontSizePropertyInfo), '("drawCompositingIndicators", SettingsDrawCompositingIndicatorsPropertyInfo), '("enableAccelerated2dCanvas", SettingsEnableAccelerated2dCanvasPropertyInfo), '("enableBackForwardNavigationGestures", SettingsEnableBackForwardNavigationGesturesPropertyInfo), '("enableCaretBrowsing", SettingsEnableCaretBrowsingPropertyInfo), '("enableDeveloperExtras", SettingsEnableDeveloperExtrasPropertyInfo), '("enableDnsPrefetching", SettingsEnableDnsPrefetchingPropertyInfo), '("enableEncryptedMedia", SettingsEnableEncryptedMediaPropertyInfo), '("enableFrameFlattening", SettingsEnableFrameFlatteningPropertyInfo), '("enableFullscreen", SettingsEnableFullscreenPropertyInfo), '("enableHtml5Database", SettingsEnableHtml5DatabasePropertyInfo), '("enableHtml5LocalStorage", SettingsEnableHtml5LocalStoragePropertyInfo), '("enableHyperlinkAuditing", SettingsEnableHyperlinkAuditingPropertyInfo), '("enableJava", SettingsEnableJavaPropertyInfo), '("enableJavascript", SettingsEnableJavascriptPropertyInfo), '("enableJavascriptMarkup", SettingsEnableJavascriptMarkupPropertyInfo), '("enableMediaCapabilities", SettingsEnableMediaCapabilitiesPropertyInfo), '("enableMediaStream", SettingsEnableMediaStreamPropertyInfo), '("enableMediasource", SettingsEnableMediasourcePropertyInfo), '("enableMockCaptureDevices", SettingsEnableMockCaptureDevicesPropertyInfo), '("enableOfflineWebApplicationCache", SettingsEnableOfflineWebApplicationCachePropertyInfo), '("enablePageCache", SettingsEnablePageCachePropertyInfo), '("enablePlugins", SettingsEnablePluginsPropertyInfo), '("enablePrivateBrowsing", SettingsEnablePrivateBrowsingPropertyInfo), '("enableResizableTextAreas", SettingsEnableResizableTextAreasPropertyInfo), '("enableSiteSpecificQuirks", SettingsEnableSiteSpecificQuirksPropertyInfo), '("enableSmoothScrolling", SettingsEnableSmoothScrollingPropertyInfo), '("enableSpatialNavigation", SettingsEnableSpatialNavigationPropertyInfo), '("enableTabsToLinks", SettingsEnableTabsToLinksPropertyInfo), '("enableWebaudio", SettingsEnableWebaudioPropertyInfo), '("enableWebgl", SettingsEnableWebglPropertyInfo), '("enableWriteConsoleMessagesToStdout", SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo), '("enableXssAuditor", SettingsEnableXssAuditorPropertyInfo), '("fantasyFontFamily", SettingsFantasyFontFamilyPropertyInfo), '("hardwareAccelerationPolicy", SettingsHardwareAccelerationPolicyPropertyInfo), '("javascriptCanAccessClipboard", SettingsJavascriptCanAccessClipboardPropertyInfo), '("javascriptCanOpenWindowsAutomatically", SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo), '("loadIconsIgnoringImageLoadSetting", SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo), '("mediaPlaybackAllowsInline", SettingsMediaPlaybackAllowsInlinePropertyInfo), '("mediaPlaybackRequiresUserGesture", SettingsMediaPlaybackRequiresUserGesturePropertyInfo), '("minimumFontSize", SettingsMinimumFontSizePropertyInfo), '("monospaceFontFamily", SettingsMonospaceFontFamilyPropertyInfo), '("pictographFontFamily", SettingsPictographFontFamilyPropertyInfo), '("printBackgrounds", SettingsPrintBackgroundsPropertyInfo), '("sansSerifFontFamily", SettingsSansSerifFontFamilyPropertyInfo), '("serifFontFamily", SettingsSerifFontFamilyPropertyInfo), '("userAgent", SettingsUserAgentPropertyInfo), '("zoomTextOnly", SettingsZoomTextOnlyPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
settingsAllowFileAccessFromFileUrls :: AttrLabelProxy "allowFileAccessFromFileUrls"
settingsAllowFileAccessFromFileUrls = AttrLabelProxy

settingsAllowModalDialogs :: AttrLabelProxy "allowModalDialogs"
settingsAllowModalDialogs = AttrLabelProxy

settingsAllowUniversalAccessFromFileUrls :: AttrLabelProxy "allowUniversalAccessFromFileUrls"
settingsAllowUniversalAccessFromFileUrls = AttrLabelProxy

settingsAutoLoadImages :: AttrLabelProxy "autoLoadImages"
settingsAutoLoadImages = AttrLabelProxy

settingsCursiveFontFamily :: AttrLabelProxy "cursiveFontFamily"
settingsCursiveFontFamily = AttrLabelProxy

settingsDefaultCharset :: AttrLabelProxy "defaultCharset"
settingsDefaultCharset = AttrLabelProxy

settingsDefaultFontFamily :: AttrLabelProxy "defaultFontFamily"
settingsDefaultFontFamily = AttrLabelProxy

settingsDefaultFontSize :: AttrLabelProxy "defaultFontSize"
settingsDefaultFontSize = AttrLabelProxy

settingsDefaultMonospaceFontSize :: AttrLabelProxy "defaultMonospaceFontSize"
settingsDefaultMonospaceFontSize = AttrLabelProxy

settingsDrawCompositingIndicators :: AttrLabelProxy "drawCompositingIndicators"
settingsDrawCompositingIndicators = AttrLabelProxy

settingsEnableAccelerated2dCanvas :: AttrLabelProxy "enableAccelerated2dCanvas"
settingsEnableAccelerated2dCanvas = AttrLabelProxy

settingsEnableBackForwardNavigationGestures :: AttrLabelProxy "enableBackForwardNavigationGestures"
settingsEnableBackForwardNavigationGestures = AttrLabelProxy

settingsEnableCaretBrowsing :: AttrLabelProxy "enableCaretBrowsing"
settingsEnableCaretBrowsing = AttrLabelProxy

settingsEnableDeveloperExtras :: AttrLabelProxy "enableDeveloperExtras"
settingsEnableDeveloperExtras = AttrLabelProxy

settingsEnableDnsPrefetching :: AttrLabelProxy "enableDnsPrefetching"
settingsEnableDnsPrefetching = AttrLabelProxy

settingsEnableEncryptedMedia :: AttrLabelProxy "enableEncryptedMedia"
settingsEnableEncryptedMedia = AttrLabelProxy

settingsEnableFrameFlattening :: AttrLabelProxy "enableFrameFlattening"
settingsEnableFrameFlattening = AttrLabelProxy

settingsEnableFullscreen :: AttrLabelProxy "enableFullscreen"
settingsEnableFullscreen = AttrLabelProxy

settingsEnableHtml5Database :: AttrLabelProxy "enableHtml5Database"
settingsEnableHtml5Database = AttrLabelProxy

settingsEnableHtml5LocalStorage :: AttrLabelProxy "enableHtml5LocalStorage"
settingsEnableHtml5LocalStorage = AttrLabelProxy

settingsEnableHyperlinkAuditing :: AttrLabelProxy "enableHyperlinkAuditing"
settingsEnableHyperlinkAuditing = AttrLabelProxy

settingsEnableJava :: AttrLabelProxy "enableJava"
settingsEnableJava = AttrLabelProxy

settingsEnableJavascript :: AttrLabelProxy "enableJavascript"
settingsEnableJavascript = AttrLabelProxy

settingsEnableJavascriptMarkup :: AttrLabelProxy "enableJavascriptMarkup"
settingsEnableJavascriptMarkup = AttrLabelProxy

settingsEnableMediaCapabilities :: AttrLabelProxy "enableMediaCapabilities"
settingsEnableMediaCapabilities = AttrLabelProxy

settingsEnableMediaStream :: AttrLabelProxy "enableMediaStream"
settingsEnableMediaStream = AttrLabelProxy

settingsEnableMediasource :: AttrLabelProxy "enableMediasource"
settingsEnableMediasource = AttrLabelProxy

settingsEnableMockCaptureDevices :: AttrLabelProxy "enableMockCaptureDevices"
settingsEnableMockCaptureDevices = AttrLabelProxy

settingsEnableOfflineWebApplicationCache :: AttrLabelProxy "enableOfflineWebApplicationCache"
settingsEnableOfflineWebApplicationCache = AttrLabelProxy

settingsEnablePageCache :: AttrLabelProxy "enablePageCache"
settingsEnablePageCache = AttrLabelProxy

settingsEnablePlugins :: AttrLabelProxy "enablePlugins"
settingsEnablePlugins = AttrLabelProxy

settingsEnablePrivateBrowsing :: AttrLabelProxy "enablePrivateBrowsing"
settingsEnablePrivateBrowsing = AttrLabelProxy

settingsEnableResizableTextAreas :: AttrLabelProxy "enableResizableTextAreas"
settingsEnableResizableTextAreas = AttrLabelProxy

settingsEnableSiteSpecificQuirks :: AttrLabelProxy "enableSiteSpecificQuirks"
settingsEnableSiteSpecificQuirks = AttrLabelProxy

settingsEnableSmoothScrolling :: AttrLabelProxy "enableSmoothScrolling"
settingsEnableSmoothScrolling = AttrLabelProxy

settingsEnableSpatialNavigation :: AttrLabelProxy "enableSpatialNavigation"
settingsEnableSpatialNavigation = AttrLabelProxy

settingsEnableTabsToLinks :: AttrLabelProxy "enableTabsToLinks"
settingsEnableTabsToLinks = AttrLabelProxy

settingsEnableWebaudio :: AttrLabelProxy "enableWebaudio"
settingsEnableWebaudio = AttrLabelProxy

settingsEnableWebgl :: AttrLabelProxy "enableWebgl"
settingsEnableWebgl = AttrLabelProxy

settingsEnableWriteConsoleMessagesToStdout :: AttrLabelProxy "enableWriteConsoleMessagesToStdout"
settingsEnableWriteConsoleMessagesToStdout = AttrLabelProxy

settingsEnableXssAuditor :: AttrLabelProxy "enableXssAuditor"
settingsEnableXssAuditor = AttrLabelProxy

settingsFantasyFontFamily :: AttrLabelProxy "fantasyFontFamily"
settingsFantasyFontFamily = AttrLabelProxy

settingsHardwareAccelerationPolicy :: AttrLabelProxy "hardwareAccelerationPolicy"
settingsHardwareAccelerationPolicy = AttrLabelProxy

settingsJavascriptCanAccessClipboard :: AttrLabelProxy "javascriptCanAccessClipboard"
settingsJavascriptCanAccessClipboard = AttrLabelProxy

settingsJavascriptCanOpenWindowsAutomatically :: AttrLabelProxy "javascriptCanOpenWindowsAutomatically"
settingsJavascriptCanOpenWindowsAutomatically = AttrLabelProxy

settingsLoadIconsIgnoringImageLoadSetting :: AttrLabelProxy "loadIconsIgnoringImageLoadSetting"
settingsLoadIconsIgnoringImageLoadSetting = AttrLabelProxy

settingsMediaPlaybackAllowsInline :: AttrLabelProxy "mediaPlaybackAllowsInline"
settingsMediaPlaybackAllowsInline = AttrLabelProxy

settingsMediaPlaybackRequiresUserGesture :: AttrLabelProxy "mediaPlaybackRequiresUserGesture"
settingsMediaPlaybackRequiresUserGesture = AttrLabelProxy

settingsMinimumFontSize :: AttrLabelProxy "minimumFontSize"
settingsMinimumFontSize = AttrLabelProxy

settingsMonospaceFontFamily :: AttrLabelProxy "monospaceFontFamily"
settingsMonospaceFontFamily = AttrLabelProxy

settingsPictographFontFamily :: AttrLabelProxy "pictographFontFamily"
settingsPictographFontFamily = AttrLabelProxy

settingsPrintBackgrounds :: AttrLabelProxy "printBackgrounds"
settingsPrintBackgrounds = AttrLabelProxy

settingsSansSerifFontFamily :: AttrLabelProxy "sansSerifFontFamily"
settingsSansSerifFontFamily = AttrLabelProxy

settingsSerifFontFamily :: AttrLabelProxy "serifFontFamily"
settingsSerifFontFamily = AttrLabelProxy

settingsUserAgent :: AttrLabelProxy "userAgent"
settingsUserAgent = AttrLabelProxy

settingsZoomTextOnly :: AttrLabelProxy "zoomTextOnly"
settingsZoomTextOnly = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList Settings = SettingsSignalList
type SettingsSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

-- method Settings::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2", name = "Settings"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_new" webkit_settings_new :: 
    IO (Ptr Settings)

{- |
Creates a new 'GI.WebKit2.Objects.Settings.Settings' instance with default values. It must
be manually attached to a 'GI.WebKit2.Objects.WebView.WebView'.
See also @/webkit_settings_new_with_settings()/@.
-}
settingsNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m Settings
    {- ^ __Returns:__ a new 'GI.WebKit2.Objects.Settings.Settings' instance. -}
settingsNew  = liftIO $ do
    result <- webkit_settings_new
    checkUnexpectedReturnNULL "settingsNew" result
    result' <- (wrapObject Settings) result
    return result'

#if ENABLE_OVERLOADING
#endif

-- method Settings::get_allow_file_access_from_file_urls
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_allow_file_access_from_file_urls" webkit_settings_get_allow_file_access_from_file_urls :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/allow-file-access-from-file-urls/@ property.

/Since: 2.10/
-}
settingsGetAllowFileAccessFromFileUrls ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If file access from file URLs is allowed or 'False' otherwise. -}
settingsGetAllowFileAccessFromFileUrls settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_allow_file_access_from_file_urls settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetAllowFileAccessFromFileUrlsMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetAllowFileAccessFromFileUrlsMethodInfo a signature where
    overloadedMethod _ = settingsGetAllowFileAccessFromFileUrls

#endif

-- method Settings::get_allow_modal_dialogs
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_allow_modal_dialogs" webkit_settings_get_allow_modal_dialogs :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/allow-modal-dialogs/@ property.
-}
settingsGetAllowModalDialogs ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if it\'s allowed to create and run modal dialogs or 'False' otherwise. -}
settingsGetAllowModalDialogs settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_allow_modal_dialogs settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetAllowModalDialogsMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetAllowModalDialogsMethodInfo a signature where
    overloadedMethod _ = settingsGetAllowModalDialogs

#endif

-- method Settings::get_allow_universal_access_from_file_urls
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_allow_universal_access_from_file_urls" webkit_settings_get_allow_universal_access_from_file_urls :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/allow-universal-access-from-file-urls/@ property.

/Since: 2.14/
-}
settingsGetAllowUniversalAccessFromFileUrls ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If universal access from file URLs is allowed or 'False' otherwise. -}
settingsGetAllowUniversalAccessFromFileUrls settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_allow_universal_access_from_file_urls settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetAllowUniversalAccessFromFileUrlsMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetAllowUniversalAccessFromFileUrlsMethodInfo a signature where
    overloadedMethod _ = settingsGetAllowUniversalAccessFromFileUrls

#endif

-- method Settings::get_auto_load_images
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_auto_load_images" webkit_settings_get_auto_load_images :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/auto-load-images/@ property.
-}
settingsGetAutoLoadImages ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If auto loading of images is enabled or 'False' otherwise. -}
settingsGetAutoLoadImages settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_auto_load_images settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetAutoLoadImagesMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetAutoLoadImagesMethodInfo a signature where
    overloadedMethod _ = settingsGetAutoLoadImages

#endif

-- method Settings::get_cursive_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_cursive_font_family" webkit_settings_get_cursive_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/cursive-font-family/@ property.
-}
settingsGetCursiveFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ The default font family used to display content marked with cursive font. -}
settingsGetCursiveFontFamily settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_cursive_font_family settings'
    checkUnexpectedReturnNULL "settingsGetCursiveFontFamily" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetCursiveFontFamilyMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetCursiveFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsGetCursiveFontFamily

#endif

-- method Settings::get_default_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_default_charset" webkit_settings_get_default_charset :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/default-charset/@ property.
-}
settingsGetDefaultCharset ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ Default charset. -}
settingsGetDefaultCharset settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_default_charset settings'
    checkUnexpectedReturnNULL "settingsGetDefaultCharset" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetDefaultCharsetMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetDefaultCharsetMethodInfo a signature where
    overloadedMethod _ = settingsGetDefaultCharset

#endif

-- method Settings::get_default_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Nothing, sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_default_font_family" webkit_settings_get_default_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
/No description available in the introspection data./
-}
settingsGetDefaultFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    -> m T.Text
settingsGetDefaultFontFamily settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_default_font_family settings'
    checkUnexpectedReturnNULL "settingsGetDefaultFontFamily" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetDefaultFontFamilyMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetDefaultFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsGetDefaultFontFamily

#endif

-- method Settings::get_default_font_size
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt32)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_default_font_size" webkit_settings_get_default_font_size :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO Word32

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/default-font-size/@ property.
-}
settingsGetDefaultFontSize ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Word32
    {- ^ __Returns:__ The default font size, in pixels. -}
settingsGetDefaultFontSize settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_default_font_size settings'
    touchManagedPtr settings
    return result

#if ENABLE_OVERLOADING
data SettingsGetDefaultFontSizeMethodInfo
instance (signature ~ (m Word32), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetDefaultFontSizeMethodInfo a signature where
    overloadedMethod _ = settingsGetDefaultFontSize

#endif

-- method Settings::get_default_monospace_font_size
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt32)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_default_monospace_font_size" webkit_settings_get_default_monospace_font_size :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO Word32

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/default-monospace-font-size/@ property.
-}
settingsGetDefaultMonospaceFontSize ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Word32
    {- ^ __Returns:__ Default monospace font size, in pixels. -}
settingsGetDefaultMonospaceFontSize settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_default_monospace_font_size settings'
    touchManagedPtr settings
    return result

#if ENABLE_OVERLOADING
data SettingsGetDefaultMonospaceFontSizeMethodInfo
instance (signature ~ (m Word32), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetDefaultMonospaceFontSizeMethodInfo a signature where
    overloadedMethod _ = settingsGetDefaultMonospaceFontSize

#endif

-- method Settings::get_draw_compositing_indicators
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_draw_compositing_indicators" webkit_settings_get_draw_compositing_indicators :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/draw-compositing-indicators/@ property.
-}
settingsGetDrawCompositingIndicators ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If compositing borders are drawn or 'False' otherwise. -}
settingsGetDrawCompositingIndicators settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_draw_compositing_indicators settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetDrawCompositingIndicatorsMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetDrawCompositingIndicatorsMethodInfo a signature where
    overloadedMethod _ = settingsGetDrawCompositingIndicators

#endif

-- method Settings::get_enable_accelerated_2d_canvas
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_accelerated_2d_canvas" webkit_settings_get_enable_accelerated_2d_canvas :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-accelerated-2d-canvas/@ property.

/Since: 2.2/
-}
settingsGetEnableAccelerated2dCanvas ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if accelerated 2D canvas is enabled or 'False' otherwise. -}
settingsGetEnableAccelerated2dCanvas settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_accelerated_2d_canvas settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableAccelerated2dCanvasMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableAccelerated2dCanvasMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableAccelerated2dCanvas

#endif

-- method Settings::get_enable_back_forward_navigation_gestures
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_back_forward_navigation_gestures" webkit_settings_get_enable_back_forward_navigation_gestures :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-back-forward-navigation-gestures/@ property.

/Since: 2.24/
-}
settingsGetEnableBackForwardNavigationGestures ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if horizontal swipe gesture will trigger back-forward navigaiton or 'False' otherwise. -}
settingsGetEnableBackForwardNavigationGestures settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_back_forward_navigation_gestures settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableBackForwardNavigationGesturesMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableBackForwardNavigationGesturesMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableBackForwardNavigationGestures

#endif

-- method Settings::get_enable_caret_browsing
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_caret_browsing" webkit_settings_get_enable_caret_browsing :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-caret-browsing/@ property.
-}
settingsGetEnableCaretBrowsing ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If caret browsing is enabled or 'False' otherwise. -}
settingsGetEnableCaretBrowsing settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_caret_browsing settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableCaretBrowsingMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableCaretBrowsingMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableCaretBrowsing

#endif

-- method Settings::get_enable_developer_extras
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_developer_extras" webkit_settings_get_enable_developer_extras :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-developer-extras/@ property.
-}
settingsGetEnableDeveloperExtras ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If developer extras is enabled or 'False' otherwise. -}
settingsGetEnableDeveloperExtras settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_developer_extras settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableDeveloperExtrasMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableDeveloperExtrasMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableDeveloperExtras

#endif

-- method Settings::get_enable_dns_prefetching
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_dns_prefetching" webkit_settings_get_enable_dns_prefetching :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-dns-prefetching/@ property.
-}
settingsGetEnableDnsPrefetching ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If DNS prefetching is enabled or 'False' otherwise. -}
settingsGetEnableDnsPrefetching settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_dns_prefetching settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableDnsPrefetchingMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableDnsPrefetchingMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableDnsPrefetching

#endif

-- method Settings::get_enable_encrypted_media
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_encrypted_media" webkit_settings_get_enable_encrypted_media :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-encrypted-media/@ property.

/Since: 2.20/
-}
settingsGetEnableEncryptedMedia ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if EncryptedMedia support is enabled or 'False' otherwise. -}
settingsGetEnableEncryptedMedia settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_encrypted_media settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableEncryptedMediaMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableEncryptedMediaMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableEncryptedMedia

#endif

-- method Settings::get_enable_frame_flattening
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_frame_flattening" webkit_settings_get_enable_frame_flattening :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-frame-flattening/@ property.
-}
settingsGetEnableFrameFlattening ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If frame flattening is enabled or 'False' otherwise. -}
settingsGetEnableFrameFlattening settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_frame_flattening settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableFrameFlatteningMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableFrameFlatteningMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableFrameFlattening

#endif

-- method Settings::get_enable_fullscreen
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_fullscreen" webkit_settings_get_enable_fullscreen :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-fullscreen/@ property.
-}
settingsGetEnableFullscreen ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If fullscreen support is enabled or 'False' otherwise. -}
settingsGetEnableFullscreen settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_fullscreen settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableFullscreenMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableFullscreenMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableFullscreen

#endif

-- method Settings::get_enable_html5_database
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_html5_database" webkit_settings_get_enable_html5_database :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-html5-database/@ property.
-}
settingsGetEnableHtml5Database ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If HTML5 database support is enabled or 'False' otherwise. -}
settingsGetEnableHtml5Database settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_html5_database settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableHtml5DatabaseMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableHtml5DatabaseMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableHtml5Database

#endif

-- method Settings::get_enable_html5_local_storage
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_html5_local_storage" webkit_settings_get_enable_html5_local_storage :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-html5-local-storage/@ property.
-}
settingsGetEnableHtml5LocalStorage ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If HTML5 local storage support is enabled or 'False' otherwise. -}
settingsGetEnableHtml5LocalStorage settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_html5_local_storage settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableHtml5LocalStorageMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableHtml5LocalStorageMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableHtml5LocalStorage

#endif

-- method Settings::get_enable_hyperlink_auditing
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_hyperlink_auditing" webkit_settings_get_enable_hyperlink_auditing :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-hyperlink-auditing/@ property.
-}
settingsGetEnableHyperlinkAuditing ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If hyper link auditing is enabled or 'False' otherwise. -}
settingsGetEnableHyperlinkAuditing settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_hyperlink_auditing settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableHyperlinkAuditingMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableHyperlinkAuditingMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableHyperlinkAuditing

#endif

-- method Settings::get_enable_java
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_java" webkit_settings_get_enable_java :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-java/@ property.
-}
settingsGetEnableJava ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If Java is enabled or 'False' otherwise. -}
settingsGetEnableJava settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_java settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableJavaMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableJavaMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableJava

#endif

-- method Settings::get_enable_javascript
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_javascript" webkit_settings_get_enable_javascript :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-javascript/@ property.
-}
settingsGetEnableJavascript ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If JavaScript is enabled or 'False' otherwise. -}
settingsGetEnableJavascript settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_javascript settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableJavascriptMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableJavascriptMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableJavascript

#endif

-- method Settings::get_enable_javascript_markup
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_javascript_markup" webkit_settings_get_enable_javascript_markup :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-javascript-markup/@ property.

/Since: 2.24/
-}
settingsGetEnableJavascriptMarkup ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if JavaScript markup is enabled or 'False' otherwise. -}
settingsGetEnableJavascriptMarkup settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_javascript_markup settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableJavascriptMarkupMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableJavascriptMarkupMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableJavascriptMarkup

#endif

-- method Settings::get_enable_media_capabilities
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_media_capabilities" webkit_settings_get_enable_media_capabilities :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-media-capabilities/@ property.

/Since: 2.22/
-}
settingsGetEnableMediaCapabilities ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if MediaCapabilities support is enabled or 'False' otherwise. -}
settingsGetEnableMediaCapabilities settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_media_capabilities settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableMediaCapabilitiesMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableMediaCapabilitiesMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableMediaCapabilities

#endif

-- method Settings::get_enable_media_stream
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_media_stream" webkit_settings_get_enable_media_stream :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-media-stream/@ property.

/Since: 2.4/
-}
settingsGetEnableMediaStream ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If mediastream support is enabled or 'False' otherwise. -}
settingsGetEnableMediaStream settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_media_stream settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableMediaStreamMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableMediaStreamMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableMediaStream

#endif

-- method Settings::get_enable_mediasource
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_mediasource" webkit_settings_get_enable_mediasource :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-mediasource/@ property.

/Since: 2.4/
-}
settingsGetEnableMediasource ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If MediaSource support is enabled or 'False' otherwise. -}
settingsGetEnableMediasource settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_mediasource settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableMediasourceMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableMediasourceMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableMediasource

#endif

-- method Settings::get_enable_mock_capture_devices
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_mock_capture_devices" webkit_settings_get_enable_mock_capture_devices :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-mock-capture-devices/@ property.

/Since: 2.24/
-}
settingsGetEnableMockCaptureDevices ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If mock capture devices is enabled or 'False' otherwise. -}
settingsGetEnableMockCaptureDevices settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_mock_capture_devices settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableMockCaptureDevicesMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableMockCaptureDevicesMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableMockCaptureDevices

#endif

-- method Settings::get_enable_offline_web_application_cache
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_offline_web_application_cache" webkit_settings_get_enable_offline_web_application_cache :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-offline-web-application-cache/@ property.
-}
settingsGetEnableOfflineWebApplicationCache ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If HTML5 offline web application cache support is enabled or 'False' otherwise. -}
settingsGetEnableOfflineWebApplicationCache settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_offline_web_application_cache settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableOfflineWebApplicationCacheMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableOfflineWebApplicationCacheMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableOfflineWebApplicationCache

#endif

-- method Settings::get_enable_page_cache
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_page_cache" webkit_settings_get_enable_page_cache :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-page-cache/@ property.
-}
settingsGetEnablePageCache ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if page cache enabled or 'False' otherwise. -}
settingsGetEnablePageCache settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_page_cache settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnablePageCacheMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnablePageCacheMethodInfo a signature where
    overloadedMethod _ = settingsGetEnablePageCache

#endif

-- method Settings::get_enable_plugins
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_plugins" webkit_settings_get_enable_plugins :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-plugins/@ property.
-}
settingsGetEnablePlugins ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If plugins are enabled or 'False' otherwise. -}
settingsGetEnablePlugins settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_plugins settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnablePluginsMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnablePluginsMethodInfo a signature where
    overloadedMethod _ = settingsGetEnablePlugins

#endif

-- method Settings::get_enable_private_browsing
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_private_browsing" webkit_settings_get_enable_private_browsing :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{-# DEPRECATED settingsGetEnablePrivateBrowsing ["(Since version 2.16.)","Use 'GI.WebKit2.Objects.WebView.WebView':@/is-ephemeral/@ or 'GI.WebKit2.Objects.WebContext.WebContext':@/is-ephemeral/@ instead."] #-}
{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-private-browsing/@ property.
-}
settingsGetEnablePrivateBrowsing ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If private browsing is enabled or 'False' otherwise. -}
settingsGetEnablePrivateBrowsing settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_private_browsing settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnablePrivateBrowsingMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnablePrivateBrowsingMethodInfo a signature where
    overloadedMethod _ = settingsGetEnablePrivateBrowsing

#endif

-- method Settings::get_enable_resizable_text_areas
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_resizable_text_areas" webkit_settings_get_enable_resizable_text_areas :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-resizable-text-areas/@ property.
-}
settingsGetEnableResizableTextAreas ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If text areas can be resized or 'False' otherwise. -}
settingsGetEnableResizableTextAreas settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_resizable_text_areas settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableResizableTextAreasMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableResizableTextAreasMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableResizableTextAreas

#endif

-- method Settings::get_enable_site_specific_quirks
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_site_specific_quirks" webkit_settings_get_enable_site_specific_quirks :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-site-specific-quirks/@ property.
-}
settingsGetEnableSiteSpecificQuirks ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if site specific quirks are enabled or 'False' otherwise. -}
settingsGetEnableSiteSpecificQuirks settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_site_specific_quirks settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableSiteSpecificQuirksMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableSiteSpecificQuirksMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableSiteSpecificQuirks

#endif

-- method Settings::get_enable_smooth_scrolling
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_smooth_scrolling" webkit_settings_get_enable_smooth_scrolling :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-smooth-scrolling/@ property.
-}
settingsGetEnableSmoothScrolling ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if smooth scrolling is enabled or 'False' otherwise. -}
settingsGetEnableSmoothScrolling settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_smooth_scrolling settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableSmoothScrollingMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableSmoothScrollingMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableSmoothScrolling

#endif

-- method Settings::get_enable_spatial_navigation
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_spatial_navigation" webkit_settings_get_enable_spatial_navigation :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-spatial-navigation/@ property.

/Since: 2.2/
-}
settingsGetEnableSpatialNavigation ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If HTML5 spatial navigation support is enabled or 'False' otherwise. -}
settingsGetEnableSpatialNavigation settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_spatial_navigation settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableSpatialNavigationMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableSpatialNavigationMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableSpatialNavigation

#endif

-- method Settings::get_enable_tabs_to_links
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_tabs_to_links" webkit_settings_get_enable_tabs_to_links :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-tabs-to-links/@ property.
-}
settingsGetEnableTabsToLinks ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If tabs to link is enabled or 'False' otherwise. -}
settingsGetEnableTabsToLinks settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_tabs_to_links settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableTabsToLinksMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableTabsToLinksMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableTabsToLinks

#endif

-- method Settings::get_enable_webaudio
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_webaudio" webkit_settings_get_enable_webaudio :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-webaudio/@ property.
-}
settingsGetEnableWebaudio ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If webaudio support is enabled or 'False' otherwise. -}
settingsGetEnableWebaudio settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_webaudio settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableWebaudioMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableWebaudioMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableWebaudio

#endif

-- method Settings::get_enable_webgl
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_webgl" webkit_settings_get_enable_webgl :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-webgl/@ property.
-}
settingsGetEnableWebgl ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If WebGL support is enabled or 'False' otherwise. -}
settingsGetEnableWebgl settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_webgl settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableWebglMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableWebglMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableWebgl

#endif

-- method Settings::get_enable_write_console_messages_to_stdout
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_write_console_messages_to_stdout" webkit_settings_get_enable_write_console_messages_to_stdout :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-write-console-messages-to-stdout/@ property.

/Since: 2.2/
-}
settingsGetEnableWriteConsoleMessagesToStdout ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' if writing console messages to stdout is enabled or 'False'
otherwise. -}
settingsGetEnableWriteConsoleMessagesToStdout settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_write_console_messages_to_stdout settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableWriteConsoleMessagesToStdoutMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableWriteConsoleMessagesToStdoutMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableWriteConsoleMessagesToStdout

#endif

-- method Settings::get_enable_xss_auditor
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_enable_xss_auditor" webkit_settings_get_enable_xss_auditor :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/enable-xss-auditor/@ property.
-}
settingsGetEnableXssAuditor ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If XSS auditing is enabled or 'False' otherwise. -}
settingsGetEnableXssAuditor settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_enable_xss_auditor settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetEnableXssAuditorMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetEnableXssAuditorMethodInfo a signature where
    overloadedMethod _ = settingsGetEnableXssAuditor

#endif

-- method Settings::get_fantasy_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_fantasy_font_family" webkit_settings_get_fantasy_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/fantasy-font-family/@ property.
-}
settingsGetFantasyFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ The default font family used to display content marked with fantasy font. -}
settingsGetFantasyFontFamily settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_fantasy_font_family settings'
    checkUnexpectedReturnNULL "settingsGetFantasyFontFamily" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetFantasyFontFamilyMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetFantasyFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsGetFantasyFontFamily

#endif

-- method Settings::get_hardware_acceleration_policy
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "WebKit2", name = "HardwareAccelerationPolicy"}))
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_hardware_acceleration_policy" webkit_settings_get_hardware_acceleration_policy :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CUInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/hardware-acceleration-policy/@ property.

/Since: 2.16/
-}
settingsGetHardwareAccelerationPolicy ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m WebKit2.Enums.HardwareAccelerationPolicy
    {- ^ __Returns:__ a 'GI.WebKit2.Enums.HardwareAccelerationPolicy' -}
settingsGetHardwareAccelerationPolicy settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_hardware_acceleration_policy settings'
    let result' = (toEnum . fromIntegral) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetHardwareAccelerationPolicyMethodInfo
instance (signature ~ (m WebKit2.Enums.HardwareAccelerationPolicy), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetHardwareAccelerationPolicyMethodInfo a signature where
    overloadedMethod _ = settingsGetHardwareAccelerationPolicy

#endif

-- method Settings::get_javascript_can_access_clipboard
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_javascript_can_access_clipboard" webkit_settings_get_javascript_can_access_clipboard :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/javascript-can-access-clipboard/@ property.
-}
settingsGetJavascriptCanAccessClipboard ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If javascript-can-access-clipboard is enabled or 'False' otherwise. -}
settingsGetJavascriptCanAccessClipboard settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_javascript_can_access_clipboard settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetJavascriptCanAccessClipboardMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetJavascriptCanAccessClipboardMethodInfo a signature where
    overloadedMethod _ = settingsGetJavascriptCanAccessClipboard

#endif

-- method Settings::get_javascript_can_open_windows_automatically
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_javascript_can_open_windows_automatically" webkit_settings_get_javascript_can_open_windows_automatically :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/javascript-can-open-windows-automatically/@ property.
-}
settingsGetJavascriptCanOpenWindowsAutomatically ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If JavaScript can open window automatically or 'False' otherwise. -}
settingsGetJavascriptCanOpenWindowsAutomatically settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_javascript_can_open_windows_automatically settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetJavascriptCanOpenWindowsAutomaticallyMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetJavascriptCanOpenWindowsAutomaticallyMethodInfo a signature where
    overloadedMethod _ = settingsGetJavascriptCanOpenWindowsAutomatically

#endif

-- method Settings::get_load_icons_ignoring_image_load_setting
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_load_icons_ignoring_image_load_setting" webkit_settings_get_load_icons_ignoring_image_load_setting :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/load-icons-ignoring-image-load-setting/@ property.
-}
settingsGetLoadIconsIgnoringImageLoadSetting ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If site icon can be loaded irrespective of image loading preference or 'False' otherwise. -}
settingsGetLoadIconsIgnoringImageLoadSetting settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_load_icons_ignoring_image_load_setting settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetLoadIconsIgnoringImageLoadSettingMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetLoadIconsIgnoringImageLoadSettingMethodInfo a signature where
    overloadedMethod _ = settingsGetLoadIconsIgnoringImageLoadSetting

#endif

-- method Settings::get_media_playback_allows_inline
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_media_playback_allows_inline" webkit_settings_get_media_playback_allows_inline :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/media-playback-allows-inline/@ property.
-}
settingsGetMediaPlaybackAllowsInline ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If inline playback is allowed for media
   or 'False' if only fullscreen playback is allowed. -}
settingsGetMediaPlaybackAllowsInline settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_media_playback_allows_inline settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetMediaPlaybackAllowsInlineMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetMediaPlaybackAllowsInlineMethodInfo a signature where
    overloadedMethod _ = settingsGetMediaPlaybackAllowsInline

#endif

-- method Settings::get_media_playback_requires_user_gesture
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_media_playback_requires_user_gesture" webkit_settings_get_media_playback_requires_user_gesture :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/media-playback-requires-user-gesture/@ property.
-}
settingsGetMediaPlaybackRequiresUserGesture ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If an user gesture is needed to play or load media
   or 'False' if no user gesture is needed. -}
settingsGetMediaPlaybackRequiresUserGesture settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_media_playback_requires_user_gesture settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetMediaPlaybackRequiresUserGestureMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetMediaPlaybackRequiresUserGestureMethodInfo a signature where
    overloadedMethod _ = settingsGetMediaPlaybackRequiresUserGesture

#endif

-- method Settings::get_minimum_font_size
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt32)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_minimum_font_size" webkit_settings_get_minimum_font_size :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO Word32

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/minimum-font-size/@ property.
-}
settingsGetMinimumFontSize ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Word32
    {- ^ __Returns:__ Minimum font size, in pixels. -}
settingsGetMinimumFontSize settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_minimum_font_size settings'
    touchManagedPtr settings
    return result

#if ENABLE_OVERLOADING
data SettingsGetMinimumFontSizeMethodInfo
instance (signature ~ (m Word32), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetMinimumFontSizeMethodInfo a signature where
    overloadedMethod _ = settingsGetMinimumFontSize

#endif

-- method Settings::get_monospace_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_monospace_font_family" webkit_settings_get_monospace_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/monospace-font-family/@ property.
-}
settingsGetMonospaceFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ Default font family used to display content marked with monospace font. -}
settingsGetMonospaceFontFamily settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_monospace_font_family settings'
    checkUnexpectedReturnNULL "settingsGetMonospaceFontFamily" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetMonospaceFontFamilyMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetMonospaceFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsGetMonospaceFontFamily

#endif

-- method Settings::get_pictograph_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_pictograph_font_family" webkit_settings_get_pictograph_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/pictograph-font-family/@ property.
-}
settingsGetPictographFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ The default font family used to display content marked with pictograph font. -}
settingsGetPictographFontFamily settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_pictograph_font_family settings'
    checkUnexpectedReturnNULL "settingsGetPictographFontFamily" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetPictographFontFamilyMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetPictographFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsGetPictographFontFamily

#endif

-- method Settings::get_print_backgrounds
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_print_backgrounds" webkit_settings_get_print_backgrounds :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/print-backgrounds/@ property.
-}
settingsGetPrintBackgrounds ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If background images should be printed or 'False' otherwise. -}
settingsGetPrintBackgrounds settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_print_backgrounds settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetPrintBackgroundsMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetPrintBackgroundsMethodInfo a signature where
    overloadedMethod _ = settingsGetPrintBackgrounds

#endif

-- method Settings::get_sans_serif_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_sans_serif_font_family" webkit_settings_get_sans_serif_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/sans-serif-font-family/@ property.
-}
settingsGetSansSerifFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ The default font family used to display content marked with sans-serif font. -}
settingsGetSansSerifFontFamily settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_sans_serif_font_family settings'
    checkUnexpectedReturnNULL "settingsGetSansSerifFontFamily" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetSansSerifFontFamilyMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetSansSerifFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsGetSansSerifFontFamily

#endif

-- method Settings::get_serif_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_serif_font_family" webkit_settings_get_serif_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Gets the 'GI.WebKit2.Objects.Settings.Settings':@/serif-font-family/@ property.
-}
settingsGetSerifFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ The default font family used to display content marked with serif font. -}
settingsGetSerifFontFamily settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_serif_font_family settings'
    checkUnexpectedReturnNULL "settingsGetSerifFontFamily" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetSerifFontFamilyMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetSerifFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsGetSerifFontFamily

#endif

-- method Settings::get_user_agent
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_user_agent" webkit_settings_get_user_agent :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CString

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/user-agent/@ property.
-}
settingsGetUserAgent ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m T.Text
    {- ^ __Returns:__ The current value of the user-agent property. -}
settingsGetUserAgent settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_user_agent settings'
    checkUnexpectedReturnNULL "settingsGetUserAgent" result
    result' <- cstringToText result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetUserAgentMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetUserAgentMethodInfo a signature where
    overloadedMethod _ = settingsGetUserAgent

#endif

-- method Settings::get_zoom_text_only
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_get_zoom_text_only" webkit_settings_get_zoom_text_only :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    IO CInt

{- |
Get the 'GI.WebKit2.Objects.Settings.Settings':@/zoom-text-only/@ property.
-}
settingsGetZoomTextOnly ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> m Bool
    {- ^ __Returns:__ 'True' If zoom level of the view should only affect the text
   or 'False' if all view contents should be scaled. -}
settingsGetZoomTextOnly settings = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    result <- webkit_settings_get_zoom_text_only settings'
    let result' = (/= 0) result
    touchManagedPtr settings
    return result'

#if ENABLE_OVERLOADING
data SettingsGetZoomTextOnlyMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsSettings a) => O.MethodInfo SettingsGetZoomTextOnlyMethodInfo a signature where
    overloadedMethod _ = settingsGetZoomTextOnly

#endif

-- method Settings::set_allow_file_access_from_file_urls
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "allowed", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_allow_file_access_from_file_urls" webkit_settings_set_allow_file_access_from_file_urls :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- allowed : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/allow-file-access-from-file-urls/@ property.

/Since: 2.10/
-}
settingsSetAllowFileAccessFromFileUrls ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@allowed@/: Value to be set -}
    -> m ()
settingsSetAllowFileAccessFromFileUrls settings allowed = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let allowed' = (fromIntegral . fromEnum) allowed
    webkit_settings_set_allow_file_access_from_file_urls settings' allowed'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetAllowFileAccessFromFileUrlsMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetAllowFileAccessFromFileUrlsMethodInfo a signature where
    overloadedMethod _ = settingsSetAllowFileAccessFromFileUrls

#endif

-- method Settings::set_allow_modal_dialogs
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "allowed", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_allow_modal_dialogs" webkit_settings_set_allow_modal_dialogs :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- allowed : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/allow-modal-dialogs/@ property.
-}
settingsSetAllowModalDialogs ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@allowed@/: Value to be set -}
    -> m ()
settingsSetAllowModalDialogs settings allowed = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let allowed' = (fromIntegral . fromEnum) allowed
    webkit_settings_set_allow_modal_dialogs settings' allowed'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetAllowModalDialogsMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetAllowModalDialogsMethodInfo a signature where
    overloadedMethod _ = settingsSetAllowModalDialogs

#endif

-- method Settings::set_allow_universal_access_from_file_urls
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "allowed", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_allow_universal_access_from_file_urls" webkit_settings_set_allow_universal_access_from_file_urls :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- allowed : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/allow-universal-access-from-file-urls/@ property.

/Since: 2.14/
-}
settingsSetAllowUniversalAccessFromFileUrls ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@allowed@/: Value to be set -}
    -> m ()
settingsSetAllowUniversalAccessFromFileUrls settings allowed = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let allowed' = (fromIntegral . fromEnum) allowed
    webkit_settings_set_allow_universal_access_from_file_urls settings' allowed'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetAllowUniversalAccessFromFileUrlsMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetAllowUniversalAccessFromFileUrlsMethodInfo a signature where
    overloadedMethod _ = settingsSetAllowUniversalAccessFromFileUrls

#endif

-- method Settings::set_auto_load_images
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_auto_load_images" webkit_settings_set_auto_load_images :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/auto-load-images/@ property.
-}
settingsSetAutoLoadImages ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetAutoLoadImages settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_auto_load_images settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetAutoLoadImagesMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetAutoLoadImagesMethodInfo a signature where
    overloadedMethod _ = settingsSetAutoLoadImages

#endif

-- method Settings::set_cursive_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "cursive_font_family", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the new default cursive font family", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_cursive_font_family" webkit_settings_set_cursive_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- cursive_font_family : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/cursive-font-family/@ property.
-}
settingsSetCursiveFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@cursiveFontFamily@/: the new default cursive font family -}
    -> m ()
settingsSetCursiveFontFamily settings cursiveFontFamily = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    cursiveFontFamily' <- textToCString cursiveFontFamily
    webkit_settings_set_cursive_font_family settings' cursiveFontFamily'
    touchManagedPtr settings
    freeMem cursiveFontFamily'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetCursiveFontFamilyMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetCursiveFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsSetCursiveFontFamily

#endif

-- method Settings::set_default_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "default_charset", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "default charset to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_default_charset" webkit_settings_set_default_charset :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- default_charset : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/default-charset/@ property.
-}
settingsSetDefaultCharset ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@defaultCharset@/: default charset to be set -}
    -> m ()
settingsSetDefaultCharset settings defaultCharset = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    defaultCharset' <- textToCString defaultCharset
    webkit_settings_set_default_charset settings' defaultCharset'
    touchManagedPtr settings
    freeMem defaultCharset'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetDefaultCharsetMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetDefaultCharsetMethodInfo a signature where
    overloadedMethod _ = settingsSetDefaultCharset

#endif

-- method Settings::set_default_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "default_font_family", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the new default font family", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_default_font_family" webkit_settings_set_default_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- default_font_family : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/default-font-family/@ property.
-}
settingsSetDefaultFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@defaultFontFamily@/: the new default font family -}
    -> m ()
settingsSetDefaultFontFamily settings defaultFontFamily = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    defaultFontFamily' <- textToCString defaultFontFamily
    webkit_settings_set_default_font_family settings' defaultFontFamily'
    touchManagedPtr settings
    freeMem defaultFontFamily'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetDefaultFontFamilyMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetDefaultFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsSetDefaultFontFamily

#endif

-- method Settings::set_default_font_size
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "font_size", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "default font size to be set in pixels", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_default_font_size" webkit_settings_set_default_font_size :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    Word32 ->                               -- font_size : TBasicType TUInt32
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/default-font-size/@ property.
-}
settingsSetDefaultFontSize ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Word32
    {- ^ /@fontSize@/: default font size to be set in pixels -}
    -> m ()
settingsSetDefaultFontSize settings fontSize = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    webkit_settings_set_default_font_size settings' fontSize
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetDefaultFontSizeMethodInfo
instance (signature ~ (Word32 -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetDefaultFontSizeMethodInfo a signature where
    overloadedMethod _ = settingsSetDefaultFontSize

#endif

-- method Settings::set_default_monospace_font_size
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "font_size", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "default monospace font size to be set in pixels", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_default_monospace_font_size" webkit_settings_set_default_monospace_font_size :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    Word32 ->                               -- font_size : TBasicType TUInt32
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/default-monospace-font-size/@ property.
-}
settingsSetDefaultMonospaceFontSize ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Word32
    {- ^ /@fontSize@/: default monospace font size to be set in pixels -}
    -> m ()
settingsSetDefaultMonospaceFontSize settings fontSize = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    webkit_settings_set_default_monospace_font_size settings' fontSize
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetDefaultMonospaceFontSizeMethodInfo
instance (signature ~ (Word32 -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetDefaultMonospaceFontSizeMethodInfo a signature where
    overloadedMethod _ = settingsSetDefaultMonospaceFontSize

#endif

-- method Settings::set_draw_compositing_indicators
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_draw_compositing_indicators" webkit_settings_set_draw_compositing_indicators :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/draw-compositing-indicators/@ property.
-}
settingsSetDrawCompositingIndicators ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetDrawCompositingIndicators settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_draw_compositing_indicators settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetDrawCompositingIndicatorsMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetDrawCompositingIndicatorsMethodInfo a signature where
    overloadedMethod _ = settingsSetDrawCompositingIndicators

#endif

-- method Settings::set_enable_accelerated_2d_canvas
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_accelerated_2d_canvas" webkit_settings_set_enable_accelerated_2d_canvas :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-accelerated-2d-canvas/@ property.

/Since: 2.2/
-}
settingsSetEnableAccelerated2dCanvas ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableAccelerated2dCanvas settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_accelerated_2d_canvas settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableAccelerated2dCanvasMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableAccelerated2dCanvasMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableAccelerated2dCanvas

#endif

-- method Settings::set_enable_back_forward_navigation_gestures
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_back_forward_navigation_gestures" webkit_settings_set_enable_back_forward_navigation_gestures :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-back-forward-navigation-gestures/@ property.

/Since: 2.24/
-}
settingsSetEnableBackForwardNavigationGestures ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: value to be set -}
    -> m ()
settingsSetEnableBackForwardNavigationGestures settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_back_forward_navigation_gestures settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableBackForwardNavigationGesturesMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableBackForwardNavigationGesturesMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableBackForwardNavigationGestures

#endif

-- method Settings::set_enable_caret_browsing
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_caret_browsing" webkit_settings_set_enable_caret_browsing :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-caret-browsing/@ property.
-}
settingsSetEnableCaretBrowsing ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableCaretBrowsing settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_caret_browsing settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableCaretBrowsingMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableCaretBrowsingMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableCaretBrowsing

#endif

-- method Settings::set_enable_developer_extras
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_developer_extras" webkit_settings_set_enable_developer_extras :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-developer-extras/@ property.
-}
settingsSetEnableDeveloperExtras ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableDeveloperExtras settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_developer_extras settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableDeveloperExtrasMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableDeveloperExtrasMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableDeveloperExtras

#endif

-- method Settings::set_enable_dns_prefetching
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_dns_prefetching" webkit_settings_set_enable_dns_prefetching :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-dns-prefetching/@ property.
-}
settingsSetEnableDnsPrefetching ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableDnsPrefetching settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_dns_prefetching settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableDnsPrefetchingMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableDnsPrefetchingMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableDnsPrefetching

#endif

-- method Settings::set_enable_encrypted_media
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_encrypted_media" webkit_settings_set_enable_encrypted_media :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-encrypted-media/@ property.

/Since: 2.20/
-}
settingsSetEnableEncryptedMedia ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableEncryptedMedia settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_encrypted_media settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableEncryptedMediaMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableEncryptedMediaMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableEncryptedMedia

#endif

-- method Settings::set_enable_frame_flattening
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_frame_flattening" webkit_settings_set_enable_frame_flattening :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-frame-flattening/@ property.
-}
settingsSetEnableFrameFlattening ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableFrameFlattening settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_frame_flattening settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableFrameFlatteningMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableFrameFlatteningMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableFrameFlattening

#endif

-- method Settings::set_enable_fullscreen
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_fullscreen" webkit_settings_set_enable_fullscreen :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-fullscreen/@ property.
-}
settingsSetEnableFullscreen ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableFullscreen settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_fullscreen settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableFullscreenMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableFullscreenMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableFullscreen

#endif

-- method Settings::set_enable_html5_database
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_html5_database" webkit_settings_set_enable_html5_database :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-html5-database/@ property.
-}
settingsSetEnableHtml5Database ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableHtml5Database settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_html5_database settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableHtml5DatabaseMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableHtml5DatabaseMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableHtml5Database

#endif

-- method Settings::set_enable_html5_local_storage
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_html5_local_storage" webkit_settings_set_enable_html5_local_storage :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-html5-local-storage/@ property.
-}
settingsSetEnableHtml5LocalStorage ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableHtml5LocalStorage settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_html5_local_storage settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableHtml5LocalStorageMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableHtml5LocalStorageMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableHtml5LocalStorage

#endif

-- method Settings::set_enable_hyperlink_auditing
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_hyperlink_auditing" webkit_settings_set_enable_hyperlink_auditing :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-hyperlink-auditing/@ property.
-}
settingsSetEnableHyperlinkAuditing ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableHyperlinkAuditing settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_hyperlink_auditing settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableHyperlinkAuditingMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableHyperlinkAuditingMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableHyperlinkAuditing

#endif

-- method Settings::set_enable_java
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_java" webkit_settings_set_enable_java :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-java/@ property.
-}
settingsSetEnableJava ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableJava settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_java settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableJavaMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableJavaMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableJava

#endif

-- method Settings::set_enable_javascript
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_javascript" webkit_settings_set_enable_javascript :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-javascript/@ property.
-}
settingsSetEnableJavascript ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableJavascript settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_javascript settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableJavascriptMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableJavascriptMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableJavascript

#endif

-- method Settings::set_enable_javascript_markup
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_javascript_markup" webkit_settings_set_enable_javascript_markup :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-javascript-markup/@ property.

/Since: 2.24/
-}
settingsSetEnableJavascriptMarkup ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableJavascriptMarkup settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_javascript_markup settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableJavascriptMarkupMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableJavascriptMarkupMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableJavascriptMarkup

#endif

-- method Settings::set_enable_media_capabilities
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_media_capabilities" webkit_settings_set_enable_media_capabilities :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-media-capabilities/@ property.

/Since: 2.22/
-}
settingsSetEnableMediaCapabilities ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableMediaCapabilities settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_media_capabilities settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableMediaCapabilitiesMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableMediaCapabilitiesMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableMediaCapabilities

#endif

-- method Settings::set_enable_media_stream
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_media_stream" webkit_settings_set_enable_media_stream :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-media-stream/@ property.

/Since: 2.4/
-}
settingsSetEnableMediaStream ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableMediaStream settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_media_stream settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableMediaStreamMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableMediaStreamMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableMediaStream

#endif

-- method Settings::set_enable_mediasource
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_mediasource" webkit_settings_set_enable_mediasource :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-mediasource/@ property.

/Since: 2.4/
-}
settingsSetEnableMediasource ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableMediasource settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_mediasource settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableMediasourceMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableMediasourceMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableMediasource

#endif

-- method Settings::set_enable_mock_capture_devices
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_mock_capture_devices" webkit_settings_set_enable_mock_capture_devices :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-mock-capture-devices/@ property.

/Since: 2.4/
-}
settingsSetEnableMockCaptureDevices ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableMockCaptureDevices settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_mock_capture_devices settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableMockCaptureDevicesMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableMockCaptureDevicesMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableMockCaptureDevices

#endif

-- method Settings::set_enable_offline_web_application_cache
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_offline_web_application_cache" webkit_settings_set_enable_offline_web_application_cache :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-offline-web-application-cache/@ property.
-}
settingsSetEnableOfflineWebApplicationCache ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableOfflineWebApplicationCache settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_offline_web_application_cache settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableOfflineWebApplicationCacheMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableOfflineWebApplicationCacheMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableOfflineWebApplicationCache

#endif

-- method Settings::set_enable_page_cache
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_page_cache" webkit_settings_set_enable_page_cache :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-page-cache/@ property.
-}
settingsSetEnablePageCache ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnablePageCache settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_page_cache settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnablePageCacheMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnablePageCacheMethodInfo a signature where
    overloadedMethod _ = settingsSetEnablePageCache

#endif

-- method Settings::set_enable_plugins
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_plugins" webkit_settings_set_enable_plugins :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-plugins/@ property.
-}
settingsSetEnablePlugins ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnablePlugins settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_plugins settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnablePluginsMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnablePluginsMethodInfo a signature where
    overloadedMethod _ = settingsSetEnablePlugins

#endif

-- method Settings::set_enable_private_browsing
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_private_browsing" webkit_settings_set_enable_private_browsing :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{-# DEPRECATED settingsSetEnablePrivateBrowsing ["(Since version 2.16.)","Use 'GI.WebKit2.Objects.WebView.WebView':@/is-ephemeral/@ or 'GI.WebKit2.Objects.WebContext.WebContext':@/is-ephemeral/@ instead."] #-}
{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-private-browsing/@ property.
-}
settingsSetEnablePrivateBrowsing ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnablePrivateBrowsing settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_private_browsing settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnablePrivateBrowsingMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnablePrivateBrowsingMethodInfo a signature where
    overloadedMethod _ = settingsSetEnablePrivateBrowsing

#endif

-- method Settings::set_enable_resizable_text_areas
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_resizable_text_areas" webkit_settings_set_enable_resizable_text_areas :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-resizable-text-areas/@ property.
-}
settingsSetEnableResizableTextAreas ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableResizableTextAreas settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_resizable_text_areas settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableResizableTextAreasMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableResizableTextAreasMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableResizableTextAreas

#endif

-- method Settings::set_enable_site_specific_quirks
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_site_specific_quirks" webkit_settings_set_enable_site_specific_quirks :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-site-specific-quirks/@ property.
-}
settingsSetEnableSiteSpecificQuirks ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableSiteSpecificQuirks settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_site_specific_quirks settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableSiteSpecificQuirksMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableSiteSpecificQuirksMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableSiteSpecificQuirks

#endif

-- method Settings::set_enable_smooth_scrolling
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_smooth_scrolling" webkit_settings_set_enable_smooth_scrolling :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-smooth-scrolling/@ property.
-}
settingsSetEnableSmoothScrolling ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableSmoothScrolling settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_smooth_scrolling settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableSmoothScrollingMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableSmoothScrollingMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableSmoothScrolling

#endif

-- method Settings::set_enable_spatial_navigation
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_spatial_navigation" webkit_settings_set_enable_spatial_navigation :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-spatial-navigation/@ property.

/Since: 2.2/
-}
settingsSetEnableSpatialNavigation ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableSpatialNavigation settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_spatial_navigation settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableSpatialNavigationMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableSpatialNavigationMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableSpatialNavigation

#endif

-- method Settings::set_enable_tabs_to_links
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_tabs_to_links" webkit_settings_set_enable_tabs_to_links :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-tabs-to-links/@ property.
-}
settingsSetEnableTabsToLinks ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableTabsToLinks settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_tabs_to_links settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableTabsToLinksMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableTabsToLinksMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableTabsToLinks

#endif

-- method Settings::set_enable_webaudio
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_webaudio" webkit_settings_set_enable_webaudio :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-webaudio/@ property.
-}
settingsSetEnableWebaudio ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableWebaudio settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_webaudio settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableWebaudioMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableWebaudioMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableWebaudio

#endif

-- method Settings::set_enable_webgl
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_webgl" webkit_settings_set_enable_webgl :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-webgl/@ property.
-}
settingsSetEnableWebgl ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableWebgl settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_webgl settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableWebglMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableWebglMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableWebgl

#endif

-- method Settings::set_enable_write_console_messages_to_stdout
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_write_console_messages_to_stdout" webkit_settings_set_enable_write_console_messages_to_stdout :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-write-console-messages-to-stdout/@ property.

/Since: 2.2/
-}
settingsSetEnableWriteConsoleMessagesToStdout ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableWriteConsoleMessagesToStdout settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_write_console_messages_to_stdout settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableWriteConsoleMessagesToStdoutMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableWriteConsoleMessagesToStdoutMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableWriteConsoleMessagesToStdout

#endif

-- method Settings::set_enable_xss_auditor
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_enable_xss_auditor" webkit_settings_set_enable_xss_auditor :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/enable-xss-auditor/@ property.
-}
settingsSetEnableXssAuditor ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetEnableXssAuditor settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_enable_xss_auditor settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetEnableXssAuditorMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetEnableXssAuditorMethodInfo a signature where
    overloadedMethod _ = settingsSetEnableXssAuditor

#endif

-- method Settings::set_fantasy_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "fantasy_font_family", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the new default fantasy font family", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_fantasy_font_family" webkit_settings_set_fantasy_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- fantasy_font_family : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/fantasy-font-family/@ property.
-}
settingsSetFantasyFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@fantasyFontFamily@/: the new default fantasy font family -}
    -> m ()
settingsSetFantasyFontFamily settings fantasyFontFamily = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    fantasyFontFamily' <- textToCString fantasyFontFamily
    webkit_settings_set_fantasy_font_family settings' fantasyFontFamily'
    touchManagedPtr settings
    freeMem fantasyFontFamily'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetFantasyFontFamilyMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetFantasyFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsSetFantasyFontFamily

#endif

-- method Settings::set_hardware_acceleration_policy
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "policy", argType = TInterface (Name {namespace = "WebKit2", name = "HardwareAccelerationPolicy"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitHardwareAccelerationPolicy", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_hardware_acceleration_policy" webkit_settings_set_hardware_acceleration_policy :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CUInt ->                                -- policy : TInterface (Name {namespace = "WebKit2", name = "HardwareAccelerationPolicy"})
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/hardware-acceleration-policy/@ property.

/Since: 2.16/
-}
settingsSetHardwareAccelerationPolicy ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> WebKit2.Enums.HardwareAccelerationPolicy
    {- ^ /@policy@/: a 'GI.WebKit2.Enums.HardwareAccelerationPolicy' -}
    -> m ()
settingsSetHardwareAccelerationPolicy settings policy = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let policy' = (fromIntegral . fromEnum) policy
    webkit_settings_set_hardware_acceleration_policy settings' policy'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetHardwareAccelerationPolicyMethodInfo
instance (signature ~ (WebKit2.Enums.HardwareAccelerationPolicy -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetHardwareAccelerationPolicyMethodInfo a signature where
    overloadedMethod _ = settingsSetHardwareAccelerationPolicy

#endif

-- method Settings::set_javascript_can_access_clipboard
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_javascript_can_access_clipboard" webkit_settings_set_javascript_can_access_clipboard :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/javascript-can-access-clipboard/@ property.
-}
settingsSetJavascriptCanAccessClipboard ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetJavascriptCanAccessClipboard settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_javascript_can_access_clipboard settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetJavascriptCanAccessClipboardMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetJavascriptCanAccessClipboardMethodInfo a signature where
    overloadedMethod _ = settingsSetJavascriptCanAccessClipboard

#endif

-- method Settings::set_javascript_can_open_windows_automatically
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_javascript_can_open_windows_automatically" webkit_settings_set_javascript_can_open_windows_automatically :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/javascript-can-open-windows-automatically/@ property.
-}
settingsSetJavascriptCanOpenWindowsAutomatically ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetJavascriptCanOpenWindowsAutomatically settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_javascript_can_open_windows_automatically settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetJavascriptCanOpenWindowsAutomaticallyMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetJavascriptCanOpenWindowsAutomaticallyMethodInfo a signature where
    overloadedMethod _ = settingsSetJavascriptCanOpenWindowsAutomatically

#endif

-- method Settings::set_load_icons_ignoring_image_load_setting
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_load_icons_ignoring_image_load_setting" webkit_settings_set_load_icons_ignoring_image_load_setting :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/load-icons-ignoring-image-load-setting/@ property.
-}
settingsSetLoadIconsIgnoringImageLoadSetting ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetLoadIconsIgnoringImageLoadSetting settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_load_icons_ignoring_image_load_setting settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetLoadIconsIgnoringImageLoadSettingMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetLoadIconsIgnoringImageLoadSettingMethodInfo a signature where
    overloadedMethod _ = settingsSetLoadIconsIgnoringImageLoadSetting

#endif

-- method Settings::set_media_playback_allows_inline
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_media_playback_allows_inline" webkit_settings_set_media_playback_allows_inline :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/media-playback-allows-inline/@ property.
-}
settingsSetMediaPlaybackAllowsInline ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetMediaPlaybackAllowsInline settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_media_playback_allows_inline settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetMediaPlaybackAllowsInlineMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetMediaPlaybackAllowsInlineMethodInfo a signature where
    overloadedMethod _ = settingsSetMediaPlaybackAllowsInline

#endif

-- method Settings::set_media_playback_requires_user_gesture
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enabled", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_media_playback_requires_user_gesture" webkit_settings_set_media_playback_requires_user_gesture :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- enabled : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/media-playback-requires-user-gesture/@ property.
-}
settingsSetMediaPlaybackRequiresUserGesture ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@enabled@/: Value to be set -}
    -> m ()
settingsSetMediaPlaybackRequiresUserGesture settings enabled = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let enabled' = (fromIntegral . fromEnum) enabled
    webkit_settings_set_media_playback_requires_user_gesture settings' enabled'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetMediaPlaybackRequiresUserGestureMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetMediaPlaybackRequiresUserGestureMethodInfo a signature where
    overloadedMethod _ = settingsSetMediaPlaybackRequiresUserGesture

#endif

-- method Settings::set_minimum_font_size
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "font_size", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "minimum font size to be set in pixels", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_minimum_font_size" webkit_settings_set_minimum_font_size :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    Word32 ->                               -- font_size : TBasicType TUInt32
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/minimum-font-size/@ property.
-}
settingsSetMinimumFontSize ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Word32
    {- ^ /@fontSize@/: minimum font size to be set in pixels -}
    -> m ()
settingsSetMinimumFontSize settings fontSize = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    webkit_settings_set_minimum_font_size settings' fontSize
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetMinimumFontSizeMethodInfo
instance (signature ~ (Word32 -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetMinimumFontSizeMethodInfo a signature where
    overloadedMethod _ = settingsSetMinimumFontSize

#endif

-- method Settings::set_monospace_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "monospace_font_family", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the new default monospace font family", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_monospace_font_family" webkit_settings_set_monospace_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- monospace_font_family : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/monospace-font-family/@ property.
-}
settingsSetMonospaceFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@monospaceFontFamily@/: the new default monospace font family -}
    -> m ()
settingsSetMonospaceFontFamily settings monospaceFontFamily = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    monospaceFontFamily' <- textToCString monospaceFontFamily
    webkit_settings_set_monospace_font_family settings' monospaceFontFamily'
    touchManagedPtr settings
    freeMem monospaceFontFamily'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetMonospaceFontFamilyMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetMonospaceFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsSetMonospaceFontFamily

#endif

-- method Settings::set_pictograph_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "pictograph_font_family", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the new default pictograph font family", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_pictograph_font_family" webkit_settings_set_pictograph_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- pictograph_font_family : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/pictograph-font-family/@ property.
-}
settingsSetPictographFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@pictographFontFamily@/: the new default pictograph font family -}
    -> m ()
settingsSetPictographFontFamily settings pictographFontFamily = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    pictographFontFamily' <- textToCString pictographFontFamily
    webkit_settings_set_pictograph_font_family settings' pictographFontFamily'
    touchManagedPtr settings
    freeMem pictographFontFamily'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetPictographFontFamilyMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetPictographFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsSetPictographFontFamily

#endif

-- method Settings::set_print_backgrounds
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "print_backgrounds", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_print_backgrounds" webkit_settings_set_print_backgrounds :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- print_backgrounds : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/print-backgrounds/@ property.
-}
settingsSetPrintBackgrounds ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@printBackgrounds@/: Value to be set -}
    -> m ()
settingsSetPrintBackgrounds settings printBackgrounds = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let printBackgrounds' = (fromIntegral . fromEnum) printBackgrounds
    webkit_settings_set_print_backgrounds settings' printBackgrounds'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetPrintBackgroundsMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetPrintBackgroundsMethodInfo a signature where
    overloadedMethod _ = settingsSetPrintBackgrounds

#endif

-- method Settings::set_sans_serif_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "sans_serif_font_family", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the new default sans-serif font family", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_sans_serif_font_family" webkit_settings_set_sans_serif_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- sans_serif_font_family : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/sans-serif-font-family/@ property.
-}
settingsSetSansSerifFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@sansSerifFontFamily@/: the new default sans-serif font family -}
    -> m ()
settingsSetSansSerifFontFamily settings sansSerifFontFamily = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    sansSerifFontFamily' <- textToCString sansSerifFontFamily
    webkit_settings_set_sans_serif_font_family settings' sansSerifFontFamily'
    touchManagedPtr settings
    freeMem sansSerifFontFamily'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetSansSerifFontFamilyMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetSansSerifFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsSetSansSerifFontFamily

#endif

-- method Settings::set_serif_font_family
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "serif_font_family", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the new default serif font family", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_serif_font_family" webkit_settings_set_serif_font_family :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- serif_font_family : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/serif-font-family/@ property.
-}
settingsSetSerifFontFamily ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> T.Text
    {- ^ /@serifFontFamily@/: the new default serif font family -}
    -> m ()
settingsSetSerifFontFamily settings serifFontFamily = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    serifFontFamily' <- textToCString serifFontFamily
    webkit_settings_set_serif_font_family settings' serifFontFamily'
    touchManagedPtr settings
    freeMem serifFontFamily'
    return ()

#if ENABLE_OVERLOADING
data SettingsSetSerifFontFamilyMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetSerifFontFamilyMethodInfo a signature where
    overloadedMethod _ = settingsSetSerifFontFamily

#endif

-- method Settings::set_user_agent
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "user_agent", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "The new custom user agent string or %NULL to use the default user agent", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_user_agent" webkit_settings_set_user_agent :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- user_agent : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/user-agent/@ property.
-}
settingsSetUserAgent ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Maybe (T.Text)
    {- ^ /@userAgent@/: The new custom user agent string or 'Nothing' to use the default user agent -}
    -> m ()
settingsSetUserAgent settings userAgent = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    maybeUserAgent <- case userAgent of
        Nothing -> return nullPtr
        Just jUserAgent -> do
            jUserAgent' <- textToCString jUserAgent
            return jUserAgent'
    webkit_settings_set_user_agent settings' maybeUserAgent
    touchManagedPtr settings
    freeMem maybeUserAgent
    return ()

#if ENABLE_OVERLOADING
data SettingsSetUserAgentMethodInfo
instance (signature ~ (Maybe (T.Text) -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetUserAgentMethodInfo a signature where
    overloadedMethod _ = settingsSetUserAgent

#endif

-- method Settings::set_user_agent_with_application_details
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "application_name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "The application name used for the user agent or %NULL to use the default user agent.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "application_version", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "The application version for the user agent or %NULL to user the default version.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_user_agent_with_application_details" webkit_settings_set_user_agent_with_application_details :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CString ->                              -- application_name : TBasicType TUTF8
    CString ->                              -- application_version : TBasicType TUTF8
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/user-agent/@ property by appending the application details to the default user
agent. If no application name or version is given, the default user agent used will be used. If only
the version is given, the default engine version is used with the given application name.
-}
settingsSetUserAgentWithApplicationDetails ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Maybe (T.Text)
    {- ^ /@applicationName@/: The application name used for the user agent or 'Nothing' to use the default user agent. -}
    -> Maybe (T.Text)
    {- ^ /@applicationVersion@/: The application version for the user agent or 'Nothing' to user the default version. -}
    -> m ()
settingsSetUserAgentWithApplicationDetails settings applicationName applicationVersion = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    maybeApplicationName <- case applicationName of
        Nothing -> return nullPtr
        Just jApplicationName -> do
            jApplicationName' <- textToCString jApplicationName
            return jApplicationName'
    maybeApplicationVersion <- case applicationVersion of
        Nothing -> return nullPtr
        Just jApplicationVersion -> do
            jApplicationVersion' <- textToCString jApplicationVersion
            return jApplicationVersion'
    webkit_settings_set_user_agent_with_application_details settings' maybeApplicationName maybeApplicationVersion
    touchManagedPtr settings
    freeMem maybeApplicationName
    freeMem maybeApplicationVersion
    return ()

#if ENABLE_OVERLOADING
data SettingsSetUserAgentWithApplicationDetailsMethodInfo
instance (signature ~ (Maybe (T.Text) -> Maybe (T.Text) -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetUserAgentWithApplicationDetailsMethodInfo a signature where
    overloadedMethod _ = settingsSetUserAgentWithApplicationDetails

#endif

-- method Settings::set_zoom_text_only
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "settings", argType = TInterface (Name {namespace = "WebKit2", name = "Settings"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #WebKitSettings", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "zoom_text_only", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Value to be set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_set_zoom_text_only" webkit_settings_set_zoom_text_only :: 
    Ptr Settings ->                         -- settings : TInterface (Name {namespace = "WebKit2", name = "Settings"})
    CInt ->                                 -- zoom_text_only : TBasicType TBoolean
    IO ()

{- |
Set the 'GI.WebKit2.Objects.Settings.Settings':@/zoom-text-only/@ property.
-}
settingsSetZoomTextOnly ::
    (B.CallStack.HasCallStack, MonadIO m, IsSettings a) =>
    a
    {- ^ /@settings@/: a 'GI.WebKit2.Objects.Settings.Settings' -}
    -> Bool
    {- ^ /@zoomTextOnly@/: Value to be set -}
    -> m ()
settingsSetZoomTextOnly settings zoomTextOnly = liftIO $ do
    settings' <- unsafeManagedPtrCastPtr settings
    let zoomTextOnly' = (fromIntegral . fromEnum) zoomTextOnly
    webkit_settings_set_zoom_text_only settings' zoomTextOnly'
    touchManagedPtr settings
    return ()

#if ENABLE_OVERLOADING
data SettingsSetZoomTextOnlyMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsSettings a) => O.MethodInfo SettingsSetZoomTextOnlyMethodInfo a signature where
    overloadedMethod _ = settingsSetZoomTextOnly

#endif

-- method Settings::font_size_to_pixels
-- method type : MemberFunction
-- Args : [Arg {argCName = "points", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the font size in points to convert to pixels", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt32)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_font_size_to_pixels" webkit_settings_font_size_to_pixels :: 
    Word32 ->                               -- points : TBasicType TUInt32
    IO Word32

{- |
Convert /@points@/ to the equivalent value in pixels, based on the current
screen DPI. Applications can use this function to convert font size values
in points to font size values in pixels when setting the font size properties
of 'GI.WebKit2.Objects.Settings.Settings'.

/Since: 2.20/
-}
settingsFontSizeToPixels ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    Word32
    {- ^ /@points@/: the font size in points to convert to pixels -}
    -> m Word32
    {- ^ __Returns:__ the equivalent font size in pixels. -}
settingsFontSizeToPixels points = liftIO $ do
    result <- webkit_settings_font_size_to_pixels points
    return result

#if ENABLE_OVERLOADING
#endif

-- method Settings::font_size_to_points
-- method type : MemberFunction
-- Args : [Arg {argCName = "pixels", argType = TBasicType TUInt32, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the font size in pixels to convert to points", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt32)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_settings_font_size_to_points" webkit_settings_font_size_to_points :: 
    Word32 ->                               -- pixels : TBasicType TUInt32
    IO Word32

{- |
Convert /@pixels@/ to the equivalent value in points, based on the current
screen DPI. Applications can use this function to convert font size values
in pixels to font size values in points when getting the font size properties
of 'GI.WebKit2.Objects.Settings.Settings'.

/Since: 2.20/
-}
settingsFontSizeToPoints ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    Word32
    {- ^ /@pixels@/: the font size in pixels to convert to points -}
    -> m Word32
    {- ^ __Returns:__ the equivalent font size in points. -}
settingsFontSizeToPoints pixels = liftIO $ do
    result <- webkit_settings_font_size_to_points pixels
    return result

#if ENABLE_OVERLOADING
#endif


